//======================================================================
///\file TXMIndex.h
//
// (C) Copyright IBM Corp. 2013  All Rights Reserved.
//======================================================================

#ifndef TXMIndexTemplate_H_
#define TXMIndexTemplate_H_

template <typename T> class TXMIndexTemplate {
public:
    typedef T value_type;

    explicit TXMIndexTemplate() {}
    explicit TXMIndexTemplate(value_type index) { value = index; }

    value_type val() const { return value; }

    TXMIndexTemplate& operator += (value_type inc) { value +=inc; return *this; }
    TXMIndexTemplate& operator -= (value_type inc) { value -=inc; return *this; }
    // prefix operator
    TXMIndexTemplate& operator ++ () { ++value; return *this; }
    TXMIndexTemplate& operator -- () { --value; return *this; }
    // postfix operator
    TXMIndexTemplate operator ++ (int) { TXMIndexTemplate ret(*this); value++; return *this; }
    TXMIndexTemplate operator -- (int) { TXMIndexTemplate ret(*this); value--; return *this; }

    TXMIndexTemplate& operator = (const TXMIndexTemplate &other) { value = other.value; return *this; }
    bool operator == (const TXMIndexTemplate &other) const { return (value == other.value); }
    bool operator != (const TXMIndexTemplate &other) const { return (value != other.value); }
    bool operator <= (const TXMIndexTemplate &other) const { return (value <= other.value); }
    bool operator >= (const TXMIndexTemplate &other) const { return (value >= other.value); }
    bool operator < (const TXMIndexTemplate &other) const { return (value < other.value); }
    bool operator > (const TXMIndexTemplate &other) const { return (value > other.value); }
    bool operator / (const TXMIndexTemplate &other) const { return (value / other.value); }
    bool operator % (const TXMIndexTemplate &other) const { return (value % other.value); }
    bool operator * (const TXMIndexTemplate &other) const { return (value * other.value); }
    bool operator - (const TXMIndexTemplate &other) const { return (value - other.value); }
    bool operator + (const TXMIndexTemplate &other) const { return (value + other.value); }
protected:
    value_type value;

    TXMIndexTemplate& operator = (const value_type);
};

#endif /* TXMIndexTemplate_H_ */
