//======================================================================
///\file TXMTypes.h
//
// (C) Copyright IBM Corp. 2013  All Rights Reserved.
//======================================================================

// This class should only contain Transaction Manager types like transaction indices,
// tables indices and any other type that we may come up with in the future.

#ifndef TXMTYPES_H_
#define TXMTYPES_H_

#include "TXMIndex.h"

#if 0 // For TableIds indices
class TblIndex : public TXMIndexTemplate<int32> {
private:
    typedef TXMIndexTemplate<int32> inherited;
public:
    typedef inherited::value_type value_type;

    // Define default constants here.
//    static const value_type INVALID_INDEX = -1;
//    static const value_type UNKNOWN_INDEX = -2;

    // Overload constructors here.
//    TblIndex() : inherited(INVALID_INDEX) { }
//    TblIndex(value_type value) : inherited(value) { }
};
#endif

// Logical indexes into TXMgr transactions "array".
class TxIndex : public TXMIndexTemplate<int32> {
private:
    typedef TXMIndexTemplate<int32> inherited;
public:
    typedef inherited::value_type value_type;

    static const value_type INVALID_TXINDEX = -1;
    static const value_type UNKNOWN_TXINDEX = -2;
    static const value_type LOW_TXINDEX = 0;

    TxIndex() : inherited(INVALID_TXINDEX) { }
    TxIndex(value_type value) : inherited(value) { }

    bool isValid() const {
        return ((value != INVALID_TXINDEX) && (value != UNKNOWN_TXINDEX));
    }
};

// index is known to not exist / transaction not found / end of list.
const TxIndex TXINDEX_NONE = TxIndex(TxIndex::INVALID_TXINDEX);
// index is not known.
const TxIndex TXINDEX_UNKNOWN = TxIndex(TxIndex::UNKNOWN_TXINDEX);
// index is 0.
const TxIndex TXINDEX_LOW = TxIndex(TxIndex::LOW_TXINDEX);

#endif /* TXMTYPES_H_ */
