#ifndef clocks_H_INCLUDED
#define clocks_H_INCLUDED
// ____________________________________________________________________________
// ____________________________________________________________________________
//
// (C) Copyright IBM Corp. 2001, 2011  All Rights Reserved.
// ____________________________________________________________________________
//
// File:                clocks.h
//
// Description:
// ------------
// Contains very global clock definitions for use by C files.
//
// Design Notes:
// -------------
// ____________________________________________________________________________
// ____________________________________________________________________________
//
// Header files
//
#include "nzstd.h"
// ____________________________________________________________________________
// ____________________________________________________________________________
//
#ifdef __cplusplus
extern "C" {
#endif

#if (NZ_SPU_HW_REV == 7)
#include "nzclocks.h"
#endif

// ____________________________________________________________________________
// ____________________________________________________________________________
//
// Public Constants
//
// ____________________________________________________________________________
// ____________________________________________________________________________
//
// Public Objects
//
// (none)
// ____________________________________________________________________________
// ____________________________________________________________________________
//
// Public functions (prototyped here only)
//
uint64 clkReturnTimebaseCounter(void);
uint32 clkReturnTimebaseCounterLow(void);
void   clkClearTimebaseCounter(void);
void   clkInitClocks(void);
uint64 clkTimebaseTicksToSec(uint64 tbTicks);
uint64 clkTimebaseTicksToMsec(uint64 tbTicks);
uint64 clkTimebaseTicksToUsec(uint64 tbTicks);
void   clkTimebaseTicksToHrMinSec(uint64 tbTicks, int *pHours, int *pMinutes, int *pSeconds);
uint64 clkCalcTimeBaseDelta(uint64 tbTicksRef);
uint64 clkCalcTimeBaseDeltaSec(uint64 tbTicksRef);
uint64 clkCalcTimeBaseDeltaMsec(uint64 tbTicksRef);
uint64 clkCalcTimeBaseDeltaUsec(uint64 tbTicksRef);
uint32 clkGetTimebaseTicksPerSec(void);
uint32 clkGetTimebaseTicksPerMsec(void);
uint32 clkGetTimebaseTicksPerUsec(void);
uint32 clkGetHwTicksPerOsTick(void);
// ____________________________________________________________________________
// ____________________________________________________________________________
//
// Public (Global) variables ('clk' prefix)
//
// (none)
// ____________________________________________________________________________
//

#ifdef __cplusplus
}
#endif

#endif // clocks_H_INCLUDED
