extern "C" {
    void overflow_32_ctor() __attribute__((noreturn));
    void overflow_64_ctor() __attribute__((noreturn));
    void overflow_8_arith() __attribute__((noreturn));
    void overflow_16_arith() __attribute__((noreturn));
    void overflow_32_arith() __attribute__((noreturn));
    void overflow_64_arith() __attribute__((noreturn));
    void overflow_128_arith() __attribute__((noreturn));
    void divByZeroError(void) __attribute__((noreturn));
    void numericDataSizeError(void) __attribute__((noreturn));
    int throwError(int code, const char *buf, const char *obj) __attribute__((noreturn));
}
class CNumeric128;
typedef int32 NumericDigit;
struct int64_signed_halves { int32 hi32; int32 lo32; };
struct int64_unsigned_halves { uint32 hi32; uint32 lo32; };
struct int128_signed_quarters { int32 hi32; int32 hl32; int32 lh32; int32 lo32; };
struct int128_unsigned_quarters { uint32 hi32; uint32 hl32; uint32 lh32; uint32 lo32; };
struct CNumeric32 {
    union {
        NumericDigit digit[1];
        int32 full32;
    };
    int i_sizeInInts() const;
    NumericDigit* i_internal() const;
    int32 getI32() const;
    int64 getI64() const;
    operator int32() const;
    CNumeric32(void);
    explicit CNumeric32(int32 val);
    explicit CNumeric32(int64 val);
    CNumeric32(uint32 d0, uint32 d1,uint32 d2, uint32 d3);
    CNumeric32 const& operator = (int32 val);
    CNumeric32 const& operator = (int64 val);
    CNumeric32 const& operator = (CNumeric128 const&);
};
struct CNumeric64 {
    union {
    NumericDigit digit[2];
    int64_signed_halves ih;
    int64_unsigned_halves uh;
    };
    int i_sizeInInts() const;
    NumericDigit* i_internal() const;
    int32 getI32() const;
    int64 getI64() const;
    operator int64() const;
    CNumeric64(void);
    explicit CNumeric64(int32 val);
    explicit CNumeric64(int64 val);
    CNumeric64(uint32 d0, uint32 d1, uint32 d2, uint32 d3);
    CNumeric64 const& operator = (int32 val);
    CNumeric64 const& operator = (int64 val);
    CNumeric64 const& operator = (CNumeric128 const&);
};
struct CNumeric128 {
    union {
        NumericDigit digit[4];
        int128_signed_quarters iq;
        int128_unsigned_quarters uq;
    };
    int i_sizeInInts() const;
    NumericDigit* i_internal() const;
    bool inRangeI32() const;
    bool inRangeI64() const;
    int32 getI32() const;
    operator int32() const;
    int64 getI64() const;
    operator int64() const;
    uint64 getU64() const;
    operator uint64() const;
    int64 getHiI64() const;
    CNumeric128(void);
    explicit CNumeric128(int32 val);
    explicit CNumeric128(int64 val);
    CNumeric128(uint32 d0, uint32 d1, uint32 d2, uint32 d3);
    CNumeric128 const& operator = (int32 val);
    CNumeric128 const& operator = (int64 val);
    CNumeric128 const& operator = (CNumeric128 const& val);
};
inline int CNumeric32::i_sizeInInts() const { return 1; }
inline NumericDigit* CNumeric32::i_internal() const { return const_cast<NumericDigit*>(&digit[0]); }
inline int32 CNumeric32::getI32() const { return full32; }
inline int64 CNumeric32::getI64() const { return full32; }
inline CNumeric32::operator int32() const { return getI32(); }
inline CNumeric32::CNumeric32(void) {}
inline CNumeric32::CNumeric32(int32 val) : full32(val) {}
inline CNumeric32::CNumeric32(int64 val) : full32(val) {
    if ( (((signed)(full32))>>31) != ((int32)(((uint64)(val))>>32)) ) overflow_32_ctor();
}
inline CNumeric32::CNumeric32(uint32 d0, uint32 d1,uint32 d2, uint32 d3) : full32(d3) {
    uint32 sign = (((signed)(full32))>>31);
    if ( d0 != sign || d1 != sign || d2 != sign) overflow_32_ctor();
}
inline CNumeric32 const& CNumeric32::operator = (int32 val) { return *new(this) CNumeric32(val); }
inline CNumeric32 const& CNumeric32::operator = (int64 val) { return *new(this) CNumeric32(val); }
inline CNumeric32 const& CNumeric32::operator = (CNumeric128 const& cn128) {
    if ( ! cn128.inRangeI32() ) overflow_32_ctor();
    return *new(this) CNumeric32(cn128.getI32());
}
inline int CNumeric64::i_sizeInInts() const { return 2; }
inline NumericDigit* CNumeric64::i_internal() const { return const_cast<NumericDigit*>(&digit[0]); }
inline int32 CNumeric64::getI32() const { return ih.lo32; }
inline int64 CNumeric64::getI64() const { return (((uint64)uh.hi32)<<32) | uh.lo32; }
inline CNumeric64::operator int64() const { return getI64(); }
inline CNumeric64::CNumeric64(void) {}
inline CNumeric64::CNumeric64(int32 val) {
    ih.lo32 = val;
    ih.hi32 = (((signed)(val))>>31);
}
inline CNumeric64::CNumeric64(int64 val) {
    ih.lo32 = val;
    ih.hi32 = ((int32)(((uint64)(val))>>32));
}
inline CNumeric64::CNumeric64(uint32 d0, uint32 d1, uint32 d2, uint32 d3) {
    ih.lo32 = d3;
    ih.hi32 = d2;
    uint32 sign = (((signed)(d2))>>31);
    if ( d0 != sign || d1 != sign) overflow_64_ctor();
}
inline CNumeric64 const& CNumeric64::operator = (int32 val) { return *new(this) CNumeric64(val); }
inline CNumeric64 const& CNumeric64::operator = (int64 val) { return *new(this) CNumeric64(val); }
inline CNumeric64 const& CNumeric64::operator = (CNumeric128 const& cn128) {
    if ( ! cn128.inRangeI64() ) overflow_64_ctor();
    return *new(this) CNumeric64(cn128.getI64());
}
inline int CNumeric128::i_sizeInInts() const { return 4; }
inline NumericDigit* CNumeric128::i_internal() const { return const_cast<NumericDigit*>(&digit[0]); }
inline bool CNumeric128::inRangeI32() const {
    int sign = (((signed)(iq.lo32))>>31);
    return iq.hi32 == sign && iq.hl32 == sign && iq.lh32 == sign;
}
inline bool CNumeric128::inRangeI64() const {
    int sign = (((signed)(iq.lh32))>>31);
    return iq.hi32 == sign && iq.hl32 == sign;
}
inline int32 CNumeric128::getI32() const { return iq.lo32; }
inline CNumeric128::operator int32() const { return iq.lo32; }
inline int64 CNumeric128::getI64() const { return (((uint64)uq.lh32)<<32) | uq.lo32; }
inline CNumeric128::operator int64() const { return (((uint64)uq.lh32)<<32) | uq.lo32; }
inline uint64 CNumeric128::getU64() const { return (((uint64)uq.lh32)<<32) | uq.lo32; }
inline CNumeric128::operator uint64() const { return (((uint64)uq.lh32)<<32) | uq.lo32; }
inline int64 CNumeric128::getHiI64() const { return (((uint64)uq.hi32)<<32) | uq.hl32; }
inline CNumeric128::CNumeric128(void) {}
inline CNumeric128::CNumeric128(int32 val) {
    digit[3] = val;
    digit[0] = digit[1] = digit[2] = (((signed)(val))>>31);
}
inline CNumeric128::CNumeric128(int64 val) {
    digit[3] = val;
    int32 hi32 = ((int32)(((uint64)(val))>>32));
    digit[2] = hi32;
    digit[0] = digit[1] = (((signed)(hi32))>>31);
}
inline CNumeric128::CNumeric128(uint32 d0, uint32 d1, uint32 d2, uint32 d3) {
    digit[0] = d0;
    digit[1] = d1;
    digit[2] = d2;
    digit[3] = d3;
}
inline CNumeric128 const& CNumeric128::operator = (int32 val) { return *new(this) CNumeric128(val); }
inline CNumeric128 const& CNumeric128::operator = (int64 val) { return *new(this) CNumeric128(val); }
inline CNumeric128 const& CNumeric128::operator = (CNumeric128 const& val)
{
    void* xthis;
    void* xval;
 asm ("	cld\n"
     "	movsl\n"
     "	movsl\n"
     "	movsl\n"
     "	movsl\n"
 : [esi_out] "=S" (xval)
 , [edi_out] "=D" (xthis)
 , [mem_wrt] "=m" (*this)
 : [esi_in] "0" (&val)
 , [edi_in] "1" (this)
 , [mem_rd] "m" (val)
    );
    return *this;
}
inline int operator ! (CNumeric128 const& cn128) {
    return 0 == ( cn128.digit[0] | cn128.digit[1] | cn128.digit[2] | cn128.digit[3] );
}

inline static
 unsigned char operator == (CNumeric128 const& left, int32 right)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	cmpl	12+%[left],%[right]\n"
"	jne	1f\n"
"	cmpl	8+%[left],%[sign]\n"
"	jne	1f\n"
"	cmpl	4+%[left],%[sign]\n"
"	jne	1f\n"
"	cmpl	%[left],%[sign]\n"
"1:\n"
"	setzb	%[result]\n"
 : [result] "=q" (result)
 , [sign] "=&d" (sign)
 : [left] "o" (left)
 , [right] "a" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char EQ (CNumeric128 const& left, int32 rightHi, uint32 rightLo)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	cmpl	12+%[left],%[rightLo]\n"
"	jne	1f\n"
"	cmpl	8+%[left],%[rightHi]\n"
"	jne	1f\n"
"	cmpl	4+%[left],%[sign]\n"
"	jne	1f\n"
"	cmpl	%[left],%[sign]\n"
"1:\n"
"	setzb	%[result]\n"
 : [result] "=q" (result)
 , [sign] "=&d" (sign)
 : [left] "o" (left)
 , [rightHi] "a" (rightHi)
 , [rightLo] "r" (rightLo)
 : "cc"
);
 return result;
}

inline static unsigned char operator == (CNumeric128 const& left, int64 right)
{ return EQ(left, ((int32)(((uint64)(right))>>32)), (uint32)right); }

inline static
 unsigned char operator == (CNumeric128 const& left, CNumeric128 const& right)
{
int temp __attribute__((unused));
unsigned char result;
void* xleft __attribute__((unused));
void* xright __attribute__((unused));
 asm(
"	repz\n"
"	cmpsl\n"
"	setzb	%[result]\n"
 : [result] "=q" (result)
 , [esi] "=%S" (xleft)
 , [edi] "=D" (xright)
 , [ecx] "=c" (temp)
 : [esi_] "[esi]" (&left)
 , [edi_] "[edi]" (&right)
 , [ecx_] "[ecx]" (4)
 , [left_mem] "m" (left)
 , [right_mem] "m" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char operator != (CNumeric128 const& left, int32 right)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	cmpl	12+%[left],%[right]\n"
"	jne	1f\n"
"	cmpl	8+%[left],%[sign]\n"
"	jne	1f\n"
"	cmpl	4+%[left],%[sign]\n"
"	jne	1f\n"
"	cmpl	%[left],%[sign]\n"
"1:\n"
"	setnzb	%[result]\n"
 : [result] "=q" (result)
 , [sign] "=&d" (sign)
 : [left] "o" (left)
 , [right] "a" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char NE (CNumeric128 const& left, int32 rightHi, uint32 rightLo)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	cmpl	12+%[left],%[rightLo]\n"
"	jne	1f\n"
"	cmpl	8+%[left],%[rightHi]\n"
"	jne	1f\n"
"	cmpl	4+%[left],%[sign]\n"
"	jne	1f\n"
"	cmpl	%[left],%[sign]\n"
"1:\n"
"	setnzb	%[result]\n"
 : [result] "=q" (result)
 , [sign] "=&d" (sign)
 : [left] "o" (left)
 , [rightHi] "a" (rightHi)
 , [rightLo] "r" (rightLo)
 : "cc"
);
 return result;
}

inline static unsigned char operator != (CNumeric128 const& left, int64 right)
{ return NE(left, ((int32)(((uint64)(right))>>32)), (uint32)right); }

inline static
 unsigned char operator != (CNumeric128 const& left, CNumeric128 const& right)
{
int temp __attribute__((unused));
unsigned char result;
void* xleft __attribute__((unused));
void* xright __attribute__((unused));
 asm(
"	repz\n"
"	cmpsl\n"
"	setnzb	%[result]\n"
 : [result] "=q" (result)
 , [esi] "=%S" (xleft)
 , [edi] "=D" (xright)
 , [ecx] "=c" (temp)
 : [esi_] "[esi]" (&left)
 , [edi_] "[edi]" (&right)
 , [ecx_] "[ecx]" (4)
 , [left_mem] "m" (left)
 , [right_mem] "m" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char operator < (CNumeric128 const& left, int32 right)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	cmpl	%[right],12+%[left]\n"
"	movl	8+%[left],%%eax\n"
"	sbbl	%[sign],%%eax\n"
"	movl	4+%[left],%%eax\n"
"	sbbl	%[sign],%%eax\n"
"	movl	%[left],%%eax\n"
"	sbbl	%[sign],%%eax\n"
"	setlb	%[result]\n"
 : [result] "=a" (result)
 , [sign] "=&d" (sign)
 : [left] "o" (left)
 , [right] "a" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char LT (CNumeric128 const& left, int32 rightHi, uint32 rightLo)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	cmpl	%[rightLo],12+%[left]\n"
"	movl	8+%[left],%[rightLo]\n"
"	sbbl	%[rightHi],%[rightLo]\n"
"	movl	4+%[left],%[rightLo]\n"
"	sbbl	%[sign],%[rightLo]\n"
"	movl	%[left],%[rightLo]\n"
"	sbbl	%[sign],%[rightLo]\n"
"	setlb	%[result]\n"
 : [result] "=q" (result)
 , [sign] "=&d" (sign)
 , [rightLo] "+&r" (rightLo)
 : [left] "o" (left)
 , [rightHi] "a" (rightHi)
 : "cc"
);
 return result;
}

inline static unsigned char operator < (CNumeric128 const& left, int64 right)
{ return LT(left, ((int32)(((uint64)(right))>>32)), (uint32)right); }

inline static
 unsigned char operator < (CNumeric128 const& left, CNumeric128 const& right)
{
int temp __attribute__((unused));
unsigned char result;
 asm(
"	movl	12+%[left],%[temp]\n"
"	subl	12+%[right],%[temp]\n"
"	movl	8+%[left],%[temp]\n"
"	sbbl	8+%[right],%[temp]\n"
"	movl	4+%[left],%[temp]\n"
"	sbbl	4+%[right],%[temp]\n"
"	movl	%[left],%[temp]\n"
"	sbbl	%[right],%[temp]\n"
"	setlb	%[result]\n"
 : [result] "=q" (result)
 , [temp] "=&r" (temp)
 : [left] "o" (left)
 , [right] "o" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char operator <= (CNumeric128 const& left, int32 right)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	subl	12+%[left],%[right]\n"
"	movl	%[sign],%%eax\n"
"	sbbl	8+%[left],%%eax\n"
"	movl	%[sign],%%eax\n"
"	sbbl	4+%[left],%%eax\n"
"	sbbl	%[left],%[sign]\n"
"	setgeb	%[result]\n"
 : [result] "=a" (result)
 , [sign] "=&d" (sign)
 : [left] "o" (left)
 , [right] "a" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char LE (CNumeric128 const& left, int32 rightHi, uint32 rightLo)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	subl	12+%[left],%[rightLo]\n"
"	sbbl	8+%[left],%[rightHi]\n"
"	movl	%[sign],%[rightLo]\n"
"	sbbl	4+%[left],%[rightLo]\n"
"	sbbl	%[left],%[sign]\n"
"	setgeb	%[result]\n"
 : [result] "=q" (result)
 , [sign] "=&d" (sign)
 , [rightLo] "+&r" (rightLo)
 , [rightHi] "+&a" (rightHi)
 : [left] "o" (left)
 : "cc"
);
 return result;
}

inline static unsigned char operator <= (CNumeric128 const& left, int64 right)
{ return LE(left, ((int32)(((uint64)(right))>>32)), (uint32)right); }

inline static
 unsigned char operator <= (CNumeric128 const& left, CNumeric128 const& right)
{
int temp __attribute__((unused));
unsigned char result;
 asm(
"	movl	12+%[right],%[temp]\n"
"	subl	12+%[left],%[temp]\n"
"	movl	8+%[right],%[temp]\n"
"	sbbl	8+%[left],%[temp]\n"
"	movl	4+%[right],%[temp]\n"
"	sbbl	4+%[left],%[temp]\n"
"	movl	%[right],%[temp]\n"
"	sbbl	%[left],%[temp]\n"
"	setgeb	%[result]\n"
 : [result] "=q" (result)
 , [temp] "=&r" (temp)
 : [left] "o" (left)
 , [right] "o" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char operator >= (CNumeric128 const& left, int32 right)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	cmpl	%[right],12+%[left]\n"
"	movl	8+%[left],%%eax\n"
"	sbbl	%[sign],%%eax\n"
"	movl	4+%[left],%%eax\n"
"	sbbl	%[sign],%%eax\n"
"	movl	%[left],%%eax\n"
"	sbbl	%[sign],%%eax\n"
"	setgeb	%[result]\n"
 : [result] "=a" (result)
 , [sign] "=&d" (sign)
 : [left] "o" (left)
 , [right] "a" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char GE (CNumeric128 const& left, int32 rightHi, uint32 rightLo)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	cmpl	%[rightLo],12+%[left]\n"
"	movl	8+%[left],%[rightLo]\n"
"	sbbl	%[rightHi],%[rightLo]\n"
"	movl	4+%[left],%[rightLo]\n"
"	sbbl	%[sign],%[rightLo]\n"
"	movl	%[left],%[rightLo]\n"
"	sbbl	%[sign],%[rightLo]\n"
"	setgeb	%[result]\n"
 : [result] "=q" (result)
 , [sign] "=&d" (sign)
 , [rightLo] "+&r" (rightLo)
 : [left] "o" (left)
 , [rightHi] "a" (rightHi)
 : "cc"
);
 return result;
}

inline static unsigned char operator >= (CNumeric128 const& left, int64 right)
{ return GE(left, ((int32)(((uint64)(right))>>32)), (uint32)right); }

inline static
 unsigned char operator >= (CNumeric128 const& left, CNumeric128 const& right)
{
int temp __attribute__((unused));
unsigned char result;
 asm(
"	movl	12+%[left],%[temp]\n"
"	subl	12+%[right],%[temp]\n"
"	movl	8+%[left],%[temp]\n"
"	sbbl	8+%[right],%[temp]\n"
"	movl	4+%[left],%[temp]\n"
"	sbbl	4+%[right],%[temp]\n"
"	movl	%[left],%[temp]\n"
"	sbbl	%[right],%[temp]\n"
"	setgeb	%[result]\n"
 : [result] "=q" (result)
 , [temp] "=&r" (temp)
 : [left] "o" (left)
 , [right] "o" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char operator > (CNumeric128 const& left, int32 right)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	subl	12+%[left],%[right]\n"
"	movl	%[sign],%%eax\n"
"	sbbl	8+%[left],%%eax\n"
"	movl	%[sign],%%eax\n"
"	sbbl	4+%[left],%%eax\n"
"	sbbl	%[left],%[sign]\n"
"	setlb	%[result]\n"
 : [result] "=a" (result)
 , [sign] "=&d" (sign)
 : [left] "o" (left)
 , [right] "a" (right)
 : "cc"
);
 return result;
}


inline static
 unsigned char GT (CNumeric128 const& left, int32 rightHi, uint32 rightLo)
{
int sign __attribute__((unused));
unsigned char result;
 asm(
"	cltd\n"
"	subl	12+%[left],%[rightLo]\n"
"	sbbl	8+%[left],%[rightHi]\n"
"	movl	%[sign],%[rightLo]\n"
"	sbbl	4+%[left],%[rightLo]\n"
"	sbbl	%[left],%[sign]\n"
"	setlb	%[result]\n"
 : [result] "=q" (result)
 , [sign] "=&d" (sign)
 , [rightLo] "+&r" (rightLo)
 , [rightHi] "+&a" (rightHi)
 : [left] "o" (left)
 : "cc"
);
 return result;
}

inline static unsigned char operator > (CNumeric128 const& left, int64 right)
{ return GT(left, ((int32)(((uint64)(right))>>32)), (uint32)right); }

inline static
 unsigned char operator > (CNumeric128 const& left, CNumeric128 const& right)
{
int temp __attribute__((unused));
unsigned char result;
 asm(
"	movl	12+%[right],%[temp]\n"
"	subl	12+%[left],%[temp]\n"
"	movl	8+%[right],%[temp]\n"
"	sbbl	8+%[left],%[temp]\n"
"	movl	4+%[right],%[temp]\n"
"	sbbl	4+%[left],%[temp]\n"
"	movl	%[right],%[temp]\n"
"	sbbl	%[left],%[temp]\n"
"	setlb	%[result]\n"
 : [result] "=q" (result)
 , [temp] "=&r" (temp)
 : [left] "o" (left)
 , [right] "o" (right)
 : "cc"
);
 return result;
}


inline static
CNumeric128 operator + (CNumeric128 const& left, int32 right)
{
int sign __attribute__((unused));
int hi;
unsigned hl;
unsigned lh;
unsigned lo;
unsigned char ovf;
 asm(
"	cltd\n"
"	addl	12+%[left],%[lo]\n"
"	movl	%[lh],%[hl]\n"
"	adcl	8+%[left],%[lh]\n"
"	movl	%[hl],%[hi]\n"
"	adcl	4+%[left],%[hl]\n"
"	adcl	%[left],%[hi]\n"
"	setob	%[ovf]\n"
 : [lo] "=a" (lo)
 , [lh] "=&d" (lh)
 , [hl] "=&r" (hl)
 , [hi] "=&r" (hi)
 , [ovf] "=qQm" (ovf)
 : [left] "o" (left)
 , [right] "[lo]" (right)
 : "cc"
);
 if (ovf) overflow_128_arith();
 return CNumeric128(hi,hl,lh,lo);
}


inline static
CNumeric128 ADD (CNumeric128 const& left, int32 rightHi, uint32 rightLo)
{
int sign __attribute__((unused));
int hi;
unsigned hl;
unsigned lh;
unsigned lo;
unsigned char ovf;
 asm (
"	addl	12+%[left],%[lo]\n"
"	cltd\n"
"	adcl	8+%[left],%[lh]\n"
"	movl	%[hl],%[hi]\n"
"	adcl	4+%[left],%[hl]\n"
"	adcl	%[left],%[hi]\n"
"	setob	%[ovf]\n"
 : [lo] "=r" (lo)
 , [lh] "=a" (lh)
 , [hl] "=&d" (hl)
 , [hi] "=&r" (hi)
 , [ovf] "=qQm" (ovf)
 : [left] "o" (left)
 , [rightLo] "[lo]" (rightLo)
 , [rightHi] "[lh]" (rightHi)
 : "cc"
);
 if (ovf) overflow_128_arith();
 return CNumeric128(hi,hl,lh,lo);
}

inline static CNumeric128 operator + (CNumeric128 const& left, int64 right)
{ return ADD(left, ((int32)(((uint64)(right))>>32)), (uint32)right); }

inline static
CNumeric128 operator + (CNumeric128 const& left, CNumeric128 const& right)
{
int hi;
unsigned hl;
unsigned lh;
unsigned lo;
unsigned char ovf;
asm (
"	movl	12+(%[left]),%[lo]\n"
"	movl	8+(%[left]),%[lh]\n"
"	movl	4+(%[left]),%[hl]\n"
"	movl	(%[left]),%[hi]\n"
"	addl	12+(%[right]),%[lo]\n"
"	adcl	8+(%[right]),%[lh]\n"
"	adcl	4+(%[right]),%[hl]\n"
"	adcl	(%[right]),%[hi]\n"
"	setob	%[ovf]\n"
 : [lo] "=&r" (lo)
 , [lh] "=&r" (lh)
 , [hl] "=&r" (hl)
 , [hi] "=r" (hi)
 , [ovf] "=a" (ovf)
 : [left] "[hi]" (&left)
 , [right] "a" (&right)
 : "cc"
);
 if (ovf) overflow_128_arith();
 return CNumeric128(hi,hl,lh,lo);
}


inline static
CNumeric128 operator - (CNumeric128 const& left, CNumeric128 const& right)
{
int hi;
unsigned hl;
unsigned lh;
unsigned lo;
unsigned char ovf;
asm (
"	movl	12+(%[left]),%[lo]\n"
"	movl	8+(%[left]),%[lh]\n"
"	movl	4+(%[left]),%[hl]\n"
"	movl	(%[left]),%[hi]\n"
"	subl	12+(%[right]),%[lo]\n"
"	sbbl	8+(%[right]),%[lh]\n"
"	sbbl	4+(%[right]),%[hl]\n"
"	sbbl	(%[right]),%[hi]\n"
"	setob	%[ovf]\n"
 : [lo] "=&r" (lo)
 , [lh] "=&r" (lh)
 , [hl] "=&r" (hl)
 , [hi] "=r" (hi)
 , [ovf] "=a" (ovf)
 : [left] "[hi]" (&left)
 , [right] "a" (&right)
 : "cc"
);
 if (ovf) overflow_128_arith();
 return CNumeric128(hi,hl,lh,lo);
}


inline static
CNumeric128 operator - (CNumeric128 const& left, int32 right)
{
int sign __attribute__((unused));
int hi;
unsigned hl;
unsigned lh;
unsigned lo;
unsigned char ovf;
 asm(
"	cltd\n"
"	movl	12+(%[left]),%[lo]\n"
"	subl	%[right],%[lo]\n"
"	movl	8+(%[left]),%[lh]\n"
"	sbbl	%[sign],%[lh]\n"
"	movl	4+(%[left]),%[hl]\n"
"	sbbl	%[sign],%[hl]\n"
"	movl	(%[left]),%[hi]\n"
"	sbbl	%[sign],%[hi]\n"
"	setob	%[ovf]\n"
 : [lo] "=&r" (lo)
 , [lh] "=a" (lh)
 , [hl] "=&r" (hl)
 , [hi] "=r" (hi)
 , [sign] "=&d" (sign)
 , [ovf] "=qQm" (ovf)
 : [right] "[lh]" (right)
 , [left] "[hi]" (&left)
 : "cc"
);
 if (ovf) overflow_128_arith();
 return CNumeric128(hi,hl,lh,lo);
}


inline static
CNumeric128 SUB (CNumeric128 const& left, int32 rightHi, uint32 rightLo)
{
int sign __attribute__((unused));
int hi;
unsigned hl;
unsigned lh;
unsigned lo;
unsigned char ovf;
 asm(
"	cltd\n"
"	movl	12+(%[left]),%[lo]\n"
"	subl	%[rightLo],%[lo]\n"
"	movl	8+(%[left]),%[lh]\n"
"	sbbl	%[rightHi],%[lh]\n"
"	movl	4+(%[left]),%[hl]\n"
"	sbbl	%[sign],%[hl]\n"
"	movl	(%[left]),%[hi]\n"
"	sbbl	%[sign],%[hi]\n"
"	setob	%[ovf]\n"
 : [lo] "=&r" (lo)
 , [lh] "=r" (lh)
 , [hl] "=a" (hl)
 , [hi] "=r" (hi)
 , [sign] "=&d" (sign)
 , [ovf] "=qQm" (ovf)
 : [left] "[hi]" (&left)
 , [rightLo] "[lh]" (rightLo)
 , [rightHi] "[hl]" (rightHi)
 : "cc"
);
 if (ovf) overflow_128_arith();
 return CNumeric128(hi,hl,lh,lo);
}

inline static CNumeric128 operator - (CNumeric128 const& left, int64 right)
{ return SUB(left, ((int32)(((uint64)(right))>>32)), (uint32)right); }

inline static
CNumeric128 operator - (int32 left, CNumeric128 const& right)
{
int sign __attribute__((unused));
int hi;
unsigned hl;
unsigned lh;
unsigned lo;
unsigned char ovf;
 asm(
"	cltd\n"
"	subl	12+%[right],%[lo]\n"
"	movl	%[lh],%[hl]\n"
"	sbbl	8+%[right],%[lh]\n"
"	movl	%[hl],%[hi]\n"
"	sbbl	4+%[right],%[hl]\n"
"	sbbl	%[right],%[hi]\n"
"	setob	%[ovf]\n"
 : [lo] "=a" (lo)
 , [lh] "=&d" (lh)
 , [hl] "=&r" (hl)
 , [hi] "=&r" (hi)
 , [ovf] "=qQm" (ovf)
 : [left] "[lo]" (left)
 , [right] "o" (right)
 : "cc"
);
 if (ovf) overflow_128_arith();
 return CNumeric128(hi,hl,lh,lo);
}


inline static
CNumeric128 SUBF (int32 leftHi, uint32 leftLo, CNumeric128 const& right)
{
int sign __attribute__((unused));
int hi;
unsigned hl;
unsigned lh;
unsigned lo;
unsigned char ovf;
 asm(
"	subl	12+%[right],%[lo]\n"
"	cltd\n"
"	sbbl	8+%[right],%[lh]\n"
"	movl	%[hl],%[hi]\n"
"	sbbl	4+%[right],%[hl]\n"
"	sbbl	%[right],%[hi]\n"
"	setob	%[ovf]\n"
 : [lo] "=r" (lo)
 , [lh] "=a" (lh)
 , [hl] "=&d" (hl)
 , [hi] "=&r" (hi)
 , [ovf] "=qQm" (ovf)
 : [leftLo] "[lo]" (leftLo)
 , [leftHi] "[lh]" (leftHi)
 , [right] "o" (right)
 : "cc"
);
 if (ovf) overflow_128_arith();
 return CNumeric128(hi,hl,lh,lo);
}

inline static CNumeric128 operator - (int64 left, CNumeric128 const& right)
{
    return SUBF(((int32)(((uint64)(left))>>32)), (uint32)left, right);
}
inline static CNumeric128 operator - (CNumeric128 const& val) {
 int hi;
unsigned hl;
unsigned lh;
unsigned lo;
unsigned char ovf;
 asm (
"	xorl	%[lo],%[lo]\n"
"	xorl	%[lh],%[lh]\n"
"	xorl	%[hl],%[hl]\n"
"	xorl	%[hi],%[hi]\n"
"	subl	12+%[val],%[lo]\n"
"	sbbl	8+%[val],%[lh]\n"
"	sbbl	4+%[val],%[hl]\n"
"	sbbl	%[val],%[hi]\n"
"	setob	%[ovf]\n"
 : [lo] "=&r" (lo)
 , [lh] "=&r" (lh)
 , [hl] "=&r" (hl)
 , [hi] "=&r" (hi)
 , [ovf] "=qQm" (ovf)
 : [val] "o" (val)
 : "cc"
   );
    if (ovf) overflow_128_arith();
    return CNumeric128(hi,hl,lh,lo);
}
static inline void operator += (CNumeric64& lhs, int32 rval) {
 unsigned char ovf;
 int sign;
 asm (
"	cltd\n"
"	addl	%[rval],4+%[lhs]\n"
"	adcl	%[sign],0+%[lhs]\n"
"	setob	%[ovf]\n"
 : [sign] "=&d" (sign)
 , [lhs] "+o" (lhs)
 , [ovf] "=qQm" (ovf)
 : [rval] "a" (rval)
 : "cc"
   );
    if (ovf) overflow_64_arith();
}
static inline void ACCUMULATE64(CNumeric64& lhs, int32 rvalHi, int32 rvalLo) {
    unsigned char ovf;
 asm (
"	addl	%[rvalLo],4+%[lhs]\n"
"	adcl	%[rvalHi],0+%[lhs]\n"
"	setob	%[ovf]\n"
 : [lhs] "+o" (lhs)
 , [ovf] "=qQm" (ovf)
 : [rvalHi] "r" (rvalHi)
 , [rvalLo] "r" (rvalLo)
 : "cc"
   );
    if (ovf) overflow_64_arith();
}
static inline void operator += (CNumeric64& lhs, int64 rval) {
    ACCUMULATE64(lhs, ((int32)(((uint64)(rval))>>32)), (uint32)rval);
}
static inline void operator += (CNumeric128& lhs, int32 rval) {
    unsigned char ovf;
    int sign;
 asm (
"	cltd\n"
"	addl	%[rval],12+%[lhs]\n"
"	adcl	%[sign],8+%[lhs]\n"
"	adcl	%[sign],4+%[lhs]\n"
"	adcl	%[sign],%[lhs]\n"
"	setob	%[ovf]\n"
 : [sign] "=&d" (sign)
 , [lhs] "+o" (lhs)
 , [ovf] "=qQm" (ovf)
 : [rval] "a" (rval)
 : "cc"
   );
    if (ovf) overflow_128_arith();
}
static inline void ACCUMULATE128(CNumeric128& lhs, int32 rvalHi, int32 rvalLo) {
    unsigned char ovf;
    int sign;
 asm (
"	cltd\n"
"	addl	%[rvalLo],12+%[lhs]\n"
"	adcl	%[rvalHi],8+%[lhs]\n"
"	adcl	%[sign],4+%[lhs]\n"
"	adcl	%[sign],%[lhs]\n"
"	setob	%[ovf]\n"
 : [sign] "=&d" (sign)
 , [lhs] "+o" (lhs)
 , [ovf] "=qQm" (ovf)
 : [rvalLo] "r" (rvalLo)
 , [rvalHi] "a" (rvalHi)
 : "cc"
   );
    if (ovf) overflow_128_arith();
}
static inline void operator += (CNumeric128& lhs, int64 rval) {
    ACCUMULATE128(lhs, ((int32)(((uint64)(rval))>>32)), (uint32)rval);
}
static inline void operator += (CNumeric128& lhs, CNumeric128 const& rval) {
    unsigned char ovf;
    int32 temp;
 asm (
"	movl	12+%[rval],%[temp]\n"
"	addl	%[temp],12+%[lhs]\n"
"	movl	8+%[rval],%[temp]\n"
"	adcl	%[temp],8+%[lhs]\n"
"	movl	4+%[rval],%[temp]\n"
"	adcl	%[temp],4+%[lhs]\n"
"	movl	%[rval],%[temp]\n"
"	adcl	%[temp],%[lhs]\n"
"	setob	%[ovf]\n"
 : [lhs] "+o" (lhs)
 , [temp] "=&r" (temp)
 , [ovf] "=qQm" (ovf)
 : [rval] "o" (rval)
 : "cc"
   );
    if (ovf) overflow_128_arith();
}
inline static CNumeric128 const& operator + (CNumeric128 const& val) { return val; }
inline static unsigned char operator == (int32 ival, CNumeric128 const& cn128) { return cn128 == ival; }
inline static unsigned char operator == (int64 ival, CNumeric128 const& cn128) { return cn128 == ival; }
inline static unsigned char operator != (int32 ival, CNumeric128 const& cn128) { return cn128 != ival; }
inline static unsigned char operator != (int64 ival, CNumeric128 const& cn128) { return cn128 != ival; }
inline static unsigned char operator < (int32 ival, CNumeric128 const& cn128) { return cn128 > ival; }
inline static unsigned char operator < (int64 ival, CNumeric128 const& cn128) { return cn128 > ival; }
inline static unsigned char operator > (int32 ival, CNumeric128 const& cn128) { return cn128 < ival; }
inline static unsigned char operator > (int64 ival, CNumeric128 const& cn128) { return cn128 < ival; }
inline static unsigned char operator <= (int32 ival, CNumeric128 const& cn128) { return cn128 >= ival; }
inline static unsigned char operator <= (int64 ival, CNumeric128 const& cn128) { return cn128 >= ival; }
inline static unsigned char operator >= (int32 ival, CNumeric128 const& cn128) { return cn128 <= ival; }
inline static unsigned char operator >= (int64 ival, CNumeric128 const& cn128) { return cn128 <= ival; }
inline static CNumeric128 operator + (int32 ival, CNumeric128 const& cn128) { return cn128 + ival; }
inline static CNumeric128 operator + (int64 ival, CNumeric128 const& cn128) { return cn128 + ival; }
extern "C" {
    bool mul_128(CNumeric128 const& var1P, CNumeric128 const& var2P, CNumeric128& product);
}

inline static CNumeric128 operator * (CNumeric128 const& left, CNumeric128 const& right) {
 CNumeric128 product;
 if ( mul_128(left,right,product) ) overflow_128_arith();
 return product;
}


inline static CNumeric128 operator * (CNumeric128 const& left, int32 right) {
 CNumeric128 product;
 if ( mul_128(left,CNumeric128(right),product) ) overflow_128_arith();
 return product;
}


inline static CNumeric128 operator * (CNumeric128 const& left, int64 right) {
 CNumeric128 product;
 if ( mul_128(left,CNumeric128(right),product) ) overflow_128_arith();
 return product;
}


inline static CNumeric128 operator * (int32 left, CNumeric128 const& right) {
 CNumeric128 product;
 if ( mul_128(CNumeric128(left),right,product) ) overflow_128_arith();
 return product;
}


inline static CNumeric128 operator * (int64 left, CNumeric128 const& right) {
 CNumeric128 product;
 if ( mul_128(CNumeric128(left),right,product) ) overflow_128_arith();
 return product;
}

static int const DR128_REMAINDER = 0;
static int const DR128_QUOTIENT = 1;
static int const DR128_ROUNDED_QUOTIENT = 2;
class CNumeric128;
extern "C"
void dr128(CNumeric128 & result,
           CNumeric128 const & dividend,
           CNumeric128 const & divisor,
           unsigned int flags);
extern "C"
int64_t nz_mul8(int64_t a,
                int64_t b);

inline static CNumeric128 operator %(CNumeric128 const& left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, left, right, DR128_REMAINDER);
 return result;
}

inline static int32 operator %(CNumeric128 const& left, int32 right) {
 CNumeric128 result;
 dr128(result, left, CNumeric128(right), DR128_REMAINDER);
 return result.getI32();
}

inline static int64 operator %(CNumeric128 const& left, int64 right) {
 CNumeric128 result;
 dr128(result, left, CNumeric128(right), DR128_REMAINDER);
 return result.getI64();
}

inline static CNumeric128 operator %(int32 left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, CNumeric128(left), right, DR128_REMAINDER);
 return result;
}

inline static CNumeric128 operator %(int64 left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, CNumeric128(left), right, DR128_REMAINDER);
 return result;
}


inline static CNumeric128 operator /(CNumeric128 const& left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, left, right, DR128_QUOTIENT);
 return result;
}

inline static CNumeric128 operator /(CNumeric128 const& left, int32 right) {
 CNumeric128 result;
 dr128(result, left, CNumeric128(right), DR128_QUOTIENT);
 return result;
}

inline static CNumeric128 operator /(CNumeric128 const& left, int64 right) {
 CNumeric128 result;
 dr128(result, left, CNumeric128(right), DR128_QUOTIENT);
 return result;
}

inline static CNumeric128 operator /(int32 left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, CNumeric128(left), right, DR128_QUOTIENT);
 return result;
}

inline static CNumeric128 operator /(int64 left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, CNumeric128(left), right, DR128_QUOTIENT);
 return result;
}


inline static CNumeric128 rdiv(CNumeric128 const& left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, left, right, DR128_ROUNDED_QUOTIENT);
 return result;
}

inline static CNumeric128 rdiv(CNumeric128 const& left, int32 right) {
 CNumeric128 result;
 dr128(result, left, CNumeric128(right), DR128_ROUNDED_QUOTIENT);
 return result;
}

inline static CNumeric128 rdiv(CNumeric128 const& left, int64 right) {
 CNumeric128 result;
 dr128(result, left, CNumeric128(right), DR128_ROUNDED_QUOTIENT);
 return result;
}

inline static CNumeric128 rdiv(int32 left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, CNumeric128(left), right, DR128_ROUNDED_QUOTIENT);
 return result;
}

inline static CNumeric128 rdiv(int64 left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, CNumeric128(left), right, DR128_ROUNDED_QUOTIENT);
 return result;
}


inline static CNumeric128 idiv(CNumeric128 const& left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, left, right, DR128_QUOTIENT);
 return result;
}

inline static CNumeric128 idiv(CNumeric128 const& left, int32 right) {
 CNumeric128 result;
 dr128(result, left, CNumeric128(right), DR128_QUOTIENT);
 return result;
}

inline static CNumeric128 idiv(CNumeric128 const& left, int64 right) {
 CNumeric128 result;
 dr128(result, left, CNumeric128(right), DR128_QUOTIENT);
 return result;
}

inline static CNumeric128 idiv(int32 left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, CNumeric128(left), right, DR128_QUOTIENT);
 return result;
}

inline static CNumeric128 idiv(int64 left, CNumeric128 const& right) {
 CNumeric128 result;
 dr128(result, CNumeric128(left), right, DR128_QUOTIENT);
 return result;
}


inline static int32 idiv(int32 num, int32 denom) {
 if ( denom == 0 )
 divByZeroError();
 return num / denom ;
}


inline static int64 idiv(int32 num, int64 denom) {
 if ( denom == 0 )
 divByZeroError();
 return num / denom ;
}


inline static int64 idiv(int64 num, int32 denom) {
 if ( denom == 0 )
 divByZeroError();
 return num / denom ;
}


inline static int64 idiv(int64 num, int64 denom) {
 if ( denom == 0 )
 divByZeroError();
 return num / denom ;
}

inline static int32 check_divisor(int32 d) { if ( d == 0 ) divByZeroError(); return d; }
inline static int64 check_divisor(int64 d) { if ( d == 0 ) divByZeroError(); return d; }

inline static int32 rdiv(int32 num, int32 denom) {
 if ( denom == 0 ) divByZeroError();
 int32 negq = num ^ denom;
 uint32 n = num;
 if ( num < 0 ) n = -num;
 uint32 d = denom;
 if ( denom < 0 ) d = -denom;
 int32 q = n/d;
 q = q + ((2*(n-(q*d))) >= d);
 if ( negq < 0 ) q = -q;
 return q;
}


inline static int64 rdiv(int32 num, int64 denom) {
 if ( denom == 0 ) divByZeroError();
 int32 negq = num ^ ((int32)(((uint64)(denom))>>32));
 uint32 n = num;
 if ( num < 0 ) n = -num;
 uint64 d = denom;
 if ( denom < 0 ) d = -denom;
 int64 q = n/d;
 q = q + ((2*(n-(q*d))) >= d);
 if ( negq < 0 ) q = -q;
 return q;
}


inline static int64 rdiv(int64 num, int32 denom) {
 if ( denom == 0 ) divByZeroError();
 int32 negq = ((int32)(((uint64)(num))>>32)) ^ denom;
 uint64 n = num;
 if ( num < 0 ) n = -num;
 uint32 d = denom;
 if ( denom < 0 ) d = -denom;
 int64 q = n/d;
 q = q + ((2*(n-(q*d))) >= d);
 if ( negq < 0 ) q = -q;
 return q;
}


inline static int64 rdiv(int64 num, int64 denom) {
 if ( denom == 0 ) divByZeroError();
 int32 negq = ((int32)(((uint64)(num))>>32)) ^ ((int32)(((uint64)(denom))>>32));
 uint64 n = num;
 if ( num < 0 ) n = -num;
 uint64 d = denom;
 if ( denom < 0 ) d = -denom;
 int64 q = n/d;
 q = q + ((2*(n-(q*d))) >= d);
 if ( negq < 0 ) q = -q;
 return q;
}

inline static int8 N32_int8(int32 n) {
    if ( n != (int32)(int8)n ) numericDataSizeError();
    return (int8)n;
}
inline static int8 N64_int8(int64 n) {
    if ( n != (int64)(int8)n ) numericDataSizeError();
    return (int8)n;
}
inline static int8 N128_int8(CNumeric128 const& cn128) {
    uint32 sign = (((signed)(cn128.digit[3]))>>31);
    if ( (cn128.digit[0] != sign) || (cn128.digit[1] != sign) ||
         (cn128.digit[2] != sign) || (cn128.digit[3] != (int32)(int8)cn128.digit[3]) ) {
        numericDataSizeError();
    }
    return (int8)cn128.digit[3];
}
inline static int8 N128_int8(int64 n) {
    if ( n != (int64)(int8)n ) numericDataSizeError();
    return (int8)n;
}
inline static int8 N128_int8(int32 n) {
    if ( n != (int32)(int8)n ) numericDataSizeError();
    return (int8)n;
}
CNumeric128 *CNumeric_pow_10(int exponent);
inline static int8 toInt1(int32 n, int scale) {
    CNumeric128 cn128(n);
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int8(scale0val);
}
inline static int8 toInt1(int64 n, int scale) {
    CNumeric128 cn128(n);
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int8(scale0val);
}
inline static int8 toInt1(CNumeric128 const& cn128, int scale) {
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int8(scale0val);
}
inline static int16 N32_int16(int32 n) {
    if ( n != (int32)(int16)n ) numericDataSizeError();
    return (int16)n;
}
inline static int16 N64_int16(int64 n) {
    if ( n != (int64)(int16)n ) numericDataSizeError();
    return (int16)n;
}
inline static int16 N128_int16(CNumeric128 const& cn128) {
    uint32 sign = (((signed)(cn128.digit[3]))>>31);
    if ( (cn128.digit[0] != sign) || (cn128.digit[1] != sign) ||
         (cn128.digit[2] != sign) || (cn128.digit[3] != (int32)(int16)cn128.digit[3]) ) {
        numericDataSizeError();
    }
    return (int16)cn128.digit[3];
}
inline static int16 N128_int16(int64 n) {
    if ( n != (int64)(int16)n ) numericDataSizeError();
    return (int16)n;
}
inline static int16 N128_int16(int32 n) {
    if ( n != (int32)(int16)n ) numericDataSizeError();
    return (int16)n;
}
inline static int16 toInt2(int32 n, int scale) {
    CNumeric128 cn128(n);
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int16(scale0val);
}
inline static int16 toInt2(int64 n, int scale) {
    CNumeric128 cn128(n);
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int16(scale0val);
}
inline static int16 toInt2(CNumeric128 const& cn128, int scale) {
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int16(scale0val);
}
inline static int32 N64_int32(int64 n) {
    if ( n != (int64)(int32)n ) numericDataSizeError();
    return (int32)n;
}
inline static int32 N128_int32(CNumeric128 const& cn128) {
    uint32 sign = (((signed)(cn128.digit[3]))>>31);
    if ( (cn128.digit[0] != sign) || (cn128.digit[1] != sign) ||
         (cn128.digit[2] != sign) ) {
        numericDataSizeError();
    }
    return cn128.digit[3];
}
inline static int32 N128_int32(int64 n) {
    if ( n != (int64)(int32)n ) numericDataSizeError();
    return (int32)n;
}
inline static int32 N128_int32(int32 n) {
    return n;
}
inline static int32 toInt4(int32 n, int scale) {
    CNumeric128 cn128(n);
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int32(scale0val);
}
inline static int32 toInt4(int64 n, int scale) {
    CNumeric128 cn128(n);
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int32(scale0val);
}
inline static int32 toInt4(CNumeric128 const& cn128, int scale) {
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int32(scale0val);
}
inline static int64 N128_int64(CNumeric128 const& cn128) {
    uint32 sign = (((signed)(cn128.digit[2]))>>31);
    if ( (cn128.digit[0] != sign) || (cn128.digit[1] != sign) ) {
        numericDataSizeError();
    }
    return (((uint64)cn128.digit[2])<<32) | (uint32)cn128.digit[3];
}
inline static int64 N128_int64(int64 n) {
    return n;
}
inline static int64 N128_int64(int32 n) {
    return (int64) n;
}
inline static int64 toInt8(int32 n, int scale) {
    CNumeric128 cn128(n);
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int64(scale0val);
}
inline static int64 toInt8(int64 n, int scale) {
    CNumeric128 cn128(n);
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int64(scale0val);
}
inline static int64 toInt8(CNumeric128 const& cn128, int scale) {
    CNumeric128 *mag = CNumeric_pow_10(scale);
    CNumeric128 scale0val = rdiv(cn128,*mag);
    return N128_int64(scale0val);
}
inline int32 validated_precision_32(int32 value, int32 precision_hi_limit, int32 precision_lo_limit)
{
    if ( value >= precision_hi_limit || value <= precision_lo_limit )
        numericDataSizeError();
    return value;
}
inline int64 validated_precision_64(int64 value, int64 precision_hi_limit, int64 precision_lo_limit)
{
    if ( value >= precision_hi_limit || value <= precision_lo_limit )
        numericDataSizeError();
    return value;
}
inline CNumeric128 const& validated_precision_128(
    CNumeric128 const& value,
    CNumeric128 const& precision_hi_limit,
    CNumeric128 const& precision_lo_limit)
{
    if ( value.iq.hi32 >= 0 ) {
        if ( value >= precision_hi_limit ) goto OUT_OF_RANGE;
        }
    else {
        if ( value <= precision_lo_limit ) goto OUT_OF_RANGE;
        }
    return value;
OUT_OF_RANGE:
    numericDataSizeError();
}
inline CNumeric64 const& validated_precision_128 (
    CNumeric64 const& value,
    CNumeric128 const& precision_hi_limit,
    CNumeric128 const& precision_lo_limit)
{
    return value;
}
inline int64 const& validated_precision_128 (
    int64 const& value,
    CNumeric128 const& precision_hi_limit,
    CNumeric128 const& precision_lo_limit)
{
    return value;
}
inline CNumeric32 const& validated_precision_128 (
    CNumeric32 const& value,
    CNumeric128 const& precision_hi_limit,
    CNumeric128 const& precision_lo_limit)
{
    return value;
}
inline int32 const& validated_precision_128 (
    int32 const& value,
    CNumeric128 const& precision_hi_limit,
    CNumeric128 const& precision_lo_limit)
{
    return value;
}
inline static float CNumeric128_float(CNumeric128 const& cn128) {
    if ( cn128.inRangeI32() ) {
        return cn128.getI32();
    } else if ( cn128.inRangeI64() ) {
        return cn128.getI64();
    } else {
        return 18446744073709551616.0 * cn128.getHiI64() + cn128.getU64();
    }
}
inline static float CNumeric128_float(int64 const& i64) {
    return i64;
}
inline static float CNumeric128_float(int32 const& i32) {
    return i32;
}
inline static double CNumeric128_double(CNumeric128 const& cn128) {
    if ( cn128.inRangeI32() ) {
        return cn128.getI32();
    } else if ( cn128.inRangeI64() ) {
        return cn128.getI64();
    } else {
        return 18446744073709551616.0 * cn128.getHiI64() + cn128.getU64();
    }
}
inline static double CNumeric128_double(int64 const& i64) {
    return i64;
}
inline static double CNumeric128_double(int32 const& i32) {
    return i32;
}
const int CNumeric128_max_precision = 38;
inline static CNumeric128 round_128(CNumeric128 val, int sscale, int dscale) {
    if (dscale > CNumeric128_max_precision ||
            dscale < -CNumeric128_max_precision)
        throwError(45, "round scale out of range", 0);
    if (dscale > sscale) {
        return val;
    }
    else {
        int theScale = (sscale - dscale);
        CNumeric128 *factorP = CNumeric_pow_10 (
                    theScale < CNumeric128_max_precision ? theScale :
                                CNumeric128_max_precision);
        return (rdiv (val, (*factorP))) * (*factorP);
    }
}
inline static CNumeric128 trunc_128(CNumeric128 val, int sscale, int dscale) {
    if (dscale > CNumeric128_max_precision ||
            dscale < -CNumeric128_max_precision)
        throwError(45, "trunc scale out of range", 0);
    if (dscale > sscale) {
        return val;
    }
    else {
        int theScale = (sscale - dscale);
        CNumeric128 *factorP = CNumeric_pow_10 (
                    theScale < CNumeric128_max_precision ? theScale :
                                CNumeric128_max_precision);
        return (val / (*factorP)) * (*factorP);
    }
}
extern "C" { CNumeric128 const& CheckPrecision38Limit(CNumeric128 const& value); }
inline int64 CheckPrecision38Limit(int64 in) { return in; }
inline int32 CheckPrecision38Limit(int32 in) { return in; }
inline static CNumeric64 const& getI64(CNumeric64 const* p) { return *p; }
inline int32 nz_um1(int32 arg) {
 int32 result = -arg;
 if (result == (((unsigned)1)<<(8 -1))) overflow_8_arith();
 return result;
}
inline int8 nz_add1(int8 left, int8 right) {
 int8 result;
 unsigned char ovf;
asm (
"	addb	%[right],%[result]\n"
"	setob	%[ovf]"
 : [ovf] "=bcm" (ovf)
 , [result] "=&r" (result)
 : [right] "g" (right)
 , [left] "1" (left)
 : "cc"
 );
 if (ovf) overflow_8_arith();
 return result;
}
inline int8 nz_sub1(int8 left, int8 right) {
 int8 result;
 unsigned char ovf;
asm (
"	subb	%[right],%[result]\n"
"	setob	%[ovf]"
 : [ovf] "=bcm" (ovf)
 , [result] "=&r" (result)
 : [right] "g" (right)
 , [left] "1" (left)
 : "cc"
 );
 if (ovf) overflow_8_arith();
 return result;
}
inline int32 nz_mul1(int32 left, int32 right) {
 int32 result = left * right;
 if (result != (int8)result) overflow_8_arith();
 return result;
}
inline int8 nz_div1(int8 num, int8 denom) {
 if (denom == 0) divByZeroError();
 if ((denom == -1) && (num == (int8)(1<<(8 -1)))) overflow_8_arith();
 return num / denom;
}
inline int32 nz_um2(int32 arg) {
 int32 result = -arg;
 if (result == (((unsigned)1)<<(16 -1))) overflow_16_arith();
 return result;
}
inline int16 nz_add2(int16 left, int16 right) {
 int16 result;
 unsigned char ovf;
asm (
"	addw	%[right],%[result]\n"
"	setob	%[ovf]"
 : [ovf] "=bcm" (ovf)
 , [result] "=&r" (result)
 : [right] "g" (right)
 , [left] "1" (left)
 : "cc"
 );
 if (ovf) overflow_16_arith();
 return result;
}
inline int16 nz_sub2(int16 left, int16 right) {
 int16 result;
 unsigned char ovf;
asm (
"	subw	%[right],%[result]\n"
"	setob	%[ovf]"
 : [ovf] "=bcm" (ovf)
 , [result] "=&r" (result)
 : [right] "g" (right)
 , [left] "1" (left)
 : "cc"
 );
 if (ovf) overflow_16_arith();
 return result;
}
inline int16 nz_mul2(int16 left, int16 right) {
 int16 result;
 unsigned char ovf;
asm (
"	imulw	%[right],%[result]\n"
"	setob	%[ovf]"
 : [ovf] "=bcm" (ovf)
 , [result] "=&r" (result)
 : [right] "g" (right)
 , [left] "1" (left)
 : "cc"
 );
 if (ovf) overflow_16_arith();
 return result;
}
inline int16 nz_div2(int16 num, int16 denom) {
 if (denom == 0) divByZeroError();
 if ((denom == -1) && (num == (int16)(1<<(16 -1)))) overflow_16_arith();
 return num / denom;
}
inline int32 nz_um4(int32 arg) {
 int32 result = -arg;
 if (result == (((unsigned)1)<<(32 -1))) overflow_32_arith();
 return result;
}
inline int32 nz_add4(int32 left, int32 right) {
 int32 result;
 unsigned char ovf;
asm (
"	addl	%[right],%[result]\n"
"	setob	%[ovf]"
 : [ovf] "=bcm" (ovf)
 , [result] "=&r" (result)
 : [right] "g" (right)
 , [left] "1" (left)
 : "cc"
 );
 if (ovf) overflow_32_arith();
 return result;
}
inline int32 nz_sub4(int32 left, int32 right) {
 int32 result;
 unsigned char ovf;
asm (
"	subl	%[right],%[result]\n"
"	setob	%[ovf]"
 : [ovf] "=bcm" (ovf)
 , [result] "=&r" (result)
 : [right] "g" (right)
 , [left] "1" (left)
 : "cc"
 );
 if (ovf) overflow_32_arith();
 return result;
}
inline int32 nz_mul4(int32 left, int32 right) {
 int32 result;
 unsigned char ovf;
asm (
"	imull	%[right],%[result]\n"
"	setob	%[ovf]"
 : [ovf] "=bcm" (ovf)
 , [result] "=&r" (result)
 : [right] "g" (right)
 , [left] "1" (left)
 : "cc"
 );
 if (ovf) overflow_32_arith();
 return result;
}
inline int32 nz_div4(int32 num, int32 denom) {
 if (denom == 0) divByZeroError();
 if ((denom == -1) && (num == (int32)(1<<(32 -1)))) overflow_32_arith();
 return num / denom;
}
inline int64 nz_um8(int64 arg) {
 int64 result = - arg;
 if ((arg < 0) && (result < 0)) overflow_64_arith();
 return result;
}
inline int64 nz_add8(int64 left, int64 right) {
 int64 result = left + right;
 if (((((int32)(((uint64)(left))>>32)) ^ ((int32)(((uint64)(right))>>32))) >= 0) &&
 ((((int32)(((uint64)(left))>>32)) ^ ((int32)(((uint64)(result))>>32))) < 0))
 overflow_64_arith();
 return result;
}
inline int64 nz_sub8(int64 left, int64 right) {
 int64 result = left - right;
 if (((((int32)(((uint64)(left))>>32)) ^ ((int32)(((uint64)(right))>>32))) < 0) &&
 ((((int32)(((uint64)(left))>>32)) ^ ((int32)(((uint64)(result))>>32))) < 0))
 overflow_64_arith();
 return result;
}
inline int64 nz_div8(int64 num, int64 denom) {
    if ( denom == 0 ) divByZeroError();
    if (denom == INT64_C(-1) && (uint64)num == (UINT64_C(1) << 63)) overflow_64_arith();
    int64 result = num / denom;
    return result;
}
