#ifndef FMTHELPERS_INCLUDED
#define FMTHELPERS_INCLUDED

// routine names ending in 8 output 8-bit SBC
// routine names ending in A output ASCII (= UTF8)

inline char *ucMeridian8(char *p, int flag) {
    if ( flag )
        *p++ = AsciiToSBC('A');
    else
        *p++ = AsciiToSBC('P');
    *p++ = AsciiToSBC('M');
    return p;
}

inline char *ucMeridianA(char *p, int flag) {
    if ( flag )
        *p++ = 'A';
    else
        *p++ = 'P';
    *p++ = 'M';
    return p;
}

inline char *ucdMeridian8(char *p, int flag) {
    char dot = AsciiToSBC('.');
    if ( flag )
        *p++ = AsciiToSBC('A');
    else
        *p++ = AsciiToSBC('P');
    *p++ = dot;
    *p++ = AsciiToSBC('M');
    *p++ = dot;
    return p;
}

inline char *ucdMeridianA(char *p, int flag) {
    if ( flag )
        *p++ = 'A';
    else
        *p++ = 'P';
    *p++ = '.';
    *p++ = 'M';
    *p++ = '.';
    return p;
}

inline char *lcMeridian8(char *p, int flag) {
    if ( flag )
        *p++ = AsciiToSBC('a');
    else
        *p++ = AsciiToSBC('p');
    *p++ = AsciiToSBC('m');
    return p;
}

inline char *lcMeridianA(char *p, int flag) {
    if ( flag )
        *p++ = 'a';
    else
        *p++ = 'p';
    *p++ = 'm';
    return p;
}

inline char *lcdMeridian8(char *p, int flag) {
    char dot = AsciiToSBC('.');
    if ( flag )
        *p++ = AsciiToSBC('a');
    else
        *p++ = AsciiToSBC('p');
    *p++ = dot;
    *p++ = AsciiToSBC('m');
    *p++ = dot;
    return p;
}

inline char *lcdMeridianA(char *p, int flag) {
    if ( flag )
        *p++ = 'a';
    else
        *p++ = 'p';
    *p++ = '.';
    *p++ = 'm';
    *p++ = '.';
    return p;
}

inline char *ucEra8(char *p, int flag) {
    if ( flag ) {
        *p++ = AsciiToSBC('B');
        *p++ = AsciiToSBC('C');
    } else {
        *p++ = AsciiToSBC('A');
        *p++ = AsciiToSBC('D');
    }
    return p;
}

inline char *ucEraA(char *p, int flag) {
    if ( flag ) {
        *p++ = 'B';
        *p++ = 'C';
    } else {
        *p++ = 'A';
        *p++ = 'D';
    }
    return p;
}

inline char *ucdEra8(char *p, int flag) {
    char dot = AsciiToSBC('.');
    if ( flag ) {
        *p++ = AsciiToSBC('B');
        *p++ = dot;
        *p++ = AsciiToSBC('C');
    } else {
        *p++ = AsciiToSBC('A');
        *p++ = dot;
        *p++ = AsciiToSBC('D');
    }
    *p++ = dot;
    return p;
}

inline char *ucdEraA(char *p, int flag) {
    if ( flag ) {
        *p++ = 'B';
        *p++ = '.';
        *p++ = 'C';
    } else {
        *p++ = 'A';
        *p++ = '.';
        *p++ = 'D';
    }
    *p++ = '.';
    return p;
}

inline char *lcEra8(char *p, int flag) {
    if ( flag ) {
        *p++ = AsciiToSBC('b');
        *p++ = AsciiToSBC('c');
    } else {
        *p++ = AsciiToSBC('a');
        *p++ = AsciiToSBC('d');
    }
    return p;
}

inline char *lcEraA(char *p, int flag) {
    if ( flag ) {
        *p++ = 'b';
        *p++ = 'c';
    } else {
        *p++ = 'a';
        *p++ = 'd';
    }
    return p;
}

inline char *lcdEra8(char *p, int flag) {
    char dot = AsciiToSBC('.');
    if ( flag ) {
        *p++ = AsciiToSBC('b');
        *p++ = dot;
        *p++ = AsciiToSBC('c');
    } else {
        *p++ = AsciiToSBC('a');
        *p++ = dot;
        *p++ = AsciiToSBC('d');
    }
    *p++ = dot;
    return p;
}

inline char *lcdEraA(char *p, int flag) {
    if ( flag ) {
        *p++ = 'b';
        *p++ = '.';
        *p++ = 'c';
    } else {
        *p++ = 'a';
        *p++ = '.';
        *p++ = 'd';
    }
    *p++ = '.';
    return p;
}

inline char *lcOrdinalSuffix8(int val) {
    if ( val < 0 )
        val = -val;
    char suffs[9] = {'t','h','s','t','n','d','r','d',0};
    val %= 100;
    int lastdigit = val % 10;

    StrAsciiToSBC(suffs);
    if ( ( val >= 4 && val <= 20 ) || lastdigit > 3 )
        lastdigit = 0;
    return suffs + (2*lastdigit);
}

inline char *lcOrdinalSuffixA(int val) {
    if ( val < 0 )
        val = -val;
    val %= 100;
    int lastdigit = val % 10;

    if ( ( val >= 4 && val <= 20 ) || lastdigit > 3 )
        lastdigit = 0;
    return (char*)"thstndrd" + (2*lastdigit);
}

inline const char *ucOrdinalSuffix8(int val) {
    if ( val < 0 )
        val = -val;
    char suffs[9] = {'T','H','S','T','N','D','R','D',0};
    val %= 100;
    int lastdigit = val % 10;

    StrAsciiToSBC(suffs);
    if ( ( val >= 4 && val <= 20 ) || lastdigit > 3 )
        lastdigit = 0;
    return suffs + (2*lastdigit);
}

inline const char *ucOrdinalSuffixA(int val) {
    if ( val < 0)
        val = -val;
    val %= 100;
    int lastdigit = val % 10;

    if ( ( val >= 4 && val <= 20 ) || lastdigit > 3 )
        lastdigit = 0;
    return (char*)"THSTNDRD" + (2*lastdigit);
}

inline int digcnt(int val) {
    int cnt;
    if ( val < 0 )
        val = -val;

         if ( val < 10 ) cnt = 1;
    else if ( val < 100 ) cnt = 2;
    else if ( val < 1000 ) cnt = 3;
    else if ( val < 10000 ) cnt = 4;
    else if ( val < 100000 ) cnt = 5;
    else if ( val < 1000000 ) cnt = 6;
    else if ( val < 10000000 ) cnt = 7;
    else if ( val < 100000000 ) cnt = 8;
    else if ( val < 1000000000 ) cnt = 9;
    else cnt = 10;
    return cnt;
}


//functions for ISO YEAR handling
inline int date2ij(int y, int m, int d)
{
     int  m12 = (m - 14) / 12;
     return ((1461 * (y + 4800 + m12)) / 4 + (367 * (m - 2 - 12 * (m12))) / 12 - (3 * ((y + 4900 + m12) / 100)) / 4 + d - 32075);
}

inline int ij2day(int date)
{
     int  day;
     day = (date + 1) % 7;
     return day;
}

inline int date2isoweek(int year, int mon, int mday) 
{
     double  result;
     int day0, day4, dayn;
		    
     dayn = date2ij(year, mon, mday);
		        
     day4 = date2ij(year, 1, 4);
			    
     day0 = (ij2day(day4 - 1) % 7);
			        
     if (dayn < (day4 - day0))
     {
        day4 = date2ij((year - 1), 1, 4);
        day0 = (ij2day(day4 - 1) % 7);
     }
     result = (((dayn - (day4 - day0)) / 7) + 1);

    /* Extend fix of 90810 to handle date values passed through table column.
     * Sometimes the last few days in a year will fall into
     * the first week of the next year, so check for this.
     */
     if (result >= 52)
     {
         day4 = date2ij((year + 1), 1, 4);
         day0 = (ij2day(day4 - 1) % 7);
         if (dayn >= (day4 - day0))
            result = (((dayn - (day4 - day0)) / 7) + 1);
     }
     return (int)result;
}

inline int date2isoyear(int year, int mon, int mday)
{
    // current day of week
    int current_day = (date2ij(year, mon, mday) % 7)+1;
    // Get Iso week from Date
    int current_week = date2isoweek(year, mon, mday);

    /* The ISO 8601 definition for week 01 is the week with the year's first Thursday in it */
    if (current_week == 1)
    {
        if (mday > 28)        // 28 december came to next year
            return (year + 1);
        else
            return year;
    }
    /* The last week of the ISO week-numbering year, i.e. the 52nd or 53rd one,
     * is the week before week 01. */
    else if (current_week >= 52)
    {
        if (current_day > 4 && mon < 12)      // if day is friday,saturday sunday
            return (year - 1);
        else
            return year;
    }
    return  year;
} //end date2isoyear     

inline char *digout8(int cnt, char *p, int val) {
    int zero = AsciiToSBC('0');
    int signCharCount = 0;
    if ( val < 0 ) {
        cnt++;
        val = -val;
        signCharCount = 1;
    }
    for (int i=cnt-1; i>=signCharCount; i--) {
        p[i] = zero + (val % 10);
        val /= 10;
    }
    // condition and '-' sign added only for 'BC' date
    if ( signCharCount == 1 )
        p[0] = AsciiToSBC('-');

    return p+cnt;
}

inline char *digoutA(int cnt, char *p, int val) {
    int signCharCount = 0;
    if ( val < 0 ) {
        cnt++;
        val = -val;
        signCharCount = 1;
    }
    for (int i=cnt-1; i>=signCharCount; i--) {        
        p[i] = '0' + (val % 10);
        val /= 10;
    }
    // condition and '-' sign added only for 'BC' date
    if ( signCharCount == 1 )
        p[0] = '-';

    return p+cnt;
}

inline char *zdigout8(char *p, int val) {
    int zero = AsciiToSBC('0');
    int signCharCount = 0;
    int cnt = digcnt( val );
    if ( val < 0 ) {
        cnt++;
        val = -val;
        signCharCount = 1;
    }
    for (int i=cnt-1; i>=signCharCount; i--) {
        p[i] = zero + (val % 10);
        val /= 10;
    }
    // condition and '-' sign added only for 'BC' date
    if ( signCharCount == 1 )
        p[0] = AsciiToSBC('-');

    return p+cnt;
}

inline char *zdigoutA(char *p, int val) {
    int signCharCount = 0;
    int cnt = digcnt( val );
    if ( val < 0 ) {
        cnt++;
        val = -val;
        signCharCount = 1;
    }
    for (int i=cnt-1; i>=signCharCount; i--) {
        p[i] = '0' + (val % 10);
        val /= 10;
    }
    // condition and '-' sign added only for 'BC' date
    if ( signCharCount == 1 )
        p[0] = '-';

    return p+cnt;
}

inline char *comma4digout8(char *p, int val) {
    int zero = AsciiToSBC('0');
    for (int i=4; i>=2; i--) {
        p[i] = zero + (val % 10);
        val /= 10;
    }
    p[1] = AsciiToSBC(',');
    p[0] = zero + (val % 10);
    return p+5;
}

inline char *comma4digoutA(char *p, int val) {
    for (int i=4; i>=2; i--) {
        p[i] = '0' + (val % 10);
        val /= 10;
    }
    p[1] = ',';
    p[0] = '0' + (val % 10);
    return p+5;
}

inline char *zcomma4digout8(char *p, int val) {
    int cnt = digcnt( val );
    if ( cnt < 4 )
        return digout8( cnt, p, val );
    else
        return comma4digout8( p, val );
}

inline char *zcomma4digoutA(char *p, int val) {
    int cnt = digcnt( val );
    if ( cnt < 4 )
        return digoutA( cnt, p, val );
    else
        return comma4digoutA( p, val );
}
#endif // FMTHELPERS_INCLUDED
