#ifndef GROOMSPUSTATE_INCLUDED
#define GROOMSPUSTATE_INCLUDED

#include "dpm_common.h"
#include "storagerefs.h"
#include "TXIDCommon.h"


/** Groom state kept in SpuJob to facilitate interaction between groom 
    snippets and accumulate groom step stats.
 */
struct GroomSpuState {
    int tempTableId; // id of transient table storing record numbers in organized order
    int extentCount; // number of processed extents
    bool completed;  // true when all extents for a table have been organized
    bool autoDone;   // true ==  use auto-done option to convert fully written extents to "done"
                     // false == leave all written extents as redo
    TXidValue stableTxid; // used to filter out reclaimable records
    int64 startTime;  // Grooming step start time
    TCHand groomTch;  // Groomed table connection
    PageId lastReclaimedPage; // Used for page-level reclaim to skip
                               // pages scanned on previous steps

    table_id_t prevScanTableId;  // For groom versions to detect scan of a new table version
    table_id_t insertTableId;    // Non-zero if groom insert table != scan table (groom versions)
    
    // Groom step stats info below
    int scannedPages;
    int inputRecs;
    int outputRecs;
    PageId firstPageId; // inclusive
    PageId lastPageId;  // inclusive
    TXidValue maxReclaimedXid;
};

#endif // REORGSTATE_INCLUDED
