#ifndef GROOMSTMT_H
#define GROOMSTMT_H
//////////////////////////////////////////////////////////////////////
/// @file groomstmt.h
/// @brief Groom statement definition
///
//////////////////////////////////////////////////////////////////////
/// (C) Copyright IBM Corp. 2009, 2011  All Rights Reserved.
//////////////////////////////////////////////////////////////////////
///
/// Description:
///
/// This file contains groom statement related enum definition.
/// This file is used by pg and nde source subtrees.
///
/// dle - 2009-06-17
//////////////////////////////////////////////////////////////////////


////////////////////////////////////////
// GroomMode enum
// GROOM_MODE_DEFAULT is 0. In CPlan.m_groomMode 0 means not-a-groom plan.
// GROOM_MODE_DEFAULT is replaced with appropriate value
// before CPlan is constructed, so overloading GROOM_MODE_DEFAULT (0) 
// to denote not-a-groom plan in CPlan is safe.

#define _GROOM_MODE_LIST_                                 \
    _ROW_( GROOM_MODE_DEFAULT,   "DEFAULT"       ) _SEP_  \
    _ROW_( GROOM_RECORDS_READY,  "RECORDS READY" ) _SEP_  \
    _ROW_( GROOM_RECORDS_ALL,    "RECORDS ALL"   ) _SEP_  \
    _ROW_( GROOM_ORGANIZE_READY, "ORGANIZE READY") _SEP_  \
    _ROW_( GROOM_ORGANIZE_ALL,   "ORGANIZE ALL"  ) _SEP_  \
    _ROW_( GROOM_PAGES_ALL,      "PAGES ALL"     ) _SEP_  \
    _ROW_( GROOM_PAGES_START,    "PAGES START"   ) _SEP_  \
    _ROW_( GROOM_VERSIONS,       "VERSIONS"      )

#define _ROW_(a,b) a
#define _SEP_ ,
typedef enum { _GROOM_MODE_LIST_ } GroomMode;
#undef _ROW_
#undef _SEP_

typedef enum GroomReclaimMode
{
    GROOM_RECLAIM_OFF,              /* stable TxId == 0*/
    GROOM_RECLAIM_BKUPSET_NONE,     /* Use current stable TxId*/
    GROOM_RECLAIM_BKUPSET_DEFAULT,  /* Use stable TxId of default bkupset */
    GROOM_RECLAIM_BKUPSET_SPECIFIED /* Use stable TxId of specified bkupset */
} GroomReclaimMode;

extern const int GroomModeCount;
extern const char*const GroomModeStrs[];
CEXTERN const char* groomModeDescr(GroomMode mode);

#endif   /* GROOMSTMT_H */
