#ifndef I386_TSC_INCLUDED
#define I386_TSC_INCLUDED

// Using "=A" constraint doesn't work in 64bit mode.
// The following in a correct version. We use size_t
// for lo/hi as this is native register size.
#if defined(__i386__) || defined(__aix__) || defined(__sparc__) || defined(__powerpc__) || defined(__hpitanium__) || defined(__zlinux__)
# define rdtscll(val) \
    asm volatile("rdtsc" : "=A" (val))
#elif defined(__x86_64__)
# define rdtscll(val) do { \
        uint32_t lo, hi; \
        asm volatile("rdtsc" : "=a" (lo), "=d" (hi)); \
        (val) = (((uint64_t) hi) << 32) | lo; \
    } while (0)
#else
# error "unsupported architecture"
#endif

#define rdtscl(low) \
    asm volatile("rdtsc" : "=a" (low) : : "edx")

#endif
