//******************************************************************************

        // Fill all fields in logical order (loop constructed out of GOTOs)
        goto START_PARSING_RECORD_FIELDS;

        while (TRUE) {
            register uint8* REG_pField REG(edi);

        NULL_15_BYTES:
            REG_pField[14] = 0;
        NULL_14_BYTES:
            REG_pField[13] = 0;
        NULL_13_BYTES:
            REG_pField[12] = 0;
            goto NULL_12_BYTES;

        NULL_11_BYTES:
            REG_pField[10] = 0;
        NULL_10_BYTES:
            REG_pField[9] = 0;
        NULL_9_BYTES:
            REG_pField[8] = 0;
            goto NULL_8_BYTES;

        NULL_7_BYTES:
            REG_pField[6] = 0;
        NULL_6_BYTES:
            REG_pField[5] = 0;
        NULL_5_BYTES:
            REG_pField[4] = 0;
            goto NULL_4_BYTES;

        NULL_3_BYTES:
            REG_pField[2] = 0;
        NULL_2_BYTES:
            *((int16*)REG_pField) = 0;
            goto SET_NULL_BIT;

        NULL_1_BYTES:
            REG_pField[0] = 0;
            goto SET_NULL_BIT;

        NULL_16_BYTES:
            *((int32*)REG_pField + 3) = 0;
        NULL_12_BYTES:
            *((int32*)REG_pField + 2) = 0;
        NULL_8_BYTES:
            *((int32*)REG_pField + 1) = 0;
        NULL_4_BYTES:
            *((int32*)REG_pField + 0) = 0;
        SET_NULL_BIT:
            // REG_pFldPrsCtl->nullIndex is prebiased to account for sizeWordSize
            NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);
            pText += pCurrentFPC->fixedLengthNULL;
        NEXT_FIELD:
            ENCACHE_REG(pEnd);
            ++pCurrentFPC;

        START_PARSING_RECORD_FIELDS:
            REG_pField = recordBuffer.bytes + pCurrentFPC->offset;

            // switch on field type
            switch (pCurrentFPC->parseDataType) {
// =============================================================================
            default:
                badParseDataType = pCurrentFPC->parseDataType;
                goto COLUMN_DISPATCH_OPCODE;
// ======== DWA_HIDDEN_PARTITION_ID ============================================
            case DB2_DWA_HIDDEN_PARTITION_ID: {
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DWA_HIDDEN_PARTITION_ID\n");
#endif

                *(reinterpret_cast<int32*>(REG_pField)) = db2zPartitionID;

                goto NEXT_FIELD;
            }
// ======== BIGINT =============================================================
            case DB2N_BIGINT: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * BIGINT                                        | BIGINT
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + 8                       | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. invert most significant bit of first byte
                * 2. reverse byte order
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = -2147483648
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 7F FF FF FF 80 00 00 00     | Byte sequence: 00 00 00 80 FF FF FF FF
                *                ^^ [0x00: value != NULL]       |
                *                   ^^ [0x7F ^ 0x80 = 0xFF]     |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00 00 00 00 00 00 00     | Byte sequence: 00 00 00 00 00 00 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : BIGINT (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0],
                        pText[1], pText[2], pText[3], pText[4], pText[5], pText[6], pText[7], pText[8]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_BIGINT_LENGTH_NULLABLE <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto BIGINT_CONVERSION;
                }

                *(reinterpret_cast<int64*>(REG_pField)) = 0;
                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += DB2Z_BIGINT_LENGTH_NULLABLE;

                goto NEXT_FIELD;
            }
// ======== BIGINT NOT NULL ====================================================
            case DB2_BIGINT: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * BIGINT NOT NULL                               | BIGINT NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 8                           | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. invert most significant bit of first byte
                * 2. reverse byte order
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = -2147483648
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 7F FF FF FF 80 00 00 00        | Byte sequence: 00 00 00 80 FF FF FF FF
                *                ^^ [0x7F ^ 0x80 = 0xFF]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : BIGINT NOT NULL (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0],
                        pText[1], pText[2], pText[3], pText[4], pText[5], pText[6], pText[7]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_BIGINT_LENGTH <= REG_pEnd);
#endif

            BIGINT_CONVERSION:
                *(reinterpret_cast<uint64*>(REG_pField)) = bswap_64(*(reinterpret_cast<uint64 const*>(pText)));
                REG_pField[7] ^= 0x80;

                pText += DB2Z_BIGINT_LENGTH;

                goto NEXT_FIELD;
            }
// ======== CHAR FOR MIXED DATA ================================================
            case DB2N_CHAR_MIXED: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * CHAR(<P>) FOR MIXED DATA                      | NVARCHAR(<P>)
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : varying-length
                * Number of bytes : 1 + <P>                     | Number of bytes : 2 + <P>
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion: n/a
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 10, value = U+0041 + U+00AE + U+20AC + U+1D11E | CCSID: 1208 (UTF-8)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * 00 41 C2 AE E2 82 AC F0 9D 84 9E              | 0C 00 41 C2 AE E2 82 AC F0 9D 84 9E
                * ^^ [0x00: value != NULL]                      | ^^^^^ [Length: 0x000C = 12]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: <P> = 10, value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * FF 00 00 00 00 00 00 00 00 00 00              | 02 00
                * ^^ [0xFF: value = NULL]                       | ^^^^^ [Length: 0x0002 = 2]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : CHAR(%u) FOR MIXED DATA\n", pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLengthNULL <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto CHAR_MIXED_CONVERSION;
                }

                REG_pField = pVarying;

                // align length to even address
                if (reinterpret_cast<size_t>(REG_pField) & 1) {
                    *REG_pField++ = 0;
                }

                // set length
                *(reinterpret_cast<vlen_t*>(REG_pField)) = sizeof(vlen_t);
                // update pointers
                REG_pField += sizeof(vlen_t);
                pVarying = REG_pField;

                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += pCurrentFPC->fixedLengthNULL;

                goto NEXT_FIELD;
            }
// ======== CHAR FOR MIXED DATA NOT NULL =======================================
            case DB2_CHAR_MIXED: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * CHAR(<P>) FOR MIXED DATA NOT NULL             | NVARCHAR(<P>) NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : varying-length
                * Number of bytes : <P>                         | Number of bytes : 2 + <P>
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion: n/a
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 10, value = U+0041 + U+00AE + U+20AC + U+1D11E | CCSID: 1208 (UTF-8)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * 41 C2 AE E2 82 AC F0 9D 84 9E                 | 0C 00 41 C2 AE E2 82 AC F0 9D 84 9E
                *                                               | ^^^^^ [Length: 0x000C = 12]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : CHAR(%u) FOR MIXED DATA NOT NULL\n", pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLength <= REG_pEnd);
#endif

            CHAR_MIXED_CONVERSION:
                REG_pField = pVarying;

                // align length to even address
                if (reinterpret_cast<size_t>(REG_pField) & 1) {
                    *REG_pField++ = 0;
                }

                int utf8Status;

                if (copyIn->validateUTF8(pText, pCurrentFPC->fixedLength, pBadField, utf8Status) == false) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pBadField - pText, pBadField - pText,
                            pCurrentFPC->fixedLength - (pBadField - pText), pBadField);

                    if (utf8Status == _UTF8_ILLEGAL_INITIAL_BYTE) {
                        goto UTF8_ILLEGAL_INITIAL_BYTE;
                    } else {
                        goto UTF8_BAD_CONTINUATION_BYTE;
                    }
                }

                // set length
                *(reinterpret_cast<vlen_t*>(REG_pField)) = sizeof(vlen_t) + pCurrentFPC->fixedLength;
                // copy string
                memcpy(REG_pField + sizeof(vlen_t), pText, pCurrentFPC->fixedLength);
                // update pointers
                REG_pField += sizeof(vlen_t) + pCurrentFPC->fixedLength;
                pVarying = REG_pField;

                pText += pCurrentFPC->fixedLength;

                goto NEXT_FIELD;
            }
// ======== CHAR FOR MIXED/SBCS DATA (ICU conversion required) ======================
            case DB2N_CHAR_MIXED_ICU:
            case DB2N_CHAR_SBCS_ICU: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * CHAR(<P>) FOR SBCS DATA                       | NCHAR(<P>)
                * CHAR(<P>) FOR MIXED DATA                      | NVARCHAR(<P>)
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : varying-length
                * Number of bytes : 1 + <P>                     | Number of bytes : 2 + <P>
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion: ICU conversion to UTF-8 or CESU-8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 10, value = U+0041 + U+00AE + U+20AC + U+1D11E | CCSID: 1208 (UTF-8)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * 00 41 C2 AE E2 82 AC F0 9D 84 9E              | 0C 00 41 C2 AE E2 82 AC F0 9D 84 9E
                * ^^ [0x00: value != NULL]                      | ^^^^^ [Length: 0x000C = 12]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: <P> = 10, value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * FF 00 00 00 00 00 00 00 00 00 00              | 02 00
                * ^^ [0xFF: value = NULL]                       | ^^^^^ [Length: 0x0002 = 2]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : CHAR(%u) FOR MIXED/SBCS DATA (ICU conversion required)\n",
                        pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLengthNULL <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto CHAR_MIXED_ICU_CONVERSION;
                }

                REG_pField = pVarying;

                // align length to even address
                if (reinterpret_cast<size_t>(REG_pField) & 1) {
                    *REG_pField++ = 0;
                }

                // set length
                *(reinterpret_cast<vlen_t*>(REG_pField)) = sizeof(vlen_t);
                // update pointers
                REG_pField += sizeof(vlen_t);
                pVarying = REG_pField;

                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += pCurrentFPC->fixedLengthNULL;

                goto NEXT_FIELD;
            }
// ======== CHAR FOR MIXED/SBCS DATA NOT NULL (ICU conversion required) =============
            case DB2_CHAR_MIXED_ICU:
            case DB2_CHAR_SBCS_ICU: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * CHAR(<P>) FOR SBCS DATA NOT NULL              | NCHAR(<P>) NOT NULL
                * CHAR(<P>) FOR MIXED DATA NOT NULL             | NVARCHAR(<P>) NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : varying-length
                * Number of bytes : <P>                         | Number of bytes : 2 + <P>
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion: ICU conversion to UTF-8 or CESU-8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 10, value = U+0041 + U+00AE + U+20AC + U+1D11E | CCSID: 1208 (UTF-8),
                *    CREATE DATABASE [...] WITH [...] NATIONAL CHARACTER SET cesu8;
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence (UTF-8):                        | Byte sequence (CESU-8):
                * 41 C2 AE E2 82 AC F0 9D 84 9E                 | 0E 00 41 C2 AE E2 82 AC ED A0 B4 ED B4 9E
                *                                               | ^^^^^ [Length: 0x000E = 14]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : CHAR(%u) FOR MIXED/SBCS DATA NOT NULL (ICU conversion required)\n",
                        pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLength <= REG_pEnd);
#endif

            CHAR_MIXED_ICU_CONVERSION:
                REG_pField = pVarying;

                // align length to even address
                if (reinterpret_cast<size_t>(REG_pField) & 1) {
                    *REG_pField++ = 0;
                }

                ICUConverter* converter = (*copyIn->m_converters)[pCurrentFPC->extra2.ccsid];

                NZ_VERIFY(converter != NULL);

                ptrdiff_t targetBufferLength = &recordBuffer.bytes[MAX_RECORD_SIZE - 1] - REG_pField + sizeof(vlen_t);
                int32 outputLength = converter->convertReplaceIdeographicSpaces(pText, pCurrentFPC->fixedLength,
                        REG_pField + sizeof(vlen_t), targetBufferLength);

                // set length
                *(reinterpret_cast<vlen_t*>(REG_pField)) = sizeof(vlen_t) + outputLength;
                // update pointers
                REG_pField += sizeof(vlen_t) + outputLength;
                pVarying = REG_pField;

                pText += pCurrentFPC->fixedLength;

                goto NEXT_FIELD;
            }
// ======== CHAR FOR SBCS DATA (precision > 16) ================================
            case DB2N_CHAR_SBCS: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * CHAR(<P>) FOR SBCS DATA [<P> > 16]            | CHAR(<P>) [internal: VARCHAR(<P>)
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : varying-length
                * Number of bytes : 1 + <P>                     | Number of bytes : 2 + <P>
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion: n/a
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 17, value = "IBM" | CCSID: 367 (ASCII)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * 00 49 42 4D 20 20 ... 20                      | 13 00 49 42 4D 20 20 ... 20
                * ^^ [0x00: value != NULL]                      | ^^^^^ [Length: 0x0013 = 19]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: <P> = 17, value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * FF 00 00 00 00 00 ... 00                      | 02 00
                * ^^ [0xFF: value = NULL]                       | ^^^^^ [Length: 0x0002 = 2]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : CHAR(%u) FOR SBCS DATA\n", pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLengthNULL <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto CHAR_SBCS_CONVERSION;
                }

                REG_pField = pVarying;

                // align length to even address
                if (reinterpret_cast<size_t>(REG_pField) & 1) {
                    *REG_pField++ = 0;
                }

                // set length
                *(reinterpret_cast<vlen_t*>(REG_pField)) = sizeof(vlen_t);
                // update pointers
                REG_pField += sizeof(vlen_t);
                pVarying = REG_pField;

                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += pCurrentFPC->fixedLengthNULL;

                goto NEXT_FIELD;
            }
// ======== CHAR FOR SBCS DATA NOT NULL (precision > 16) =======================
            case DB2_CHAR_SBCS: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * CHAR(<P>) FOR SBCS DATA NOT NULL [<P> > 16]   | CHAR(<P>) [internal: VARCHAR(<P>)
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : varying-length
                * Number of bytes : <P>                         | Number of bytes : 2 + <P>
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion: n/a
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 17, value = "IBM" | CCSID: 367 (ASCII)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * 49 42 4D 20 20 ... 20                         | 13 00 49 42 4D 20 20 ... 20
                *                                               | ^^^^^ [Length: 0x0013 = 19]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : CHAR(%u) FOR SBCS DATA NOT NULL\n", pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLength <= REG_pEnd);
#endif

            CHAR_SBCS_CONVERSION:
                // strip CCSID-specific trailing blanks
                uint16 strippedLength = 0;

                for (int16 i = pCurrentFPC->fixedLength - 1; i >= 0; --i) {
                    if (pText[i] != GC_sbcspcChar) {
                        strippedLength = i + 1;

                        break;
                    }
                }

                REG_pField = pVarying;

                // align length to even address
                if (reinterpret_cast<size_t>(REG_pField) & 1) {
                    *REG_pField++ = 0;
                }

                // set length
                *(reinterpret_cast<vlen_t*>(REG_pField)) = sizeof(vlen_t) + strippedLength;
                // copy string
                memcpy(REG_pField + sizeof(vlen_t), pText, strippedLength);
                // update pointers
                REG_pField += sizeof(vlen_t) + strippedLength;
                pVarying = REG_pField;

                pText += pCurrentFPC->fixedLength;

                goto NEXT_FIELD;
            }
// ======== CHAR FOR SBCS DATA (precision <= 16) ===============================
            case DB2N_CHAR_SBCS_16: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * CHAR(<P>) FOR SBCS DATA [<P> <= 16]           | CHAR(<P>)
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + <P>                     | Number of bytes : <P>
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion: n/a
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 5, value = "IBM" | CCSID: 367 (ASCII)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 49 42 4D 20 20              | Byte sequence: 49 42 4D 20 20
                *                ^^ [0x00: value != NULL]       |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: <P> = 5, value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00 00 00 00              | Byte sequence: 00 00 00 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : CHAR(%u) FOR SBCS DATA\n", pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLengthNULL <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    memcpy(REG_pField, pText, pCurrentFPC->fixedLength);

                    pText += pCurrentFPC->fixedLength;
                } else {
                    memset(REG_pField, 0, pCurrentFPC->fixedLength);

                    NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                    pText += pCurrentFPC->fixedLengthNULL;
                }

                goto NEXT_FIELD;
            }
// ======== CHAR FOR SBCS DATA NOT NULL (precision <= 16) ======================
            case DB2_CHAR_SBCS_16: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * CHAR(<P>) FOR SBCS DATA NOT NULL [<P> <= 16]  | CHAR(<P>) NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : <P>                         | Number of bytes : <P>
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion: n/a
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 5, value = "IBM" | CCSID: 367 (ASCII)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 49 42 4D 20 20                 | Byte sequence: 49 42 4D 20 20
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : CHAR(%u) FOR SBCS DATA NOT NULL\n", pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLength <= REG_pEnd);
#endif

                memcpy(REG_pField, pText, pCurrentFPC->fixedLength);

                pText += pCurrentFPC->fixedLength;

                goto NEXT_FIELD;
            }
// ======== DATE ===============================================================
            case DB2N_DATE: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * DATE                                          | DATE
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + 4                       | Number of bytes : 4
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. convert date (encoded as BCD) to number of days between 2000-01-01 and date
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = 1978-07-19
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 19 78 07 19                 | Byte sequence: 64 E1 FF FF
                *                ^^ [0x00: value != NULL]       | [0xFFFFE164 = -7836]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00 00 00                 | Byte sequence: 00 00 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DATE (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2], pText[3], pText[4]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_DATE_LENGTH_NULLABLE <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto DATE_CONVERSION;
                }

                *(reinterpret_cast<int*>(REG_pField)) = 0;
                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += DB2Z_DATE_LENGTH_NULLABLE;

                goto NEXT_FIELD;
            }
// ======== DATE NOT NULL ======================================================
            case DB2_DATE: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * DATE NOT NULL                                 | DATE NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 4                           | Number of bytes : 4
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. convert date (encoded as BCD) to number of days between 2000-01-01 and date
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = 1978-07-19
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 19 78 07 19                    | Byte sequence: 64 E1 FF FF
                *                                               | [0xFFFFE164 = -7836]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DATE NOT NULL (0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2], pText[3]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_DATE_LENGTH <= REG_pEnd);
#endif

            DATE_CONVERSION:
                uint32 year  = (pText[0] >> 4) * 1000 + (pText[0] & 0x0F) * 100 + (pText[1] >> 4) * 10 + (pText[1] & 0x0F);
                uint32 month = (pText[2] >> 4) * 10   + (pText[2] & 0x0F);
                uint32 day   = (pText[3] >> 4) * 10   + (pText[3] & 0x0F);

                if ((pText[0] == 0) && (pText[1] == 0)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DATE_LENGTH, 0, 0, pBadField);

                    goto DB2Z_ZERO_YEAR;
                } else if (((pText[0] >> 4) > 9) || ((pText[0] & 0x0F) > 9) || ((pText[1] >> 4) > 9) || ((pText[1] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DATE_LENGTH, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (pText[2] == 0) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DATE_LENGTH, 0, 0, pBadField);

                    goto ZERO_MONTH;
                } else if (((pText[2] >> 4) > 9) || ((pText[2] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DATE_LENGTH, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (month > 12) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DATE_LENGTH, 0, 0, pBadField);

                    goto MONTH_TOO_LARGE;
                }

                if (pText[3] == 0) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DATE_LENGTH, 0, 0, pBadField);

                    goto ZERO_DAY;
                } else if (((pText[3] >> 4) > 9) || ((pText[3] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DATE_LENGTH, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (day > 31) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DATE_LENGTH, 0, 0, pBadField);

                    goto DAY_TOO_LARGE_FOR_MONTH;
                }

                int32 yi = yearInfo[year];
                uint32 leapBit = yi & 1;
                month += leapBit * (sizeof(monthInfo.Normal) / sizeof(monthInfo.Normal[0]));
                yi >>= 1;
                day += monthInfo.Normal[month];

                if (day > monthInfo.Normal[month + 1]) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DATE_LENGTH, 0, 0, pBadField);

                    goto DAY_TOO_LARGE_FOR_MONTH;
                }

                yi += day;
                *((int32*)REG_pField) = yi;

                pText += DB2Z_DATE_LENGTH;

                goto NEXT_FIELD;
            }
// ======== DECIMAL/DECIMAL NOT NULL (all precisions) ==========================
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * DECIMAL(<P>, <S>)                             | NUMERIC(<P>, <S>)
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + (<P> >> 1) + 1          | Number of bytes : 4/8/16
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversions:
                * A) <P> == 1?
                *    Single step conversion using Parser::cvtTables.direct
                *
                * B) <P> > 1 common initialization
                *    1. map sign nibble to a conversion table (.pos2 or .neg2)
                *    2. byte count is number of bytes containing 2 nibbles (BCD)
                *    3. init 32 bit running value
                *       a) precision is even -> zero
                *       b) precision is odd  -> significance from low nibble in leading sign byte
                *
                *  - <P> <= 9?
                *    4. skip the leading zero optimization (unlikely to be profitable)
                *    5. [32-bit conversion loop]:
                *       do
                *         a) convert next byte
                *         b) multiply running 32-bit value by 100
                *         c) accumulate conversion error flag in low byte of ctl word
                *         d) add in converted byte to running 32-bit value
                *       while byte count is not exhausted
                *    6. [Epilog]:
                *       if FPF_NEGATE is set then negate the 32-bit value
                *
                *  - <P> <= 18?
                *    4. [Strip leading zeros]:
                *       if sign byte low nibble was significant then advance to 32-bit conversion loop
                *       do
                *         a) convert next byte
                *         b) if converted value is non-zero then advance to 32-bit conversion loop
                *       while byte count is not exhausted
                *       if byte count exhausted then conversion is complete, value is zero
                *    5. [32-bit conversion loop]:
                *       do
                *         a) convert next byte
                *         b) multiply running 32-bit value by 100
                *         c) accumulate conversion error flag in low byte of ctl word
                *         d) add in converted byte to running 32-bit value
                *         e) if value*100+99 would overflow then advance to 64-bit conversion loop
                *       while byte count is not exhausted
                *       if byte count exhausted then proceed to epilog
                *    6. [64-bit conversion loop]:
                *       do
                *         a) convert next byte
                *         b) multiply running 64-bit value by 100
                *         c) accumulate conversion error flag in low byte of ctl word
                *         d) add in converted byte to running 64-bit value
                *       while byte count is not exhausted
                *    7. [Epilog]:
                *       if FPF_NEGATE is set then negate the 64-bit value
                *
                *  - <P> > 18
                *    4. [Strip leading zeros]:
                *       if sign byte low nibble was significant then advance to 32-bit conversion loop
                *       do
                *         a) convert next byte
                *         b) if converted value is non-zero then advance to 32-bit conversion loop
                *       while byte count is not exhausted
                *       if byte count exhausted then conversion is complete, value is zero
                *    5. [32-bit conversion loop]:
                *       do
                *         a) convert next byte
                *         b) multiply running 32-bit value by 100
                *         c) accumulate conversion error flag in low byte of ctl word
                *         d) add in converted byte to running 32-bit value
                *         e) if value*100+99 would overflow then advance to 64-bit conversion loop
                *       while byte count is not exhausted
                *       if byte count exhausted then proceed to epilog
                *    6. [64-bit conversion loop]:
                *       do
                *         a) convert next byte
                *         b) multiply running 64-bit value by 100
                *         c) accumulate conversion error flag in low byte of ctl word
                *         d) add in converted byte to running 64-bit value
                *         e) if value*10000+9999 would overflow && remaining byte count is even then
                *               advance to 96-bit conversion loop
                *       while byte count is not exhausted
                *       if byte count exhausted then proceed to epilog
                *    7. [96-bit conversion loop, two bytes per iteration]:
                *       do
                *         a) convert next two bytes (i.e. range is 0..9999)
                *         b) accumulate conversion error flag in low byte of ctl word
                *         c) multiply running 96-bit value by 10000 and add in converted bytes
                *         d) if value*10000+9999 would overflow then advance to 128-bit conversion loop
                *       while byte count is not exhausted
                *       if byte count exhausted then proceed to epilog
                *    8. [128-bit conversion loop, two bytes per iteration]:
                *       do
                *         a) convert next two bytes (i.e. range is 0..9999)
                *         b) accumulate conversion error flag in low byte of ctl word
                *         c) multiply running 128-bit value by 10000 and add in converted bytes
                *       while byte count is not exhausted
                *    9. [Epilog]:
                *       a) flags.FPF_NEGATE is false -> copy local 128-bit value to output
                *       b) flags.FPF_NEGATE is true  -> copy negated local 128-bit value to output
                *
                *    DECIMAL_CHECK_BYTES optionally incorporates a scheme for identifying
                *    malformed values.  Rather than include the overhead of a conditional
                *    branch within an inner loop all precisions follow a common strategy of
                *    or-ing converted bytes into an error accumulator.  At the end of the
                *    conversion the conditional branch returns to NEXT_FIELD in the most
                *    likely case of no error.
                *
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = +1234567890.0
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 F0 12 34 56 78 90           | Byte sequence: 00 00 00 00 D2 02 96 49
                *                ^^ [0x00: value != NULL]       | [0x00000000499602D2 = +1234567890]
                *                   ^ [0xF = +]                 |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = -1234567890.0
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 0F ED CB A9 87 6F           | Byte sequence: FF FF FF FF 2E FD 69 B6
                *                ^^ [0x00: value != NULL]       | [0xFFFFFFFFB669FD2E = -1234567890]
                *                   ^ [0x0 = -]                 |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * c) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00 00 00 00 00           | Byte sequence: 00 00 00 00 00 00 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */

            case DB2N_DECIMAL_1:
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DECIMAL(%u, %u) | LENGTH = %u\n", pCurrentFPC->extra.precAndScale & 0x00FF,
                        pCurrentFPC->extra.precAndScale >> 8, DB2Z_NULL_HEADER_LENGTH + ((pCurrentFPC->extra.precAndScale & 0x00FF) >> 1) + 1);
#endif

                if (*pText) {
                    goto NULL_4_BYTES;
                }

                pText += DB2Z_NULL_HEADER_LENGTH;
                // no break
            case DB2_DECIMAL_1: {
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DECIMAL(%u, %u) NOT NULL | LENGTH = %u\n", pCurrentFPC->extra.precAndScale & 0x00FF,
                        pCurrentFPC->extra.precAndScale >> 8, ((pCurrentFPC->extra.precAndScale & 0x00FF) >> 1) + 1);
#endif

                int w0 = cvtTables.direct[*pText++];
                *((int32*)REG_pField + 0) = w0;
#if DECIMAL_CHECK_BYTES
                if (w0 != -128) {
                    goto NEXT_FIELD;
                }

                setBadFieldData(badField, badStr, pText, pEnd, -1, 1, 0, 0, pBadField);

                goto DB2Z_INVALID_BCD;
#else
                goto NEXT_FIELD;
#endif
            }

            case DB2N_DECIMAL_2_9:
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DECIMAL(%u, %u) | LENGTH = %u\n", pCurrentFPC->extra.precAndScale & 0x00FF,
                        pCurrentFPC->extra.precAndScale >> 8, DB2Z_NULL_HEADER_LENGTH + ((pCurrentFPC->extra.precAndScale & 0x00FF) >> 1) + 1);
#endif

                if (*pText) {
                    goto NULL_4_BYTES;
                }

                pText += DB2Z_NULL_HEADER_LENGTH;
                // no break
            case DB2_DECIMAL_2_9: {
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DECIMAL(%u, %u) NOT NULL | LENGTH = %u\n", pCurrentFPC->extra.precAndScale & 0x00FF,
                        pCurrentFPC->extra.precAndScale >> 8, ((pCurrentFPC->extra.precAndScale & 0x00FF) >> 1) + 1);
#endif

                unsigned byte0 = *pText++;              // Sign flag in high nibble
                uint8 const* cvtTbl = cvtTables.neg2;   // Initially assume negative
                cvtTbl += (byte0 & 0x80) * ((cvtTables.pos2 - cvtTables.neg2) / 0x80);

                unsigned w0 = 0;
                unsigned ctl = pCurrentFPC->extra2.decimalControl;

                if (pCurrentFPC->extra.precAndScale & 1) { // Significant nibble when odd
                    w0 = (cvtTbl + (cvtTables.pos1 - cvtTables.pos2))[byte0];
#if DECIMAL_CHECK_BYTES
                    ctl |= w0;
#endif
                }

                unsigned tmp;

                asm ("1:\n"
                    "	movzbl	(%[pText]),%[tmp]\n"    // Fetch 2 nibbles
                    "	imull	$100,%[w0],%[w0]\n"     // Scale running value by 100
                    "	lea	1(%[pText]),%[pText]\n"     // Increment address
                    "	movzbl	(%[cvtTbl],%[tmp]),%[tmp]\n"// Convert nibbles to binary
#if DECIMAL_CHECK_BYTES
                    "	orl	%[tmp],%[ctl]\n"            // Accumulate for final check
#endif
                    "	addl	%[tmp],%[w0]\n"         // Add in converted byte
                    "	addl	$0xffffff00,%[ctl]\n"   // Decrement remaining bytes
                    "	jc	1b\n"                       //  c: length not yet exhausted
                    "	movl	%[w0],%[tmp]\n"         // Scratch copy of w0
                    "	negl	%[tmp]\n"               // tmp = -w0
                    "	testl	$0x80,%[byte0]\n"       // Negative value?
                    "	cmovzl	%[tmp],%[w0]"           //  z: yes, set negate w0

                    : [pText]   "+S" (pText)
                    , [w0]      "+r" (w0)
                    , [ctl]     "+r" (ctl)
                    , [tmp]    "=&r" (tmp)
                    : [cvtTbl]   "r" (cvtTbl)
                    , [byte0]    "g" (byte0)
                    : "cc"
                    );

                *((int32*)REG_pField + 0) = w0;

#if DECIMAL_CHECK_BYTES
                if (!(ctl & 0x80)) {
                    goto NEXT_FIELD;
                }

                setBadFieldData(badField, badStr, pText, pEnd, -pCurrentFPC->fixedLength, pCurrentFPC->fixedLength, 0, 0, pBadField);

                goto DB2Z_INVALID_BCD;
#else
                goto NEXT_FIELD;
#endif
            }

            case DB2N_DECIMAL_10_18:
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DECIMAL(%u, %u) | LENGTH = %u\n", pCurrentFPC->extra.precAndScale & 0x00FF,
                        pCurrentFPC->extra.precAndScale >> 8, DB2Z_NULL_HEADER_LENGTH + ((pCurrentFPC->extra.precAndScale & 0x00FF) >> 1) + 1);
#endif

                if (*pText) {
                    goto NULL_8_BYTES;
                }

                pText += DB2Z_NULL_HEADER_LENGTH;
                // no break
            case DB2_DECIMAL_10_18: {
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DECIMAL(%u, %u) NOT NULL | LENGTH = %u\n", pCurrentFPC->extra.precAndScale & 0x00FF,
                        pCurrentFPC->extra.precAndScale >> 8, ((pCurrentFPC->extra.precAndScale & 0x00FF) >> 1) + 1);
#endif

                unsigned byte0 = *pText++;              // Sign flag in high nibble
#define cvtTbl REG_pField                               // "borrowed" REG_pField's EDI
                uint8* pField_sav = REG_pField;
                cvtTbl = cvtTables.neg2;                // Initially assume negative
                cvtTbl += (byte0 & 0x80) * ((cvtTables.pos2 - cvtTables.neg2) / 0x80);

                unsigned w0 = 0;
                unsigned w1 = 0;
                unsigned ctl = pCurrentFPC->extra2.decimalControl;

                if (pCurrentFPC->extra.precAndScale & 1) { // Significant nibble when odd
                    w0 = (cvtTbl + (cvtTables.pos1 - cvtTables.pos2))[byte0];
#if DECIMAL_CHECK_BYTES
                    ctl |= w0;
#endif
                }
#undef cvtTbl

                unsigned tmp;
                unsigned static const upShift100 = (((unsigned)0xffffffff - 100) / 100);

                asm (
#define cvtTbl "%[REG_pField]"
                       "testl	%[w0],%[w0]\n"              // Any significance in sign byte?
                    "	jnz	2f\n"                           //  nz: yes, no zeros to strip

                    // Strip nibble pairs having no significance
                    "1:\n"
                    "	movzbl	(%[pText]),%[tmp]\n"        // Fetch 2 nibbles
                    "	lea	1(%[pText]),%[pText]\n"         // Increment address
                    "	movzbl	("cvtTbl",%[tmp]),%[w0]\n"  // Convert nibbles to binary; init w0
                    "	testl	%[w0],%[w0]\n"              // Any significance?
                    "	jnz	3f\n"                           //  nz: yes, stop stripping zeros
                    "	addl	$0xffffff00,%[ctl]\n"       // Decrement remaining length
                    "	jc	1b\n"                           //  c: length not yet exhausted
                    "	jmp	6f\n"                           // Value was entirely zero

                    "2:\n"
                    "	addl	$0x100,%[ctl]\n"            // Inc length for sign byte significance
                    "3:\n"
#if DECIMAL_CHECK_BYTES
                    "	orl	%[w0],%[ctl]\n"                 // Inital check accumulator
#endif
                    "	addl	$0xffffff00,%[ctl]\n"       // Decrement remaining length
                    "	jnc	6f\n"                           //  nc: length exhausted

                    // Accumulate into a single register
                    "4:\n"
                    "	movzbl	(%[pText]),%[tmp]\n"        // Fetch 2 nibbles
                    "	imull	$100,%[w0],%[w0]\n"
                    "	lea	1(%[pText]),%[pText]\n"         // Increment address
                    "	movzbl	("cvtTbl",%[tmp]),%[tmp]\n" // Convert nibbles to binary
#if DECIMAL_CHECK_BYTES
                    "	orl	%[tmp],%[ctl]\n"                // Accumulate for final check
#endif
                    "	addl	%[tmp],%[w0]\n"
                    "	addl	$0xffffff00,%[ctl]\n"       // Decrement remaining length
                    "	jnc	6f\n"                           //  nc: length exhausted
                    "	cmpl	%[upShift100],%[w0]\n"      // Time to up-shift to 2 registers?
                    "	jc	4b\n"                           //  c: no, can still accommodate *100

                    // Accumulate into a register pair (w1:w0)
                    "5:\n"
                    "	movl	$100,%[tmp]\n"              // (%[tmp] is also EDX)
                    "	imull	%[tmp],%[w1]\n"             // w1 = 100*w1
                    "	mull	%[tmp]\n"                   // edx:w0 = 100*w0
                    "	addl	%%edx,%[w1]\n"              // Sum high order components
                    "	movzbl	(%[pText]),%[tmp]\n"        // Fetch 2 nibbles
                    "	lea	1(%[pText]),%[pText]\n"         // Increment address
                    "	movzbl	("cvtTbl",%[tmp]),%[tmp]\n" // Convert nibbles to binary
#if DECIMAL_CHECK_BYTES
                    "	orl	%[tmp],%[ctl]\n"                // Accumulate for final check
#endif
                    "	addl	%[tmp],%[w0]\n"             // Add converted nibbles to low order
                    "	adcl	$0,%[w1]\n"                 // Propagate carry to high order
                    "	addl	$0xffffff00,%[ctl]\n"       // Decrement remaining length
                    "	jc	5b\n"                           //  c: length not yet exhausted

                    // Epilog
                    "6:\n"
                    "	testl	$0x80,%[byte0]\n"           // Negative value?
                    "	mov	%[pField_sav],%[REG_pField]\n"  //  (cvtTbl "borrowed" REG_pField's EDI)
                    "	jnz	7f\n"                           //  nz: no
                    "	negl	%[w1]\n"                    // Complement and increment high order
                    "	negl	%[w0]\n"                    // Complement and increment low order
                    "	sbbl	$0,%[w1]\n"                 // Conditionaly rescind high increment
                    "7:"
#undef cvtTbl
                    : [w0]         "+a" (w0)
                    , [tmp]       "=&d" (tmp)
                    , [pText]      "+S" (pText)
                    , [REG_pField] "+D" (REG_pField)
                    , [w1]         "+r" (w1)
                    , [ctl]        "+r" (ctl)
                    : [byte0]       "m" (byte0)
                    , [pField_sav]  "m" (pField_sav)
                    , [upShift100]  "i" (upShift100)
                    : "cc"
                    );

                *((int32*)REG_pField + 0) = w1;
                *((int32*)REG_pField + 1) = w0;

#if DECIMAL_CHECK_BYTES
                if (!(ctl & 0x80)) {
                    goto NEXT_FIELD;
                }

                setBadFieldData(badField, badStr, pText, pEnd, -pCurrentFPC->fixedLength, pCurrentFPC->fixedLength, 0, 0, pBadField);

                goto DB2Z_INVALID_BCD;
#else
                goto NEXT_FIELD;
#endif
            }

            case DB2N_DECIMAL_19_38:
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DECIMAL(%u, %u) | LENGTH = %u\n", pCurrentFPC->extra.precAndScale & 0x00FF,
                        pCurrentFPC->extra.precAndScale >> 8, DB2Z_NULL_HEADER_LENGTH + ((pCurrentFPC->extra.precAndScale & 0x00FF) >> 1) + 1);
#endif

                if (*pText) {
                    goto NULL_16_BYTES;
                }

                pText += DB2Z_NULL_HEADER_LENGTH;
                // no break
            case DB2_DECIMAL_19_38: {
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DECIMAL(%u, %u) NOT NULL | LENGTH = %u\n", pCurrentFPC->extra.precAndScale & 0x00FF,
                        pCurrentFPC->extra.precAndScale >> 8, ((pCurrentFPC->extra.precAndScale & 0x00FF) >> 1) + 1);
#endif

                unsigned byte0 = *pText++;              // Sign flag in high nibble
#define cvtTbl REG_pField                               // "borrowed" REG_pField's EDI
                uint8* pField_sav = REG_pField;
                cvtTbl = cvtTables.neg2;                // Initially assume negative
                cvtTbl += (byte0 & 0x80) * ((cvtTables.pos2 - cvtTables.neg2) / 0x80);

                unsigned w0 = 0;
                unsigned w1 = 0;
                unsigned ctl = pCurrentFPC->extra2.decimalControl;

                if (pCurrentFPC->extra.precAndScale & 1) { // Significant nibble when odd
                    w0 = (cvtTbl + (cvtTables.pos1 - cvtTables.pos2))[byte0];
#if DECIMAL_CHECK_BYTES
                    ctl |= w0;
#endif
                }
#undef cvtTbl

                unsigned tmp;
                unsigned static const upShift100   = (((unsigned)0xffffffff -   100) /   100);
                unsigned static const upShift10000 = (((unsigned)0xffffffff - 10000) / 10000) - 1;
                unsigned k10000 = 10000; // gcc gets operand wrong if declared "static const"
                struct MemoryWorkArea { unsigned hi, hl, lh, lo; } mem = { 0, 0, 0, 0 };

                asm (
#define cvtTbl "%[REG_pField]"
                       "testl	%[w0],%[w0]\n"              // Any significance in sign byte?
                    "	jnz	2f\n"                           //  nz: yes, no zeros to strip

                    // LOOP: strip nibble pairs having no significance
                    "1:\n"
                    "	movzbl	(%[pText]),%[tmp]\n"        // Fetch 2 nibbles
                    "	lea	1(%[pText]),%[pText]\n"         // Increment address
                    "	movzbl	("cvtTbl",%[tmp]),%[w0]\n"  // Convert nibbles to binary; init w0
                    "	testl	%[w0],%[w0]\n"              // Any significance?
                    "	jnz	3f\n"                           //  nz: yes, stop stripping zeros
                    "	addl	$0xffffff00,%[ctl]\n"       // Decrement remaining length
                    "	jc	1b\n"                           //  c: length not yet exhausted
                    "	jmp	8f\n"                           // Value was entirely zero

                    "2:\n"
                    "	addl	$0x100,%[ctl]\n"            // Inc length for sign byte significance
                    "3:\n"
#if DECIMAL_CHECK_BYTES
                    "	orl	%[w0],%[ctl]\n"                 // Inital check accumulator
#endif
                    "	addl	$0xffffff00,%[ctl]\n"       // Decrement remaining length
                    "	jnc	8f\n"                           //  nc: length exhausted

                    // LOOP: accumulate one byte (2 nibbles) into a single register
                    "4:\n"
                    "	movzbl	(%[pText]),%[tmp]\n"        // Fetch 2 nibbles
                    "	imull	$100,%[w0],%[w0]\n"
                    "	lea	1(%[pText]),%[pText]\n"         // Increment address
                    "	movzbl	("cvtTbl",%[tmp]),%[tmp]\n" // Convert nibbles to binary
#if DECIMAL_CHECK_BYTES
                    "	orl	%[tmp],%[ctl]\n"                // Accumulate for final check
#endif
                    "	addl	%[tmp],%[w0]\n"
                    "	addl	$0xffffff00,%[ctl]\n"       // Decrement remaining length
                    "	jnc	8f\n"                           //  nc: length exhausted
                    "	cmpl	%[upShift100],%[w0]\n"      // Time to up-shift to 2 registers?
                    "	jc	4b\n"                           //  c: no, can still accommodate *100

                    // LOOP: accumulate one byte (2 nibbles) into a register pair (w1:w0)
                    "5:\n"
                    "	movl	$100,%[tmp]\n"              // (%[tmp] is also EDX)
                    "	imull	%[tmp],%[w1]\n"             // w1 = 100*w1
                    "	mull	%[tmp]\n"                   // edx:w0 = 100*w0
                    "	addl	%%edx,%[w1]\n"              // Sum high order components
                    "	movzbl	(%[pText]),%[tmp]\n"        // Fetch 2 nibbles
                    "	lea	1(%[pText]),%[pText]\n"         // Increment address
                    "	movzbl	("cvtTbl",%[tmp]),%[tmp]\n" // Convert nibbles to binary
#if DECIMAL_CHECK_BYTES
                    "	orl	%[tmp],%[ctl]\n"                // Accumulate for final check
#endif
                    "	addl	%[tmp],%[w0]\n"             // Add converted nibbles to low order
                    "	adcl	$0,%[w1]\n"                 // Propagate carry to high order
                    "	addl	$0xffffff00,%[ctl]\n"       // Decrement remaining length
                    "	jnc	8f\n"                           //  nc: length exhausted
                    "	cmpl	%[upShift10000],%[w1]\n"    // Time to up-shift to 3 registers?
                    "	jc	5b\n"                           //  c: no, can still accommodate * 10000
                    "	test	$0x100,%[ctl]\n"            // Is unbiased length even?
                    "	jz	5b\n"                           //  z: no, accumulate one more byte

                    // Switch to values in memory
                    "	movl	%[w0],%[w0m]\n"
                    "	movl	%[w1],%[w1m]\n"

                    // LOOP: accumulate two bytes (4 nibbles) into a memory triple (w2m:w1m:w0m)
                    "6:\n"
                    "	movzbl	(%[pText]),%[hi]\n"         // Fetch 2 nibbles
                    "	movzbl	1(%[pText]),%[tmp]\n"       // Fetch 2 nibbles
                    "	movzbl	("cvtTbl",%[hi]),%[hi]\n"   // Convert nibbles to binary
                    "	movzbl	("cvtTbl",%[tmp]),%[tmp]\n" // Convert nibbles to binary
#if DECIMAL_CHECK_BYTES
                    "	orl	%[hi],%[ctl]\n"                 // Accumulate for final check
                    "	orl	%[tmp],%[ctl]\n"                // Accumulate for final check
#endif
                    "	imull	$100,%[hi],%[hi]\n"         // Scale converted high nibbles
                    "	lea	2(%[pText]),%[pText]\n"         // Increment address
                    "	addl	%[tmp],%[hi]\n"             // Combine high and low parts into %[hi]

                    // -- Multiply w2m:w1m:w0m by 10000; add %[hi] to w0m and propagate carry
                    "	movl	%[w0m],%%eax\n"
                    "	mull	%[k10000]\n"
                    "	addl	%[hi],%%eax\n"
                    "	movl	%%edx,%[hi]\n"
                    "	movl	%%eax,%[w0m]\n"
                    "	rcll	%[ctl]\n"
                    "	movl	%[w1m],%%eax\n"
                    "	mull	%[k10000]\n"
                    "	shrl	%[ctl]\n"
                    "	adcl	%[hi],%%eax\n"
                    "	movl	%%eax,%[w1m]\n"
                    "	rcll	%[ctl]\n"
                    "	movl	%[w2m],%%eax\n"
                    "	imull	%[k10000],%%eax\n"
                    "	shrl	%[ctl]\n"
                    "	adcl	%%edx,%%eax\n"
                    "	movl	%%eax,%[w2m]\n"

                    "	addl	$0xfffffe00,%[ctl]\n"       // Decrement remaining length by 2
                    "	jnc	9f\n"                           //  nc: length exhausted
                    "	cmpl	%[upShift10000],%%eax\n"    // Time to up-shift to 4 regs?
                    "	jc	6b\n"                           //  c: no, can still accommodate * 10000

                    // Accumulate two bytes (4 nibbles) into a memory quad (w3m:w2m:w1m:w0m)
                    "7:\n"
                    "	movzbl	(%[pText]),%[hi]\n"         // Fetch 2 nibbles
                    "	movzbl	1(%[pText]),%[tmp]\n"       // Fetch 2 nibbles
                    "	movzbl	("cvtTbl",%[hi]),%[hi]\n"   // Convert nibbles to binary
                    "	movzbl	("cvtTbl",%[tmp]),%[tmp]\n" // Convert nibbles to binary
#if DECIMAL_CHECK_BYTES
                    "	orl	%[hi],%[ctl]\n"                 // Accumulate for final check
                    "	orl	%[tmp],%[ctl]\n"                // Accumulate for final check
#endif
                    "	imull	$100,%[hi],%[hi]\n"         // Scale converted high nibbles
                    "	lea	2(%[pText]),%[pText]\n"         // Increment address
                    "	addl	%[tmp],%[hi]\n"             // Combine high and low parts into %[hi]

                    // -- Multiply w3m:w2m:w1m:w0m by 10000; add %[hi] to w0m and propagate carry
                    "	movl	%[w0m],%%eax\n"
                    "	mull	%[k10000]\n"
                    "	addl	%[hi],%%eax\n"
                    "	movl	%%edx,%[hi]\n"
                    "	movl	%%eax,%[w0m]\n"
                    "	rcll	%[ctl]\n"
                    "	movl	%[w1m],%%eax\n"
                    "	mull	%[k10000]\n"
                    "	shrl	%[ctl]\n"
                    "	adcl	%[hi],%%eax\n"
                    "	movl	%%edx,%[hi]\n"
                    "	movl	%%eax,%[w1m]\n"
                    "	rcll	%[ctl]\n"
                    "	movl	%[w2m],%%eax\n"
                    "	mull	%[k10000]\n"
                    "	shrl	%[ctl]\n"
                    "	adcl	%[hi],%%eax\n"
                    "	movl	%%eax,%[w2m]\n"
                    "	rcll	%[ctl]\n"
                    "	movl	%[w3m],%%eax\n"
                    "	imull	%[k10000],%%eax\n"
                    "	shrl	%[ctl]\n"
                    "	adcl	%%edx,%%eax\n"
                    "	movl	%%eax,%[w3m]\n"

                    "	addl	$0xfffffe00,%[ctl]\n"       // Decrement remaining length by 2
                    "	jc	7b\n"                           //  c: length not yet exhausted
                    "	jmp	9f\n"

                    // Move w0 and w1 to memory work area
                    "8:\n"
                    "	movl	%[w0],%[w0m]\n"
                    "	movl	%[w1],%[w1m]\n"

                    "9:\n"
                    "	testl	$0x80,%[byte0]\n"           // Negative value?
                    "	mov	%[pField_sav],%[REG_pField]\n"  //  (cvtTbl "borrowed" REG_pField)
                    "	jnz	10f\n"                          //  nz: no

                    // -- Copy memory workspace to result area with on the fly negation
                    "	movl	$0,%%eax\n"
                    "	subl	%[w0m],%%eax\n"
                    "	movl	%%eax,12(%[REG_pField])\n"
                    "	movl	$0,%%eax\n"
                    "	sbbl	%[w1m],%%eax\n"
                    "	movl	%%eax,8(%[REG_pField])\n"
                    "	movl	$0,%%eax\n"
                    "	sbbl	%[w2m],%%eax\n"
                    "	movl	%%eax,4(%[REG_pField])\n"
                    "	movl	$0,%%eax\n"
                    "	sbbl	%[w3m],%%eax\n"
                    "	jmp	11f\n"

                    // -- Straight copy memory workspace to result area
                    "10:\n"
                    "	movl	%[w0m],%%eax\n"
                    "	movl	%%eax,12(%[REG_pField])\n"
                    "	movl	%[w1m],%%eax\n"
                    "	movl	%%eax,8(%[REG_pField])\n"
                    "	movl	%[w2m],%%eax\n"
                    "	movl	%%eax,4(%[REG_pField])\n"
                    "	movl	%[w3m],%%eax\n"
                    "11:\n"
                    "	movl	%%eax,(%[REG_pField])"
#undef cvtTbl
                    : [w0]          "+a" (w0)
                    , [tmp]        "=&d" (tmp)
                    , [pText]       "+S" (pText)
                    , [REG_pField]  "+D" (REG_pField)
                    , [hi]          "=r" (w1)
                    , [ctl]         "+r" (ctl)
                    : [w1]           "4" (w1)
                    , [byte0]        "m" (byte0)
                    , [w3m]          "m" (mem.hi)
                    , [w2m]          "m" (mem.hl)
                    , [w1m]          "m" (mem.lh)
                    , [w0m]          "m" (mem.lo)
                    , [pField_sav]   "m" (pField_sav)
                    , [k10000]       "m" (k10000)
                    , [upShift100]   "i" (upShift100)
                    , [upShift10000] "i" (upShift10000)
                    : "cc"
                    );

#if DECIMAL_CHECK_BYTES
                if (!(ctl & 0x80)) {
                    goto NEXT_FIELD;
                }

                setBadFieldData(badField, badStr, pText, pEnd, -pCurrentFPC->fixedLength, pCurrentFPC->fixedLength, 0, 0, pBadField);

                goto DB2Z_INVALID_BCD;
#else
                goto NEXT_FIELD;
#endif
            }
// ======== DOUBLE =============================================================
            case DB2N_DOUBLE: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * DOUBLE                                        | DOUBLE
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + 8                       | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. interpret value as uint64 and reverse byte order
                * 2. process hexadecimal floating-point values that represent zero
                * 3. if most significant bit is set, invert the bit; otherwise, invert all bits
                * 4. convert hexadecimal floating-point number into IEEE 754 floating-point number
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = +0.5
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 C0 80 00 00 00 00 00 00     | Byte sequence: 3F E0 00 00 00 00 00 00
                *                ^^ [0x00: value != NULL]       |
                *                   ^ [MSB is set]              |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00 00 00 00 00 00 00     | Byte sequence: 00 00 00 00 00 00 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DOUBLE (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n",
                        pText[0], pText[1], pText[2], pText[3], pText[4], pText[5], pText[6], pText[7], pText[8]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_DOUBLE_LENGTH_NULLABLE <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto DOUBLE_CONVERSION;
                }

                *(reinterpret_cast<uint64*>(REG_pField)) = 0;
                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += DB2Z_DOUBLE_LENGTH_NULLABLE;

                goto NEXT_FIELD;
            }
// ======== DOUBLE NOT NULL ====================================================
            case DB2_DOUBLE: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * DOUBLE NOT NULL                               | DOUBLE NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 8                           | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. interpret value as uint64 and reverse byte order
                * 2. process hexadecimal floating-point values that represent zero
                * 3. if most significant bit is set, invert the bit; otherwise, invert all bits
                * 4. convert hexadecimal floating-point number into IEEE 754 floating-point number
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = +0.5
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: C0 80 00 00 00 00 00 00        | Byte sequence: 3F E0 00 00 00 00 00 00
                *                ^ [MSB is set]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : DOUBLE NOT NULL (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0],
                        pText[1], pText[2], pText[3], pText[4], pText[5], pText[6], pText[7]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_DOUBLE_LENGTH <= REG_pEnd);
#endif

            DOUBLE_CONVERSION:
                uint64 fraction = bswap_64(*(reinterpret_cast<uint64 const*>(pText)));

                // zero? (0x7FFFFFFFFFFFFFFF = -0; 0x8000000000000000ULL = +0 (true zero); 0xC000000000000000ULL was seen at customer)
                if ((fraction == 0x7FFFFFFFFFFFFFFFULL) || (fraction == 0x8000000000000000ULL) || (fraction == 0xC000000000000000ULL)) {
                    *(reinterpret_cast<uint64*>(REG_pField)) = 0;
                } else {
                    if ((fraction & 0x8000000000000000ULL) == 0x8000000000000000ULL) {
                        fraction = fraction & 0x7FFFFFFFFFFFFFFFULL;
                        *(reinterpret_cast<uint64*>(REG_pField)) = 0x0000000000000000ULL; // initialization
                    } else {
                        fraction = ~fraction;
                        *(reinterpret_cast<uint64*>(REG_pField)) = 0x8000000000000000ULL; // set sign bit to 1
                    }

                    // move out sign
                    fraction <<= 1;

                    int16 exponent = fraction >> 57;

                    // move out exponent
                    fraction <<= 7;

                    // calculate exponent because bias is different
                    exponent = (exponent << 2) + 766;

                    // prevent infinite while loop due to corrupted input data
                    if (fraction == 0) {
                        setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_DOUBLE_LENGTH, 0, 0, pBadField);

                        goto DB2Z_INVALID_REAL_DOUBLE;
                    }

                    // normalize
                    while (fraction < 0x8000000000000000ULL) {
                        --exponent;
                        fraction <<= 1;
                    }

                    fraction <<= 1;

                    *(reinterpret_cast<uint64*>(REG_pField)) |= (static_cast<uint64>(exponent) << 52) | (fraction >> 12);
                }

                pText += DB2Z_DOUBLE_LENGTH;

                goto NEXT_FIELD;
            }
// ======== GRAPHIC ============================================================
            case DB2N_GRAPHIC: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * GRAPHIC(<P>)                                  | NVARCHAR(<P>)
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : varying-length
                * Number of bytes : 1 + 2 * <P>                 | Number of bytes : 2 + [<P> ... 4 * <P>]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * - ICU conversion
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 5, value = U+0041 + U+00AE + U+20AC + U+1D11E | CCSID: 1200 (UTF-16)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * 00 00 41 00 AE 20 AC D8 34 DD 1E              | 0C 00 41 C2 AE E2 82 AC F0 9D 84 9E
                * ^^ [0x00: value != NULL]                      | ^^^^^ [Length: 0x000C = 12]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: <P> = 5, value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * FF 00 00 00 00 00 00 00 00 00 00              | 02 00
                * ^^ [0xFF: value = NULL]                       | ^^^^^ [Length: 0x0002 = 2]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : GRAPHIC(%u)\n", pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLengthNULL <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto GRAPHIC_CONVERSION;
                }

                REG_pField = pVarying;

                // align length to even address
                if (reinterpret_cast<size_t>(REG_pField) & 1) {
                    *REG_pField++ = 0;
                }

                // set length
                *(reinterpret_cast<vlen_t*>(REG_pField)) = sizeof(vlen_t);
                // update pointers
                REG_pField += sizeof(vlen_t);
                pVarying = REG_pField;

                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += pCurrentFPC->fixedLengthNULL;

                goto NEXT_FIELD;
            }
// ======== GRAPHIC NOT NULL ===================================================
            case DB2_GRAPHIC: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * GRAPHIC(<P>) NOT NULL                         | NVARCHAR(<P>) NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : varying-length
                * Number of bytes : 2 * <P>                     | Number of bytes : 2 + [<P> ... 4 * <P>]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * - ICU conversion
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: <P> = 5, value = U+0041 + U+00AE + U+20AC + U+1D11E | CCSID: 1200 (UTF-16)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence:
                * 00 41 00 AE 20 AC D8 34 DD 1E                 | 0C 00 41 C2 AE E2 82 AC F0 9D 84 9E
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : GRAPHIC(%u) NOT NULL\n", pCurrentFPC->extra.precAndScale);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLength <= REG_pEnd);
#endif

            GRAPHIC_CONVERSION:
                REG_pField = pVarying;

                // align length to even address
                if (reinterpret_cast<size_t>(REG_pField) & 1) {
                    *REG_pField++ = 0;
                }

                ICUConverter* converter = (*copyIn->m_converters)[pCurrentFPC->extra2.ccsid];

                NZ_VERIFY(converter != NULL);

                int32 outputLength;
                ptrdiff_t targetBufferLength = &recordBuffer.bytes[MAX_RECORD_SIZE - 1] - REG_pField + sizeof(vlen_t);

                if (pCurrentFPC->extra2.ccsid == ICUConverter::CCSID_UTF16) {
                    outputLength = converter->convert(pText, pCurrentFPC->fixedLength, REG_pField + sizeof(vlen_t), targetBufferLength);
                } else {
                    outputLength = converter->convertReplaceIdeographicSpaces(pText, pCurrentFPC->fixedLength, REG_pField + sizeof(vlen_t),
                            targetBufferLength);
                }

                // set length
                *(reinterpret_cast<vlen_t*>(REG_pField)) = sizeof(vlen_t) + outputLength;
                // update pointers
                REG_pField += sizeof(vlen_t) + outputLength;
                pVarying = REG_pField;

                pText += pCurrentFPC->fixedLength;

                goto NEXT_FIELD;
            }
// ======== INT ================================================================
            case DB2N_INT: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * INT                                           | INT
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + 4                       | Number of bytes : 4
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. invert most significant bit of first byte
                * 2. reverse byte order
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = -32768
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 7F FF 80 00                 | Byte sequence: 00 80 FF FF
                *                ^^ [0x00: value != NULL]       |
                *                   ^^ [0x7F ^ 0x80 = 0xFF]     |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00 00 00                 | Byte sequence: 00 00 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : INT (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2], pText[3],
                        pText[4]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_INT_LENGTH_NULLABLE <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto INT_CONVERSION;
                }

                *(reinterpret_cast<int32*>(REG_pField)) = 0;
                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += DB2Z_INT_LENGTH_NULLABLE;

                goto NEXT_FIELD;
            }
// ======== INT NOT NULL =======================================================
            case DB2_INT: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * INT NOT NULL                                  | INT NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 4                           | Number of bytes : 4
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. invert most significant bit of first byte
                * 2. reverse byte order
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = -32768
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 7F FF 80 00                    | Byte sequence: 00 80 FF FF
                *                ^^ [0x7F ^ 0x80 = 0xFF]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : INT NOT NULL (0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2], pText[3]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_INT_LENGTH <= REG_pEnd);
#endif

            INT_CONVERSION:
                *(reinterpret_cast<uint32*>(REG_pField)) = bswap_32(*(reinterpret_cast<uint32 const*>(pText)));
                REG_pField[3] ^= 0x80;

                pText += DB2Z_INT_LENGTH;

                goto NEXT_FIELD;
            }
// ======== REAL ===============================================================
            case DB2N_REAL: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * REAL                                          | REAL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + 4                       | Number of bytes : 4
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. interpret value as uint32 and reverse byte order
                * 2. process hexadecimal floating-point values that represent zero
                * 3. if most significant bit is set, invert the bit; otherwise, invert all bits
                * 4. convert hexadecimal floating-point number into IEEE 754 floating-point number
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = +0.5
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 C0 80 00 00                 | Byte sequence: 3F E0 00 00
                *                ^^ [0x00: value != NULL]       |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00 00 00                 | Byte sequence: 00 00 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : REAL (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2], pText[3], pText[4]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_REAL_LENGTH_NULLABLE <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto REAL_CONVERSION;
                }

                *(reinterpret_cast<uint32*>(REG_pField)) = 0;
                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += DB2Z_REAL_LENGTH_NULLABLE;

                goto NEXT_FIELD;
            }
// ======== REAL NOT NULL ======================================================
            case DB2_REAL: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * REAL NOT NULL                                 | REAL NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 4                           | Number of bytes : 4
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. interpret value as uint32 and reverse byte order
                * 2. process hexadecimal floating-point values that represent zero
                * 3. if most significant bit is set, invert the bit; otherwise, invert all bits
                * 4. convert hexadecimal floating-point number into IEEE 754 floating-point number
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = +0.5
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: C0 80 00 00                    | Byte sequence: 3F E0 00 00
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : REAL NOT NULL (0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2], pText[3]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_REAL_LENGTH <= REG_pEnd);
#endif

            REAL_CONVERSION:
                uint32 fraction = bswap_32(*(reinterpret_cast<uint32 const*>(pText)));
                bool isSignedNumber = false;

                // zero? (0x7FFFFFFF = -0; 0x80000000 = +0 (true zero); 0xC0000000 was seen at customer)
                if ((fraction == 0x7FFFFFFF) || (fraction == 0x80000000) || (fraction == 0xC0000000)) {
                    *(reinterpret_cast<uint32*>(REG_pField)) = 0;
                } else {
                    if ((fraction & 0x80000000) == 0x80000000) {
                        fraction = fraction & 0x7FFFFFFF;
                    } else {
                        fraction = ~fraction;
                        isSignedNumber = true;
                    }

                    // move out sign
                    fraction <<= 1;

                    int16 exponent = fraction >> 25;

                    // move out exponent
                    fraction <<= 7;

                    // calculate exponent because bias is different
                    exponent = (exponent << 2) - 130;

                    // prevent infinite while loop due to corrupted input data
                    if (fraction == 0) {
                        setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_REAL_LENGTH, 0, 0, pBadField);

                        goto DB2Z_INVALID_REAL_DOUBLE;
                    }

                    // normalize
                    while (fraction < 0x80000000) {
                        --exponent;
                        fraction <<= 1;
                    }

                    fraction <<= 1;

                    // check if z/OS floating-point number can be converted into IEEE 754 floating-point number
                    if ((exponent & 0xFF00) != 0x0000) {
                        setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_REAL_LENGTH, 0, 0, pBadField);

                        goto DB2Z_UNSUPPORTED_REAL;
                    }

                    if (isSignedNumber == true) {
                        *(reinterpret_cast<uint32*>(REG_pField)) = ((exponent << 23) | (fraction >> 9)) | 0x80000000;
                    } else {
                        *(reinterpret_cast<uint32*>(REG_pField)) = ((exponent << 23) | (fraction >> 9)) & 0x7FFFFFFF;
                    }
                }

                pText += DB2Z_REAL_LENGTH;

                goto NEXT_FIELD;
            }
// ======== REAL_TO_DOUBLE =====================================================
            case DB2N_REAL_TO_DOUBLE: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * REAL                                          | DOUBLE
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + 4                       | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. interpret value as uint32 and reverse byte order
                * 2. process hexadecimal floating-point values that represent zero
                * 3. if most significant bit is set, invert the bit; otherwise, invert all bits
                * 4. convert hexadecimal floating-point number into IEEE 754 floating-point number
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = +0.5
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 C0 80 00 00                 | Byte sequence: 3F E0 00 00
                *                ^^ [0x00: value != NULL]       |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00 00 00                 | Byte sequence: 00 00 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : REAL_TO_DOUBLE (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2], pText[3], pText[4]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_REAL_LENGTH_NULLABLE <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto REAL_TO_DOUBLE_CONVERSION;
                }

                *(reinterpret_cast<uint64*>(REG_pField)) = 0;
                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += DB2Z_REAL_LENGTH_NULLABLE;

                goto NEXT_FIELD;
            }
// ======== REAL_TO_DOUBLE NOT NULL ============================================
            case DB2_REAL_TO_DOUBLE: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * REAL NOT NULL                                 | DOUBLE NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 4                           | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. interpret value as uint32 and reverse byte order
                * 2. process hexadecimal floating-point values that represent zero
                * 3. if most significant bit is set, invert the bit; otherwise, invert all bits
                * 4. convert hexadecimal floating-point number into IEEE 754 floating-point number
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = +0.5
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: C0 80 00 00                    | Byte sequence: 3F E0 00 00
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : REAL_TO_DOUBLE NOT NULL (0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2], pText[3]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_REAL_LENGTH <= REG_pEnd);
#endif

            REAL_TO_DOUBLE_CONVERSION:
                uint32 fraction = bswap_32(*(reinterpret_cast<uint32 const*>(pText)));

                // zero? (0x7FFFFFFF = -0; 0x80000000 = +0 (true zero); 0xC0000000 was seen at customer)
                if ((fraction == 0x7FFFFFFF) || (fraction == 0x80000000) || (fraction == 0xC0000000)) {
                    *(reinterpret_cast<uint64*>(REG_pField)) = 0;
                } else {
                    if ((fraction & 0x80000000) == 0x80000000) {
                        fraction = fraction & 0x7FFFFFFF;
                        *(reinterpret_cast<uint64*>(REG_pField)) = 0x0000000000000000ULL; // initialization
                    } else {
                        fraction = ~fraction;
                        *(reinterpret_cast<uint64*>(REG_pField)) = 0x8000000000000000ULL; // set sign bit to 1
                    }

                    // move out sign
                    fraction <<= 1;

                    int16 exponent = fraction >> 25;

                    // move out exponent
                    fraction <<= 7;

                    // calculate exponent because bias is different
                    exponent = (exponent << 2) + 766; // DOUBLE

                    // prevent infinite while loop due to corrupted input data
                    if (fraction == 0) {
                        setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_REAL_LENGTH, 0, 0, pBadField);

                        goto DB2Z_INVALID_REAL_DOUBLE;
                    }

                    // normalize
                    while (fraction < 0x80000000) {
                        --exponent;
                        fraction <<= 1;
                    }

                    fraction <<= 1;

                    // fraction positioning in IEEE 754:
                    // DOUBLE (64 bit) to DOUBLE (64 bit): (fraction >> 12)
                    // REAL   (32 bit) to DOUBLE (64 bit): (static_cast<uint64>(fraction) << 20) [<< 32 >> 12 = << 20]
                    *(reinterpret_cast<uint64*>(REG_pField)) |= (static_cast<uint64>(exponent) << 52) | (static_cast<uint64>(fraction) << 20);
                }

                pText += DB2Z_REAL_LENGTH;

                goto NEXT_FIELD;
            }
// ======== SMALLINT ===========================================================
            case DB2N_SMALLINT: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * SMALLINT                                      | SMALLINT
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + 2                       | Number of bytes : 2
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. invert most significant bit of first byte
                * 2. reverse byte order
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = -32768
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 00 00                       | Byte sequence: 00 80
                *                ^^ [0x00: value != NULL]       |
                *                   ^^ [0x00 ^ 0x80 = 0x80]     |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00                       | Byte sequence: 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : SMALLINT (0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_SMALLINT_LENGTH_NULLABLE <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto SMALLINT_CONVERSION;
                }

                *(reinterpret_cast<int16*>(REG_pField)) = 0;
                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += DB2Z_SMALLINT_LENGTH_NULLABLE;

                goto NEXT_FIELD;
            }
// ======== SMALLINT NOT NULL ==================================================
            case DB2_SMALLINT: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * SMALLINT NOT NULL                             | SMALLINT NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 2                           | Number of bytes : 2
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. invert most significant bit of first byte
                * 2. reverse byte order
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = -32768
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 00                          | Byte sequence: 00 80
                *                ^^ [0x00 ^ 0x80 = 0x80]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : SMALLINT NOT NULL (0x%02X 0x%02X)\n", pText[0], pText[1]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_SMALLINT_LENGTH <= REG_pEnd);
#endif

            SMALLINT_CONVERSION:
                *(reinterpret_cast<uint16*>(REG_pField)) = bswap_16(*(reinterpret_cast<uint16 const*>(pText)));
                REG_pField[1] ^= 0x80;

                pText += DB2Z_SMALLINT_LENGTH;

                goto NEXT_FIELD;
            }
// ======== TIME ===============================================================
            case DB2N_TIME: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * TIME                                          | TIME
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + 3                       | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. convert time (encoded as BCD) to microseconds since midnight
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = 23:59:59
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 00 23 59 59                    | Byte sequence: C0 1D C8 1D 14 00 00 00
                *                ^^ [0x00: value != NULL]       | [0x000000141DC81DC0 = 86399000000]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: FF 00 00 00                    | Byte sequence: 00 00 00 00 00 00 00 00
                *                ^^ [0xFF: value = NULL]        |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : TIME (0x%02X 0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2], pText[3]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_TIME_LENGTH_NULLABLE <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto TIME_CONVERSION;
                }

                *(reinterpret_cast<uint64*>(REG_pField)) = 0;
                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += DB2Z_TIME_LENGTH_NULLABLE;

                goto NEXT_FIELD;
            }
// ======== TIME NOT NULL ======================================================
            case DB2_TIME: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * TIME NOT NULL                                 | TIME NOT NULL
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 3                           | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. convert time (encoded as BCD) to microseconds since midnight
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = 23:59:59
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence: 23 59 59                       | Byte sequence: C0 1D C8 1D 14 00 00 00
                *                                               | [0x000000141DC81DC0 = 86399000000]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                printf("Processing                : TIME NOT NULL (0x%02X 0x%02X 0x%02X)\n", pText[0], pText[1], pText[2]);
#endif
#if NZDEBUG
                NZ_VERIFY(pText + DB2Z_TIME_LENGTH <= REG_pEnd);
#endif

            TIME_CONVERSION:
                uint32 hours   = (pText[0] >> 4) * 10 + (pText[0] & 0x0F);
                uint32 minutes = (pText[1] >> 4) * 10 + (pText[1] & 0x0F);
                uint32 seconds = (pText[2] >> 4) * 10 + (pText[2] & 0x0F);

                if (((pText[0] >> 4) > 9) || ((pText[0] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_TIME_LENGTH, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (hours > 23) {
#if CONVERT_TIME24
                    if ((pText[0] == 0x24) && (pText[1] == 0x00) && (pText[2] == 0x00)) {
                        *(reinterpret_cast<uint64*>(REG_pField)) = 86399000000ULL; // 23:59:59
                        ++pCurrentFPC->truncations;

                        goto TIME_CONVERSION_SKIP;
                    }

#elif ENABLE_TIME24_SUPPORT
                    if ((pText[0] == 0x24) && (pText[1] == 0x00) && (pText[2] == 0x00)) {
                        *(reinterpret_cast<uint64*>(REG_pField)) = 86400000000ULL; // 24:00:00

                        goto TIME_CONVERSION_SKIP;
                    }

#endif
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_TIME_LENGTH, 0, 0, pBadField);

#if ENABLE_TIME24_SUPPORT
                    goto HOURS25_TOO_LARGE;
#else
                    goto HOURS24_TOO_LARGE;
#endif
                }

                if (((pText[1] >> 4) > 9) || ((pText[1] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_TIME_LENGTH, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (minutes > 59) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_TIME_LENGTH, 0, 0, pBadField);

                    goto MINUTES_TOO_LARGE;
                }

                if (((pText[2] >> 4) > 9) || ((pText[2] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_TIME_LENGTH, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (seconds > 59) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, DB2Z_TIME_LENGTH, 0, 0, pBadField);

                    goto SECONDS_TOO_LARGE;
                }

                *(reinterpret_cast<uint64*>(REG_pField)) = (hours * 3600 + minutes * 60 + seconds) * 1000000ULL;

#if CONVERT_TIME24 || ENABLE_TIME24_SUPPORT
            TIME_CONVERSION_SKIP:
#endif
                pText += DB2Z_TIME_LENGTH;

                goto NEXT_FIELD;
            }
// ======== TIMESTAMP ==========================================================
            case DB2N_TIMESTAMP:
            case DB2N_TIMESTAMP_12: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * TIMESTAMP                                     | TIMESTAMP
                * TIMESTAMP(12)                                 | TIMESTAMP (truncated)
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 1 + 10/13                   | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. convert timestamp (encoded as BCD) to microseconds between 2000-01-01 and timestamp
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = 1978-07-19 23:59:59.999999 (TIMESTAMP)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence: FF DF 58 B1 52 98 FD FF
                * 00 19 78 07 19 23 59 59 99 99 99              | [0xFFFD9852B158DFFF = -676944000000001]
                * ^^ [0x00: value != NULL]                      |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * b) Example: value = NULL
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence: 00 00 00 00 00 00 00 00
                * FF 00 00 00 00 00 00 00 00 00 00              |
                * ^^ [0xFF: value = NULL]                       |
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                if (pCurrentFPC->parseDataType == DB2_TIMESTAMP) {
                    printf("Processing                : TIMESTAMP (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n",
                            pText[0], pText[1], pText[2], pText[3], pText[4], pText[5], pText[6], pText[7], pText[8], pText[9], pText[10]);
                } else {
                    printf("Processing                : TIMESTAMP(12) (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n",
                            pText[0], pText[1], pText[2], pText[3], pText[4], pText[5], pText[6], pText[7], pText[8], pText[9], pText[10], pText[11], pText[12], pText[13]);
                }
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLengthNULL <= REG_pEnd);
#endif

                if (pText[0] == 0x00) {
                    pText += DB2Z_NULL_HEADER_LENGTH;

                    goto TIMESTAMP_CONVERSION;
                }

                *(reinterpret_cast<uint64*>(REG_pField)) = 0;
                NzSetBit(recordBuffer.bytes, pCurrentFPC->nullIndex);

                pText += pCurrentFPC->fixedLengthNULL;

                goto NEXT_FIELD;
            }
// ======== TIMESTAMP NOT NULL =================================================
            case DB2_TIMESTAMP:
            case DB2_TIMESTAMP_12: {
                /*
                * ****************************************************************************************
                * 1. Type Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS                                  | NPS
                * ==============================================+=========================================
                * TIMESTAMP NOT NULL                            | TIMESTAMP
                * TIMESTAMP(12) NOT NULL                        | TIMESTAMP (truncated)
                *
                * ****************************************************************************************
                * 2. Format Mapping
                * ****************************************************************************************
                *
                * DB2 for z/OS internal format (BRF/RRF)        | NPS internal format
                * ==============================================+=========================================
                * Length type     : fixed-length                | Length type     : fixed-length
                * Number of bytes : 10/13                       | Number of bytes : 8
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * Conversion:
                * 1. convert timestamp (encoded as BCD) to microseconds between 2000-01-01 and timestamp
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                * a) Example: value = 1978-07-19 23:59:59.999999 (TIMESTAMP NOT NULL)
                * ----------------------------------------------+-----------------------------------------
                * Byte sequence:                                | Byte sequence: FF DF 58 B1 52 98 FD FF
                * 19 78 07 19 23 59 59 99 99 99                 | [0xFFFD9852B158DFFF = -676944000000001]
                * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                */
#ifdef DB2Z_PARSER_TRACING
                if (pCurrentFPC->parseDataType == DB2_TIMESTAMP) {
                    printf("Processing                : TIMESTAMP NOT NULL (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n",
                            pText[0], pText[1], pText[2], pText[3], pText[4], pText[5], pText[6], pText[7], pText[8], pText[9]);
                } else {
                    printf("Processing                : TIMESTAMP(12) NOT NULL (0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X)\n",
                            pText[0], pText[1], pText[2], pText[3], pText[4], pText[5], pText[6], pText[7], pText[8], pText[9], pText[10], pText[11], pText[12]);
                }
#endif
#if NZDEBUG
                NZ_VERIFY(pText + pCurrentFPC->fixedLength <= REG_pEnd);
#endif

            TIMESTAMP_CONVERSION:
                uint32 year     = (pText[0] >> 4) *   1000 + (pText[0] & 0x0F) *   100 + (pText[1] >> 4) *   10 + (pText[1] & 0x0F);
                uint32 month    = (pText[2] >> 4) *     10 + (pText[2] & 0x0F);
                uint32 day      = (pText[3] >> 4) *     10 + (pText[3] & 0x0F);
                uint32 hours    = (pText[4] >> 4) *     10 + (pText[4] & 0x0F);
                uint32 minutes  = (pText[5] >> 4) *     10 + (pText[5] & 0x0F);
                uint32 seconds  = (pText[6] >> 4) *     10 + (pText[6] & 0x0F);
                uint32 mseconds = (pText[7] >> 4) * 100000 + (pText[7] & 0x0F) * 10000 + (pText[8] >> 4) * 1000 + (pText[8] & 0x0F) * 100 +
                                  (pText[9] >> 4) *     10 + (pText[9] & 0x0F);

                // date
                if ((pText[0] == 0) && (pText[1] == 0)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_ZERO_YEAR;
                } else if (((pText[0] >> 4) > 9) || ((pText[0] & 0x0F) > 9) || ((pText[1] >> 4) > 9) || ((pText[1] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (pText[2] == 0) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto ZERO_MONTH;
                } else if (((pText[2] >> 4) > 9) || ((pText[2] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (month > 12) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto MONTH_TOO_LARGE;
                }

                if (pText[3] == 0) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto ZERO_DAY;
                } else if (((pText[3] >> 4) > 9) || ((pText[3] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (day > 31) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DAY_TOO_LARGE_FOR_MONTH;
                }

                int32 yi = yearInfo[year];
                uint32 leapBit = yi & 1;
                month += leapBit * (sizeof(monthInfo.Normal) / sizeof(monthInfo.Normal[0]));
                yi >>= 1;
                day += monthInfo.Normal[month];

                if (day > monthInfo.Normal[month + 1]) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DAY_TOO_LARGE_FOR_MONTH;
                }

                yi += day;

                // time
                if (((pText[4] >> 4) > 9) || ((pText[4] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (hours > 23) {
#if CONVERT_TIME24 || ENABLE_TIME24_SUPPORT
                    if ((pText[4] == 0x24) && (pText[5] == 0x00) && (pText[6] == 0x00)) {
                        *(reinterpret_cast<uint64*>(REG_pField)) = yi * 86400000000ULL + 86399999999ULL; // ????-??-?? 23:59:59.999999
#endif
#if CONVERT_TIME24
                        ++pCurrentFPC->truncations;
#endif
#if CONVERT_TIME24 || ENABLE_TIME24_SUPPORT

                        goto TIMESTAMP_CONVERSION_SKIP;
                    }

#endif
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

#if ENABLE_TIME24_SUPPORT
                    goto HOURS25_TOO_LARGE;
#else
                    goto HOURS24_TOO_LARGE;
#endif
                }

                if (((pText[5] >> 4) > 9) || ((pText[5] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (minutes > 59) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto MINUTES_TOO_LARGE;
                }

                if (((pText[6] >> 4) > 9) || ((pText[6] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (seconds > 59) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto SECONDS_TOO_LARGE;
                }

                if (((pText[7] >> 4) > 9) || ((pText[7] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (((pText[8] >> 4) > 9) || ((pText[8] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                if (((pText[9] >> 4) > 9) || ((pText[9] & 0x0F) > 9)) {
                    setBadFieldData(badField, badStr, pText, pEnd, 0, pCurrentFPC->fixedLength, 0, 0, pBadField);

                    goto DB2Z_INVALID_BCD;
                }

                *(reinterpret_cast<uint64*>(REG_pField)) =
                        (yi * 86400ULL + hours * 3600ULL + minutes * 60ULL + seconds) * 1000000ULL + mseconds;

#if CONVERT_TIME24 || ENABLE_TIME24_SUPPORT
            TIMESTAMP_CONVERSION_SKIP:

#endif
                pText += pCurrentFPC->fixedLength;

                goto NEXT_FIELD;
            }

//******************************************************************************
