//******************************************************************************

// end block containing subsequent nodes' generated code
}

ROW_SUPRESSED:
        // Update number of input rows processed
        ++rowsConsumed;

        if (rowsToBeSkipped > 0) {
            --rowsToBeSkipped;
        } else if (rowsToBeProcessed) {
            --rowsToBeProcessed;

            if (rowsToBeProcessed == 0) {
                halted = TRUE;
            }
        }

        if (!halted) {
            continue; // Collect next row
        }

        goto END_OF_BUFFER;

        // error handling section
        int errCode;

        DIAGNOSE(DAY_TOO_LARGE_FOR_MONTH);
        DIAGNOSE(DB2Z_CORRUPT_ROW);
        DIAGNOSE(DB2Z_EXPECTED_BRF_NOT_RRF);
        DIAGNOSE(DB2Z_EXPECTED_RRF_NOT_BRF);
        DIAGNOSE(DB2Z_INVALID_BCD);
        DIAGNOSE(DB2Z_INVALID_FIELD_LENGTH);
        DIAGNOSE(DB2Z_INVALID_FIELD_LENGTH_INFERRED);
        DIAGNOSE(DB2Z_INVALID_REAL_DOUBLE);
        DIAGNOSE(DB2Z_UNSUPPORTED_REAL);
        DIAGNOSE(DB2Z_ZERO_RECORD_LENGTH);
        DIAGNOSE(DB2Z_ZERO_YEAR);
        DIAGNOSE(HOURS24_TOO_LARGE);
        DIAGNOSE(HOURS25_TOO_LARGE);
        DIAGNOSE(MINUTES_TOO_LARGE);
        DIAGNOSE(MONTH_TOO_LARGE);
        DIAGNOSE(SECONDS_TOO_LARGE);
        DIAGNOSE(UTF8_BAD_CONTINUATION_BYTE);
        DIAGNOSE(UTF8_ILLEGAL_INITIAL_BYTE);
        DIAGNOSE(ZERO_DAY);
        DIAGNOSE(ZERO_MONTH);

    EMIT_DIAGNOSTIC:
        ++rowsConsumed;
        ++rowsRejected;

        {
            std::string const& db2TypeName = copyIn->getDB2TypeName(*pCurrentFPC);

            logError(
                    errCode,
                    copyIn->m_rowsRejected + rowsRejected,
                    copyIn->m_rowsConsumed + rowsConsumed,
                    pBadField - *pRemainingText,
                    pCurrentFPC - pFPC + 1,
                    db2TypeName.c_str(),
                    "",
                    badField.str().c_str(),
                    badStr.str().c_str()
                    );

            logBadRecord(*pRemainingText, recordLength, true);
        }

        if (maxErrors == 0) {
            // MAXERRORS 0: unlimited errors
            *pRemainingText += recordLength;

            continue;
        } else {
            --maxErrors;

            if (maxErrors != 0) {
                *pRemainingText += recordLength;

                continue;
            }
        }

        halted = true;

        goto END_OF_BUFFER_ERROR;
    } // while (TRUE) // Outermost scan loop: deliver successive rows from input

COLUMN_DISPATCH_OPCODE:
    THROW_ERROR(NZ_FATAL_ASSERTION, "FBL: column dispatch encountered bad opcode", badParseDataType);

END_OF_BUFFER:
#ifdef DB2Z_PARSER_TRACING
    printf("****** END OF BUFFER ******\n");
#endif

END_OF_BUFFER_ERROR:
    // copy state back into object
    Parser* copyOut = this;
    copyOut->m_maxErrors         = maxErrors;
    copyOut->m_rowsToBeProcessed = rowsToBeProcessed;
    copyOut->m_rowsToBeSkipped   = rowsToBeSkipped;
    copyOut->m_rowsConsumed     += rowsConsumed;
    copyOut->m_rowsRejected     += rowsRejected;
    copyOut->m_halted = halted;

    // return pointer to first unconsumed character

//******************************************************************************
