//******************************************************************************

        // Zero out record's specials and null area
        long* pLeader; pLeader = (long*)pRecordBuffer;
        uint llcnt; llcnt = leaderLongs;
        while ( llcnt ) {
            *pLeader++ = 0;
            --llcnt;
            }

        uint recordSize; recordSize = fixedSize + nVarFields*sizeof(vlen_t);

        // If record includes varstring or blob fields zero an adequate
        // number entries in the array of ParsedVarString descriptors.
        uint16 nPVSEntries; nPVSEntries = nVarFields;
        if ( nPVSEntries != 0 ) {
            ParsedVarString* pvsCur = pPVS;
            ParsedVarString* pvsEnd = pvsCur + nPVSEntries;
            do {
                ((long*)pvsCur)[0] = 0;
                ((long*)pvsCur)[1] = 0;
                }
            while ( ++pvsCur != pvsEnd );
            }

#if BLOB_SUPPORT
        uint* blobBufferPosition; blobBufferPosition = blobBuffer;
#endif

        pText = *pRemainingText;
        pTextStart = *pRemainingText;
        // "Prime the pump", fill ch with first <EOR>
        if ( (plan->m_unTermFlg) && ( (pText[0] != '\r') || (((uint8*)&recDelim)[0] != '\n' )) ) {
            for (idx = 0; idx < recDelimLen; idx++) {
                if (pText[idx] != (((uint8*)&recDelim)[idx]))
                    goto EXPECTED_END_OF_FIELD;
            }
            for (idx = 0; idx < recDelimLen; idx++)
                NEXT_CHAR(pEnd);
        }
        else NEXT_CHAR(pEnd);
        // Step over previously identified <EOR> character
        NEXT_CHAR(pEnd);

#if CR_IS_EOR
        // Allow <\r><\n> (DOS) and <\n><\r> (MAC) pairs
        if ( ch == eor2 )
            NEXT_CHAR(pEnd);
#endif // CR_IS_EOR

        // Fill all fields in logical order (loop constructed out of GOTOs)
        FieldParseControl const * pFldPrsCtl; pFldPrsCtl = pFPC;
        FieldParseControl const * REG_pFldPrsCtl;
        uint8 const* REG_pEnd;
        ENCACHE_REG(pEnd);
        goto START_PARSING_RECORD;


        // "while" is here to call attention to the fact that this is a loop
        // over the fields in the input record and to trigger some suggestive
        // indentation; in reality the looping is accomplished entirely via
        // goto statements.
        while (TRUE) {

            uint day;
            uint month;
            uint year;
            char* REG_pField;
            char* pField;
            uint declExtra;
            uint REG_valueDelim;
#if QUOTED_VALUES
            uint REG_quoteChar;
#endif

// =============================
// Value are being quoted but we found no opening quote; all blanks have
// been consumed so the only remaining possibility is the null pattern
#if REQUIRE_QUOTES
            {
        UNQUOTED_NULL:
            ENCACHE_REG(pFldPrsCtl);
            flags = REG_pFldPrsCtl->flags;
            if ( !(flags & FPF_NULLABLE) ) goto EXPECTED_OPENING_QUOTE; // missing quote
            // Perform masked case-insensitive check for null string
            if ( nullMask_0_3 == 0 ) goto UNQUOTED_SET_NULL_BIT;
            uint ch_0_3; ch_0_3 = *((uint*)(((char*)pText)-1+0));
            FOLD_CASE_NULL(ch_0_3);
            ch_0_3 &= nullMask_0_3;
            if ( ch_0_3 != nullText_0_3 ) goto EXPECTED_OPENING_QUOTE_OR_NULL_TOKEN;
            // Matched the NULL token
            pText += nullAdvance;
            NEXT_CHAR(pEnd);
        UNQUOTED_SET_NULL_BIT:
            // REG_pFldPrsCtl->nullIndex is prebiased to avoid need to sizeWordSize to pRecordBuffer
            uint nullIndex = REG_pFldPrsCtl->nullIndex;
            *(char*)(((char*)pRecordBuffer) + (nullIndex >> 3)) |= 1 << (nullIndex & 7);
            ENCACHE_REG(pEnd);
            goto NEXT_FIELD_UNQUOTED_NULL;
             }
#endif // REQUIRE_QUOTES

// =============================
// Tentatively empty field: copy default value (cannonalizes NULL fields)
// [assumes that spaces were consumed in per field parse]

            {
                char* pEmptySrc;

#if BLOB_SUPPORT_AGAIN
#if PT_CLOB | PTN_CLOB | JUST_COMPILE
        EMPTY_CLOB:
#endif
#if PT_NUCL | PTN_NUCL | JUST_COMPILE
        EMPTY_NUCL:
#endif
#if PT_CLOB | PTN_CLOB | PT_NUCL | PTN_NUCL | JUST_COMPILE
            // body pointer is trash but length is still 0
            ((ParsedVarString*)REG_pField)->pureCopy = COALESCED_BLOB;
            if (flags & FPF_EMPTY_DEFAULT) {
                // express coalesced EMPTY blob as a pointer to a "zero" length word
                ((ParsedVarString*)REG_pField)->length = COALESCED_BLOB_LENGTH;
                ((ParsedVarString*)REG_pField)->body = (uint8* )"\4\0\0\0";  // !! LITTLE ENDIAN
                }
            goto VALIDATE_EMPTY_OR_NULL;
#endif
#if PT_PROT | PTN_PROT | JUST_COMPILE
        EMPTY_PROT:
            // body pointer is trash but length is still 0
            ((ParsedVarString*)REG_pField)->pureCopy = COALESCED_BLOB;
            if (flags & FPF_EMPTY_DEFAULT) {
                // an empty PROT still has two sentinel null bytes
                ((ParsedVarString*)REG_pField)->length = COALESCED_BLOB_LENGTH;
                ((ParsedVarString*)REG_pField)->body = (uint8* )"\6\0\0\0\0\0"; // LITTLE ENDIAN
                }
            goto VALIDATE_EMPTY_OR_NULL;
#endif
#endif //BLOB_SUPPORT_AGAIN

#if FPF_EMPTY_DEFAULT != ' '
#error FPF_EMPTY_DEFAULT must equal value of ASCII space (0x20)
#endif

#if PT_CHAR1 | PTN_CHAR1 | JUST_COMPILE
        EMPTY_CHAR1:
            {
                // if FPF_EMPTY_DEFAULT set string to space character from sbc
                //  else to '\0'
                uint8 empty_value = (flags & FPF_EMPTY_DEFAULT)? sbcspcChar : '\0' ;
                *REG_pField = empty_value;
                goto VALIDATE_EMPTY_OR_NULL;
            }
#endif
#if PT_CHAR | PTN_CHAR | JUST_COMPILE
        EMPTY_CHAR_FIXED:
            {
                // if FPF_EMPTY_DEFAULT fill string with ' ' else to '\0'
                uint8 empty_value = (flags & FPF_EMPTY_DEFAULT)? sbcspcChar : '\0' ;
                do
                    *REG_pField++ = empty_value;
                while ( --declExtra );
                goto VALIDATE_EMPTY_OR_NULL;
            }
#endif

#undef  INIT_COPY_DEFAULT
#define INIT_COPY_DEFAULT \
ENCACHE_REG(pField);\
pEmptySrc = offset_from_rec_to_def + REG_pField
#undef  COPY_DEFAULT
#define COPY_DEFAULT(TYPE,DISP) *((TYPE*)(REG_pField+(DISP))) = *((TYPE*)(pEmptySrc+(DISP)))

        EMPTY_NUMERIC16:
            INIT_COPY_DEFAULT;
            COPY_DEFAULT(int,12);
            goto COPY_12_BYTES;

        EMPTY_INTERVAL:
            INIT_COPY_DEFAULT;
        COPY_12_BYTES:
            COPY_DEFAULT(int,8);
            goto COPY_8_BYTES;

        EMPTY_TIME:
            if ( flags & FPF_DATE_TRUNC_TIME ) goto NEXT_FIELD;
            if ( flags & FPF_TIMESTAMP ) goto EXPECTED_TIMESTAMP_TIME;
        EMPTY_TIMESTAMP:
        EMPTY_NUMERIC8:
        EMPTY_DOUBLE:
        EMPTY_INT8:
        EMPTY_8_BYTES:
            INIT_COPY_DEFAULT;
        COPY_8_BYTES:
            COPY_DEFAULT(int,4);
            goto COPY_4_BYTES;

        EMPTY_DATE:
            // If it is really a time stamp then we need to copy
            // 8 bytes rather than just 4
            if ( flags & FPF_TIMESTAMP ) goto EMPTY_TIMESTAMP;
        EMPTY_NUMERIC4:
        EMPTY_FLOAT:
        EMPTY_INT4:
            INIT_COPY_DEFAULT;
        COPY_4_BYTES:
            COPY_DEFAULT(int,0);
            goto VALIDATE_EMPTY_OR_NULL;

        EMPTY_INT2:
            INIT_COPY_DEFAULT;
            COPY_DEFAULT(short,0);
            goto VALIDATE_EMPTY_OR_NULL;

        EMPTY_BOOL:
        EMPTY_INT1:
            INIT_COPY_DEFAULT;
            COPY_DEFAULT(char,0);
        EMPTY_VAR_CHAR:
        EMPTY_VAR_FIXED:
        EMPTY_NVAR_CHAR:
        EMPTY_NVAR_FIXED:
        VALIDATE_EMPTY_OR_NULL:
	    if ( ch == valueDelim || ((recDelimLen == 1) && (ch=='\n' || CH_IS_CR_EOR)) ) {
                // Field is properly terminated, so truly empty
                if ( flags & FPF_EMPTY_NULL ) goto SET_NULL_BIT;
                if ( flags & FPF_EMPTY_DEFAULT ) goto NEXT_FIELD;
                goto ILLEGAL_EMPTY_FIELD;
                }
	    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_EMPTY);
            if ( flags & FPF_EMPTY_NULL ) goto SET_NULL_BIT;
            if ( flags & FPF_EMPTY_DEFAULT ) goto NEXT_FIELD;
            goto ILLEGAL_EMPTY_FIELD;
        NO_EQUAL_REC_DELIM_EMPTY:
            // Field contains unconsumed text; could it be the null token?
            if ( nullMask_0_3 == 0 ) goto UNIDENTIFIED_FIELD_VALUE; // no token, only ''
            // Perform masked case-insensitive check for null string
            uint ch_0_3; ch_0_3 = *((uint*)(((char*)pText)-1+0));
            FOLD_CASE_NULL(ch_0_3);
            ch_0_3 &= nullMask_0_3;
            if ( ch_0_3 != nullText_0_3 ) goto UNIDENTIFIED_FIELD_VALUE;

            // Matched the NULL token; is field allowed to be NULL?
        SKIP_NULL_TOKEN_SET_NULL_BIT:
            if ( !(flags & FPF_NULLABLE) ) goto NULL_TOKEN_BUT_NOT_NULLABLE;
            pText += nullAdvance;
            NEXT_CHAR(pEnd);
        SET_NULL_BIT:
            // REG_pFldPrsCtl->nullIndex is prebiased to account for sizeWordSize
            uint nullIndex = pFldPrsCtl->nullIndex;
            *(char*)(((char*)pRecordBuffer) + (nullIndex >> 3)) |= 1 << (nullIndex & 7);
            }

        NEXT_FIELD:
            // Restore current character; this frees up that register
            // at the bottom of parsing routine (after consuming the
            // final character); doing so is especially useful since
            // that final processing is often the point of maximal
            // register pressure
            ch = pText[-1];
            ENCACHE_REG(pEnd);

#if QUOTED_VALUES
            // Look for closing quote
            ENCACHE_REG(quoteChar);
#  if ALLOW_QUOTES
            if ( valueDelim != REG_quoteChar ) goto NEXT_FIELD_UNQUOTED_NULL;
#  endif
            if ( ch != REG_quoteChar ) {
                SKIP_SPACES_ELSE(EXPECTED_CLOSING_QUOTE);
                if ( ch != REG_quoteChar ) goto EXPECTED_CLOSING_QUOTE;
                }
            NEXT_CHAR(REG_pEnd);

        NEXT_FIELD_UNQUOTED_NULL:
#endif // QUOTED_VALUES

            if ( flags & FPF_LAST_FIELD ) goto COMPLETED_LAST_FIELD;
            if ( ch == fieldDelim ) goto NEXT_FIELD_DELIM;
    	    if ( (recDelimLen == 1) && (ch=='\n' || CH_IS_CR_EOR) ) goto FILL_RECORD;
            COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_FILL);
            goto FILL_RECORD;
        NO_EQUAL_REC_DELIM_FILL:
            SKIP_SPACES_ELSE(EXPECTED_END_OF_FIELD);
            if ( ch != fieldDelim ) goto MAYBE_FILL_RECORD;
        NEXT_FIELD_DELIM:
            NEXT_CHAR(REG_pEnd);
            pFldPrsCtl++;

// Dispatch on FieldParseControl.parseDataType to collect next field

    START_PARSING_RECORD:

            pStartOfField = pText;

#if REQUIRE_QUOTES
            // Look for mandatory opening quote
            ENCACHE_REG(quoteChar);
            if ( ch != REG_quoteChar ) {
                SKIP_SPACES_ELSE(UNQUOTED_NULL);
                if ( ch != REG_quoteChar ) goto UNQUOTED_NULL;
                }
            NEXT_CHAR(REG_pEnd);
#elif ALLOW_QUOTES
            // Look for optional opening quote
            valueDelim = fieldDelim;
            if ( ch == ' ' ) {
                do
                    NEXT_CHAR(REG_pEnd);
                while ( ch == ' ' );
                }
            ENCACHE_REG(quoteChar);
            if ( ch == REG_quoteChar ) {
                valueDelim = ch;
                NEXT_CHAR(REG_pEnd);
                }
#endif
            ENCACHE_REG(pFldPrsCtl);
            uint parseDataType; parseDataType = REG_pFldPrsCtl->parseDataType;

        TIMESTAMP_REDISPATCH:

            REG_pField = (char*)(uint)REG_pFldPrsCtl->offset;   // lead gcc to
            REG_pField += (size_t)pRecordBuffer;                // best code
            pField = REG_pField;

            declExtra = REG_pFldPrsCtl->extra.declSize;

            flags = REG_pFldPrsCtl->flags;

            // At this dispatch these 6 quantities are in registers:
            //
            // Variables (no other copy):
            //
            //  parseDataType   used by some parsers to extract flags
            //
            //  ch        :  current char being examined
            //  pText     -> next character to be examined
            //  declExtra :  addition type information from FldPrsCtl entry
            //
            // Register cached copies of invariant values:
            //
            //  REG_pEnd   -> end of source being parsed
            //  REG_pField -> field's position in record buffer

            // switch on field type
            switch ( parseDataType ) {

// =============================
#if PTN_CHAR1 | JUST_COMPILE
            case PTN_CHAR1:
                NULL_STRING_CHECK;
#endif
#if PT_CHAR1 | JUST_COMPILE
            case PT_CHAR1:
#endif
#if PT_CHAR1 | PTN_CHAR1 | JUST_COMPILE
                {
                BEGIN_CASE(1);

                ENCACHE_REG(valueDelim);
#if ALLOW_QUOTES
                if ( pText != pStartOfField && REG_valueDelim != quoteChar ) {
                    pText = const_cast<uint8*>(pStartOfField);
                    ch = ' ';
                    }
#endif // ALLOW_QUOTES
#if BSLASH_ESCAPE
                if ( ch == escapeChar )
                    NEXT_CHAR(REG_pEnd);
                else
#endif // BSLASH_ESCAPE
                IF_STOPPER_GOTO(REG_valueDelim,REG_pEnd,EMPTY_CHAR1);
                if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && ( pText[-2] != escapeChar ) 
#endif                
                 ) {
                    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_CHAR1);
                    goto NEXT_FIELD;
                }
            NO_EQUAL_REC_DELIM_CHAR1:
                *REG_pField = ch;
                NEXT_CHAR(REG_pEnd);
                IF_STOPPER_GOTO(REG_valueDelim,REG_pEnd,NEXT_FIELD);
#endif // PT_CHAR1 | PTN_CHAR1 | JUST_COMPILE
#if STRING_SUPPORT
            TRUNC_STRING_CHECK:
#if !GC_TRUNC_STRING
            if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)    
#endif
            ) {
               COMPARE_TO_REC_DELIM(recDelimLen, EXPECTED_END_OF_FIELD);
               goto NEXT_FIELD;
            }
            goto TEXT_FIELD_TOO_LONG;
#endif
                ENCACHE_REG(pEnd);
//                 ENCACHE_REG(valueDelim);
                while (TRUE) {
                if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ) {
                    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_TRUNC);
                    goto NEXT_FIELD;
                }
                NO_EQUAL_REC_DELIM_TRUNC:
                    NEXT_CHAR(REG_pEnd);
#if BSLASH_ESCAPE
                    if (( ch == escapeChar) || ( ((ch == 10) || CH_IS_CR_EOR ) && (pText[-2] == escapeChar)) ) { 
                        NEXT_CHAR(REG_pEnd);  
                        continue;  
                    }
#endif
                    IF_STOPPER_GOTO(REG_valueDelim,REG_pEnd,NEXT_FIELD);
                }
#endif
#if PT_CHAR1 | PTN_CHAR1 | JUST_COMPILE
                }
#endif
// =============================
#if PTN_CHAR | JUST_COMPILE
            case PTN_CHAR:
                NULL_STRING_CHECK;
#endif
#if PT_CHAR | JUST_COMPILE
            case PT_CHAR:
#endif
#if PT_CHAR | PTN_CHAR | JUST_COMPILE
                {
                BEGIN_CASE(2);

                ENCACHE_REG(valueDelim);
#if ALLOW_QUOTES
                if ( pText != pStartOfField && REG_valueDelim != quoteChar ) {
                    pText = const_cast<uint8*>(pStartOfField);
                    ch = ' ';
                    }
#endif // ALLOW_QUOTES
#if BSLASH_ESCAPE
                if ( ch == escapeChar )
                    NEXT_CHAR(REG_pEnd);
                else
#endif // BSLASH_ESCAPE
                IF_STOPPER_GOTO(valueDelim,REG_pEnd,EMPTY_CHAR_FIXED);
                if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ){
                    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_CHAR);
                    goto SPACE_PAD;
                }
                NO_EQUAL_REC_DELIM_CHAR:
                do {
                    *REG_pField++ = ch;
                    NEXT_CHAR(REG_pEnd);
#if BSLASH_ESCAPE
                    if ( ch == escapeChar )
                        NEXT_CHAR(REG_pEnd);
                    else
#endif // BSLASH_ESCAPE
                    IF_STOPPER_GOTO(valueDelim,REG_pEnd,SPACE_PAD);
                if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString)) && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ){ 
                    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_CHAR2);
                    goto SPACE_PAD;
                }
                NO_EQUAL_REC_DELIM_CHAR2:
                    if (pText >= pEnd) goto SPACE_PAD;
                    }
                while ( --declExtra );
                goto TRUNC_STRING_CHECK;

            SPACE_PAD:
                if ( --declExtra == 0 ) goto NEXT_FIELD;
                do
                    *REG_pField++ = sbcspcChar;
                while ( --declExtra );
                goto NEXT_FIELD;
                }
#endif // PT_CHAR | PTN_CHAR | JUST_COMPILE
// =============================
#if PTN_VAR_CHAR | JUST_COMPILE
            case PTN_VAR_CHAR:
                NULL_STRING_CHECK;
#endif
#if PT_VAR_CHAR | JUST_COMPILE
            case PT_VAR_CHAR:
#endif
#if PT_VAR_CHAR | PTN_VAR_CHAR | JUST_COMPILE
                {
                BEGIN_CASE(3);

                ENCACHE_REG(valueDelim);
#if ALLOW_QUOTES
                if ( pText != pStartOfField && REG_valueDelim != quoteChar ) {
                    pText = const_cast<uint8*>(pStartOfField);
                    ch = ' ';
                    }
#endif // ALLOW_QUOTES
                REG_pField += offset_from_rec_to_PVS;
                ((ParsedVarString*)REG_pField)->body = pText;
                uint length = 0;
#if BSLASH_ESCAPE
                if ( ch == escapeChar )
                    NEXT_CHAR(pEnd);
                else
#endif // BSLASH_ESCAPE
                IF_STOPPER_GOTO(REG_valueDelim,pEnd,EMPTY_VAR_CHAR);
                if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ){
                    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_VAR_CHAR);
                    goto FINISH_VAR_CHAR;
                }
                NO_EQUAL_REC_DELIM_VAR_CHAR:
                do {
                    length += 1;
                    NEXT_CHAR(pEnd);
#if BSLASH_ESCAPE
                    if ( ch == escapeChar )
                        NEXT_CHAR(pEnd);
                    else
#endif // BSLASH_ESCAPE
                    IF_STOPPER_GOTO(REG_valueDelim,pEnd,FINISH_VAR_CHAR);
                    if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ){
                    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_VAR_CHAR2);
                    goto FINISH_VAR_CHAR;
                }
                NO_EQUAL_REC_DELIM_VAR_CHAR2:
                    if (pText >= pEnd) goto FINISH_VAR_CHAR;
                    }
                while ( --declExtra );
            FINISH_VAR_CHAR:
                ((ParsedVarString*)REG_pField)->pureCopy = (length == (pText-((ParsedVarString*)REG_pField)->body));
#if QUOTED_VALUES
                if ( ! ((ParsedVarString*)REG_pField)->pureCopy ) {
                    ((ParsedVarString*)REG_pField)->quoteChar = 0;
                    if ( quoteChar == valueDelim )
                        ((ParsedVarString*)REG_pField)->quoteChar = quoteChar;
                    }
#endif // QUOTED_VALUES
                ((ParsedVarString*)REG_pField)->length = length;
                recordSize += ((length + 1) & (-2));
                if ( declExtra ) goto NEXT_FIELD;
                goto TRUNC_STRING_CHECK;
                }
#endif // PT_VAR_CHAR | PTN_VAR_CHAR | JUST_COMPILE
// =============================
#if PTN_VAR_FIXED_CHAR | JUST_COMPILE
            case PTN_VAR_FIXED_CHAR:
                NULL_STRING_CHECK;
#endif
#if PT_VAR_FIXED_CHAR | JUST_COMPILE
            case PT_VAR_FIXED_CHAR:
#endif
#if PT_VAR_FIXED_CHAR | PTN_VAR_FIXED_CHAR | JUST_COMPILE
                {
                BEGIN_CASE(4);

                ENCACHE_REG(valueDelim);
#if ALLOW_QUOTES
                if ( pText != pStartOfField && REG_valueDelim != quoteChar ) {
                    pText = const_cast<uint8*>(pStartOfField);
                    ch = ' ';
                    }
#endif
                REG_pField += offset_from_rec_to_PVS;
                ((ParsedVarString*)REG_pField)->body = pText;
                uint length = 0;
                uint trailingSpaces = 0;
#if BSLASH_ESCAPE
                if ( ch == escapeChar )
                    NEXT_CHAR(pEnd);
                else
#endif
                IF_STOPPER_GOTO(REG_valueDelim,pEnd,EMPTY_VAR_FIXED);
                if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ){
                    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_VAR_FIXED_CHAR);
                    goto FINISH_VAR_FIXED;
                }
            NO_EQUAL_REC_DELIM_VAR_FIXED_CHAR:
                do {
                    length += 1;
                    // Without conditional flow:
                    //   CH == ' ': ++trailingSpaces
                    //   CH != ' ': set trailingSpaces to 0
                    ch = ( ch == sbcspcChar);
                    ch = -ch;
                    trailingSpaces -= ch;
                    trailingSpaces &= ch;
                    NEXT_CHAR(pEnd);
#if BSLASH_ESCAPE
                    if ( ch == escapeChar )
                        NEXT_CHAR(pEnd);
                    else
#endif
                    IF_STOPPER_GOTO(REG_valueDelim,pEnd,FINISH_VAR_FIXED);
                    if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ) {
                    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_VAR_FIXED_CHAR2);
                    goto FINISH_VAR_FIXED;
                 }
                NO_EQUAL_REC_DELIM_VAR_FIXED_CHAR2:
                    if (pText >= pEnd) goto FINISH_VAR_FIXED;
                    }
                while ( --declExtra );
            FINISH_VAR_FIXED:
                ((ParsedVarString*)REG_pField)->pureCopy = (length == (pText-((ParsedVarString*)REG_pField)->body));
                length -= trailingSpaces;
#if QUOTED_VALUES
                if ( ! ((ParsedVarString*)REG_pField)->pureCopy ) {
                    ((ParsedVarString*)REG_pField)->quoteChar = 0;
                    if ( quoteChar == valueDelim )
                        ((ParsedVarString*)REG_pField)->quoteChar = quoteChar;
                    }
#endif
                ((ParsedVarString*)REG_pField)->length = length;
                recordSize += ((length + 1) & (-2));
                if ( declExtra ) goto NEXT_FIELD;
                goto TRUNC_STRING_CHECK;
                }
#endif // PT_VAR_FIXED_CHAR | PTN_VAR_FIXED_CHAR | JUST_COMPILE
// =============================
#if PTN_NVAR_CHAR | JUST_COMPILE
            case PTN_NVAR_CHAR:
                NULL_STRING_CHECK;
#endif
#if PT_NVAR_CHAR | JUST_COMPILE
            case PT_NVAR_CHAR:
#endif
#if PT_NVAR_CHAR | PTN_NVAR_CHAR | JUST_COMPILE
                {
                BEGIN_CASE(93);

                ENCACHE_REG(valueDelim);
#if ALLOW_QUOTES
                if ( pText != pStartOfField && REG_valueDelim != quoteChar ) {
                    pText = const_cast<uint8*>(pStartOfField);
                    ch = ' ';
                    }
#endif // ALLOW_QUOTES
                REG_pField += offset_from_rec_to_PVS;
                ((ParsedVarString*)REG_pField)->body = pText;
                uint length = 0;
#if BSLASH_ESCAPE
                if ( ch == escapeChar )
                    NEXT_CHAR(pEnd);
                else
#endif // BSLASH_ESCAPE
                IF_STOPPER_GOTO(REG_valueDelim,pEnd,EMPTY_NVAR_CHAR);
                if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ) {
                  COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_NVAR_CHAR);
                  goto FINISH_NVAR;
                }
                NO_EQUAL_REC_DELIM_NVAR_CHAR:
                do {
                    NEXT_NCHAR(pEnd,length,NVAR,);
#if BSLASH_ESCAPE
                    if ( ch == escapeChar )
                        NEXT_CHAR(pEnd);
                    else
#endif // BSLASH_ESCAPE
                    IF_STOPPER_GOTO(REG_valueDelim,pEnd,FINISH_NVAR);
                    if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ) {
                   COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_NVAR_CHAR2);
                   goto FINISH_NVAR;
                }
                NO_EQUAL_REC_DELIM_NVAR_CHAR2:
                    if (pText >= pEnd) goto FINISH_NVAR;
                    }
                while ( TRUE );
            G_FINISH_NVAR:
                declExtra++;  /* ugly - this is because we finished with a real stopper, not out of space */
            FINISH_NVAR:
                ((ParsedVarString*)REG_pField)->pureCopy = (length == (pText-((ParsedVarString*)REG_pField)->body));
#if QUOTED_VALUES
                if ( ! ((ParsedVarString*)REG_pField)->pureCopy ) {
                    ((ParsedVarString*)REG_pField)->quoteChar = 0;
                    if ( quoteChar == valueDelim )
                        ((ParsedVarString*)REG_pField)->quoteChar = quoteChar;
                    }
#endif // QUOTED_VALUES
                ((ParsedVarString*)REG_pField)->length = length;
                recordSize += ((length + 1) & (-2));
                if ( declExtra ) goto NEXT_FIELD;
                goto TRUNC_STRING_CHECK;
                }
#endif // PT_NVAR_CHAR | PTN_NVAR_CHAR | JUST_COMPILE
// =============================
#if PTN_NVAR_FIXED_CHAR | JUST_COMPILE
            case PTN_NVAR_FIXED_CHAR:
                NULL_STRING_CHECK;
#endif
#if PT_NVAR_FIXED_CHAR | JUST_COMPILE
            case PT_NVAR_FIXED_CHAR:
#endif
#if PT_NVAR_FIXED_CHAR | PTN_NVAR_FIXED_CHAR | JUST_COMPILE
                {
                BEGIN_CASE(94);

                ENCACHE_REG(valueDelim);
#if ALLOW_QUOTES
                if ( pText != pStartOfField && REG_valueDelim != quoteChar ) {
                    pText = const_cast<uint8*>(pStartOfField);
                    ch = ' ';
                    }
#endif
                REG_pField += offset_from_rec_to_PVS;
                ((ParsedVarString*)REG_pField)->body = pText;
                uint length = 0;
                uint trailingSpaces = 0;
#if BSLASH_ESCAPE
                if ( ch == escapeChar )
                    NEXT_CHAR(pEnd);
                else
#endif
                IF_STOPPER_GOTO(REG_valueDelim,pEnd,EMPTY_NVAR_FIXED);
                if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ) {
                   COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_NVAR_FIXED_CHAR);
                   goto FINISH_NVAR_FIXED;
                }
            NO_EQUAL_REC_DELIM_NVAR_FIXED_CHAR:
                do {
                     //   length += 1;
                    // Without conditional flow:
                    //   CH == ' ': ++trailingSpaces
                    //   CH != ' ': set trailingSpaces to 0
                    if (ch == ' ')
                        trailingSpaces++;
                    else
                        trailingSpaces = 0;
                        NEXT_NCHAR(pEnd,length,NVAR_FIXED,trailingSpaces = 0);

#if BSLASH_ESCAPE
                    if ( ch == escapeChar )
                        NEXT_CHAR(pEnd);
                    else
#endif
                    IF_STOPPER_GOTO(REG_valueDelim,pEnd,FINISH_NVAR_FIXED);
                    if ( (((ch != '\n') || (!CH_IS_CR_EOR)) && !(lfInString))  && (ch == ((uint8*)&recDelim)[0])
#if BSLASH_ESCAPE
                && (pText[-2] != escapeChar)
#endif
                ) {
                    COMPARE_TO_REC_DELIM(recDelimLen, NO_EQUAL_REC_DELIM_NVAR_FIXED_CHAR2);
                    goto FINISH_NVAR_FIXED;
                    }
                NO_EQUAL_REC_DELIM_NVAR_FIXED_CHAR2:
                    if (pText >= pEnd) goto FINISH_NVAR_FIXED;
                    }
                    while ( TRUE );
            G_FINISH_NVAR_FIXED:
                declExtra++;  /* ugly, but required to show that we had a good exit */
            FINISH_NVAR_FIXED:
                ((ParsedVarString*)REG_pField)->pureCopy = (length == (pText-((ParsedVarString*)REG_pField)->body));
                length -= trailingSpaces;
#if QUOTED_VALUES
                if ( ! ((ParsedVarString*)REG_pField)->pureCopy ) {
                    ((ParsedVarString*)REG_pField)->quoteChar = 0;
                    if ( quoteChar == valueDelim )
                        ((ParsedVarString*)REG_pField)->quoteChar = quoteChar;
                    }
#endif
                ((ParsedVarString*)REG_pField)->length = length;
                recordSize += ((length + 1) & (-2));
                if ( declExtra ) goto NEXT_FIELD;
                goto TRUNC_STRING_CHECK;
                }
#endif // PT_NVAR_FIXED_CHAR | PTN_NVAR_FIXED_CHAR | JUST_COMPILE
#if BLOB_SUPPORT_AGAIN
// =============================
//            case PTN_BLOB:
//            case PT_BLOB:
// =============================
#if PTN_CLOB | JUST_COMPILE
            case PTN_CLOB:
                // body pointer is already NULL (in case string check fires)
                NULL_STRING_CHECK;
#endif
#if PT_CLOB | JUST_COMPILE
            case PT_CLOB:
#endif
#if PT_CLOB | PTN_CLOB | JUST_COMPILE
                {
                BEGIN_CASE(5);

                ENCACHE_REG(valueDelim);
#if ALLOW_QUOTES
                if ( pText != pStartOfField && REG_valueDelim != quoteChar ) {
                    pText = const_cast<uint8*>(pStartOfField);
                    ch = ' ';
                    }
#endif // ALLOW_QUOTES
                REG_pField += offset_from_rec_to_PVS;

                uint8* pBody = (uint8* )blobBufferPosition;
                ((ParsedBlob* )REG_pField)->body = (uint* )pBody;
                pBody += sizeof(uint); // leave room for 4 byte length preceding body proper

                uint8* REG_blobBufferEnd; ENCACHE_REG(blobBufferEnd);
                if (pBody >= REG_blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                uint length = sizeof(uint); // blob length includes itself
#if BSLASH_ESCAPE
                if ( ch == escapeChar )
                    NEXT_CHAR(pEnd);
                else
#endif // BSLASH_ESCAPE
                IF_STOPPER_GOTO(REG_valueDelim,pEnd,EMPTY_CLOB);
                while (TRUE) {
                    *pBody++ = ch;
                    if (pBody >= REG_blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                    length += 1;
                    NEXT_CHAR(pEnd);
#if BSLASH_ESCAPE
                    if ( ch == escapeChar )
                        NEXT_CHAR(pEnd);
                    else
#endif // BSLASH_ESCAPE
                    IF_STOPPER_GOTO(REG_valueDelim,pEnd,FINISH_CLOB);
                    }
            FINISH_CLOB:
                *((ParsedBlob* )REG_pField)->body = length;
                ((ParsedVarString*)REG_pField)->length = COALESCED_BLOB_LENGTH;
                ((ParsedVarString*)REG_pField)->pureCopy = COALESCED_BLOB;
                // no checks against blobBufferEnd because size is multiple of 4
                while ( ((int)pBody) & 3 )
                    *pBody++ = 0;
                blobBufferPosition = (uint* )pBody;
                goto NEXT_FIELD;
                }
#endif // PT_CLOB | PTN_CLOB | JUST_COMPILE
#endif //BLOB_SUPPORT_AGAIN
// =============================
#if BLOB_SUPPORT_AGAIN
#if PTN_NUCL | JUST_COMPILE
            case PTN_NUCL:
                // body pointer is already NULL (in case string check fires)
                NULL_STRING_CHECK;
#endif
#if PT_NUCL | JUST_COMPILE
            case PT_NUCL:
#endif
#if PT_NUCL | PTN_NUCL | JUST_COMPILE
                {
                BEGIN_CASE(6);


                ENCACHE_REG(valueDelim);
#if ALLOW_QUOTES
                if ( pText != pStartOfField && REG_valueDelim != quoteChar ) {
                    pText = const_cast<uint8*>(pStartOfField);
                    ch = ' ';
                    }
#endif // ALLOW_QUOTES
                REG_pField += offset_from_rec_to_PVS;
                uint8* pBody = (uint8* )blobBufferPosition;
                ((ParsedBlob* )REG_pField)->body = (uint* )pBody;
                pBody += sizeof(uint); // leave room for 4 byte length preceding body proper
                TNuclHeader* pHdr = (TNuclHeader* )pBody;
                pBody += sizeof(*pHdr);

                if (pBody >= blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;

                uint8* pTextRescan = pText;
#if BSLASH_ESCAPE
                if ( ch == escapeChar )
                    NEXT_CHAR(pEnd);
                else
#endif // BSLASH_ESCAPE
                IF_STOPPER_GOTO(REG_valueDelim,pEnd,EMPTY_NUCL);
                uint32 roll = 0;
                uint8 packedByte = 0;
                uint residualShift = 0;
                uint numLowcase = 0;
                uint8 prevChOnesCompl = 0xFF;
                while (TRUE) {
                    if (ch != '*') {        // '*' is utterly invisible
                        numLowcase += ((prevChOnesCompl & ch & 0x20) >> 5);
                        prevChOnesCompl = ~ch;
                        ch = ((uint8* )NUCL_MAP_CHAR_TO_SEQ)[ch];
                        roll = (roll * NUCL_RNG_MUL) + NUCL_RNG_ADD;
                        if (ch == BIOMAP_INVALID) goto INVALID_CHARACTER;
                        packedByte <<= 2;
                        if (ch & NUCL_MAP_PCK) {
                            ch &= 0x03;
                            packedByte |= ch;
                            }
                        else {
                            if (ch & 0x3C) {
                                while ( (ch & (4 << ((roll >> 2) & 0x3))) == 0 )
                                    roll = (roll * NUCL_RNG_MUL) + NUCL_RNG_ADD;
                                packedByte |= ((roll >> 2) & 0x3);
                                }
                            }
                        residualShift -= 2;
                        residualShift &= 0x6;       // 6, 4, 2, 0, 6, 4, ...
                        if ( residualShift == 0 ) {
                            *pBody++ = packedByte;
                            if (pBody >= blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                            }
                        }
                    NEXT_CHAR(pEnd);
#if BSLASH_ESCAPE
                    if ( ch == escapeChar )
                        NEXT_CHAR(pEnd);
                    else
#endif // BSLASH_ESCAPE
                    IF_STOPPER_GOTO(REG_valueDelim,pEnd,NUCL_BASES_PACKED);
                    }
            NUCL_BASES_PACKED:
                uint8* pEndOfField = pText;
                if ( residualShift != 0 ) {
                    *pBody++ = packedByte << residualShift;
                    if (pBody >= blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                    }
                // construct most of header
                pHdr->encoding = NUCL_HEADER_VERSION;
                uint numPairs = 4 * (pBody - (uint8* )&pHdr[1]);
                residualShift >>= 1;
                numPairs -= residualShift;
                pHdr->numPairs = numPairs;
                pHdr->numLowcase = numLowcase;
                // materialize the lowercase range table ahead of the ambiguities
                // since we can predict its size (we collected numLowcase during
                // the original scan); predicting the size of the ambiguity table
                // would be much harder as its representation and size changes as
                // as function of how many base pair we collected.
                size_t lowcaseOffset = ALIGN_INT32((numPairs+3)/4); // offset to aligned word
                if (numLowcase)
                    pHdr->lowcaseOffset = lowcaseOffset; // offset where lcase ranges start (ignore header)
                else
                    pHdr->lowcaseOffset = 0;
                uint* pLCRange = (uint* )((uint8* )&pHdr[1] + lowcaseOffset);
                size_t ambigOffset = lowcaseOffset + numLowcase*2*sizeof(uint); // offset to aligned word
                pHdr->ambigOffset = ambigOffset; // offset where ambigs start (ignore header)
                uint* pAmbBuf = (uint* )((uint8* )&pHdr[1] + ambigOffset);

                pBody = (uint8* )&pAmbBuf[1];   // [0] is count and 2-word ambiguity format flag
                uint nAmbBufWords;
                uint numAmbig;

                pText = pTextRescan-1;
                NUCL_RESCAN_NEXT_CHAR;
                uint8 prevCh = 0;               // ((prevCh ^ ch) & 0x20) means case change
                uint index = 0;
                if ( numPairs <= 0xFFFFFF ) {
                    // compact 1 word encoding
                    while (TRUE) {
                        // scan for ambiguity (i.e. none of A, C, G, T, nor U)
                        uint amb;
                        while (TRUE) {
#if BSLASH_ESCAPE
                            if ( ch == escapeChar )
                                NUCL_RESCAN_NEXT_CHAR;
                            else
#endif // BSLASH_ESCAPE
                            IF_RESCAN_END_GOTO(pEndOfField,NUCL_FINISH_AMB_1W);
                            if ((prevCh ^ ch) & 0x20)
                                *pLCRange++ = index;
                            prevCh = ch;

                            amb = ((uint8* )NUCL_MAP_CHAR_TO_SEQ)[ch];
                            if ( (amb & NUCL_MAP_PCK ) == 0 ) break;
                            ++index;
                            NUCL_RESCAN_NEXT_CHAR;
                            }

                        *(uint32* )pBody = (amb << 26) | index;
                        pBody += sizeof(uint32);
                        if (pBody >= blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                        amb = ch;
                        ++index;
                        NUCL_RESCAN_NEXT_CHAR;
#if BSLASH_ESCAPE
                        if ( ch == escapeChar )
                            NUCL_RESCAN_NEXT_CHAR;
                        else
#endif // BSLASH_ESCAPE
                        IF_RESCAN_END_GOTO(pEndOfField,NUCL_FINISH_AMB_1W);
                        if ((prevCh ^ ch) & 0x20)
                            *pLCRange++ = index;
                        prevCh = ch;

                        uint ambigRunLength = 0;
                        do {
                            if (ch != amb) break;
                            ++ambigRunLength;
                            ++index;
                            NUCL_RESCAN_NEXT_CHAR;
#if BSLASH_ESCAPE
                            if ( ch == escapeChar )
                                NUCL_RESCAN_NEXT_CHAR;
                            else
#endif // BSLASH_ESCAPE
                            IF_RESCAN_END_GOTO(pEndOfField,NUCL_UPDATE_AMB_1W);
                            if ((prevCh ^ ch) & 0x20)
                                *pLCRange++ = index;
                            prevCh = ch;
                            }
                        while ( ambigRunLength < 0xF );
                    NUCL_UPDATE_AMB_1W:
                        // !! LITTLE ENDIAN ASSUMPTION IN BYTE ACCESS ON NEXT LINE - jsy !!
                        pBody[-1] |= ambigRunLength;
                        }
                NUCL_FINISH_AMB_1W:
                    if (prevCh & 0x20)
                        *pLCRange++ = index;
                    nAmbBufWords = ((uint* )pBody) - pAmbBuf - 1;   // size word does not include self
                    numAmbig = nAmbBufWords;
                    }
                else {
                    // fully general 2 word encoding
                    while (TRUE) {
                        // scan for ambiguity (i.e. none of A, C, G, T, nor U)
                        uint amb;
                        while (TRUE) {
#if BSLASH_ESCAPE
                            if ( ch == escapeChar )
                                NUCL_RESCAN_NEXT_CHAR;
                            else
#endif // BSLASH_ESCAPE
                            IF_RESCAN_END_GOTO(pEndOfField,NUCL_FINISH_AMB_2W);
                            if ((prevCh ^ ch) & 0x20)
                                *pLCRange++ = index;
                            prevCh = ch;

                            amb = ((uint8* )NUCL_MAP_CHAR_TO_SEQ)[ch];
                            if ( (amb & NUCL_MAP_PCK ) == 0 ) break;
                            ++index;
                            NUCL_RESCAN_NEXT_CHAR;
                            }

                        *(uint32* )pBody = (amb << 26);
	                        pBody += sizeof(uint32);
                        *(uint32* )pBody = index;
	                        pBody += sizeof(uint32);

                        if (pBody >= blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                        amb = ch;
                        ++index;
                        NUCL_RESCAN_NEXT_CHAR;
#if BSLASH_ESCAPE
                        if ( ch == escapeChar )
                            NUCL_RESCAN_NEXT_CHAR;
                        else
#endif // BSLASH_ESCAPE
                        IF_RESCAN_END_GOTO(pEndOfField,NUCL_FINISH_AMB_2W);
                        if ((prevCh ^ ch) & 0x20)
                            *pLCRange++ = index;
                        prevCh = ch;

                        uint ambigRunLength = 0;
                        do {
                            if (ch != amb) break;
                            ++ambigRunLength;
                            ++index;
                            NUCL_RESCAN_NEXT_CHAR;
#if BSLASH_ESCAPE
                            if ( ch == escapeChar )
                                NUCL_RESCAN_NEXT_CHAR;
                            else
#endif // BSLASH_ESCAPE
                            IF_RESCAN_END_GOTO(pEndOfField,NUCL_UPDATE_AMB_2W);
                            if ((prevCh ^ ch) & 0x20)
                                *pLCRange++ = index;
                            prevCh = ch;
                            }
                        while ( ambigRunLength < 0xFFF );
                    NUCL_UPDATE_AMB_2W:
                        // !! LITTLE ENDIAN ASSUMPTION IN BYTE ACCESS ON NEXT LINE - jsy !!
                        ((uint16* )pBody)[-3] |= ambigRunLength;
                        }
                NUCL_FINISH_AMB_2W:
                    if (prevCh & 0x20)
                        *pLCRange++ = index;
                    nAmbBufWords = ((uint* )pBody) - pAmbBuf - 1;   // size word does not include self
                    numAmbig = nAmbBufWords >> 1;                   // each ambiguity takes 2 words
                    nAmbBufWords |= 0x80000000;                     // "Big Ambiguities" flag
                    }

                // if no ambiguities then no count and no 2-word ambiguity format flag
                if (numAmbig)
                    pAmbBuf[0] = nAmbBufWords;
                else {
                    pHdr->ambigOffset = 0;
                    pBody = (uint8*)pAmbBuf;
                    }

                pHdr->numAmbig = numAmbig;

                // blob length includes itself
                blobBufferPosition = (uint* )pBody;
                size_t blobSize = sizeof(uint) + pBody - (uint8*)pHdr;
// dumpNucl(pHdr);
                ENCACHE_REG(pField);
                REG_pField += offset_from_rec_to_PVS;
                *((ParsedBlob* )REG_pField)->body = blobSize;
                ((ParsedVarString*)REG_pField)->length = COALESCED_BLOB_LENGTH;
                ((ParsedVarString*)REG_pField)->pureCopy = COALESCED_BLOB;
                goto NEXT_FIELD;
                }
#endif // PTN_NUCL | PT_NUCL | JUST_COMPILE
#endif //BLOB_SUPPORT_AGAIN
// =============================
#if BLOB_SUPPORT_AGAIN
#if PTN_PROT | JUST_COMPILE
            case PTN_PROT:
                // body pointer is already NULL (in case string check fires)
                NULL_STRING_CHECK;
#endif
#if PT_PROT | JUST_COMPILE
            case PT_PROT:
#endif
#if PT_PROT | PTN_PROT | JUST_COMPILE
                {
                BEGIN_CASE(7);

                ENCACHE_REG(valueDelim);
#if ALLOW_QUOTES
                if ( pText != pStartOfField && REG_valueDelim != quoteChar ) {
                    pText = const_cast<uint8*>(pStartOfField);
                    ch = ' ';
                    }
#endif // ALLOW_QUOTES
                REG_pField += offset_from_rec_to_PVS;
                uint8* pBody = (uint8* )blobBufferPosition;
                ((ParsedBlob* )REG_pField)->body = (uint* )pBody;
                pBody += sizeof(uint); // leave room for 4 byte length preceding body proper

                uint8* REG_blobBufferEnd; ENCACHE_REG(blobBufferEnd);
                if (pBody >= REG_blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                uint length = sizeof(uint); // blob length includes itself
                // leading null sentinel byte
                *pBody++ = '\0';
                if (pBody >= REG_blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                length += 1;
#if BSLASH_ESCAPE
                if ( ch == escapeChar )
                    NEXT_CHAR(pEnd);
                else
#endif // BSLASH_ESCAPE
                IF_STOPPER_GOTO(REG_valueDelim,pEnd,EMPTY_PROT);
                while (TRUE) {
                    ch = ((uint8* )PROT_MAP_CHAR_TO_SEQ)[ch];
                    if (ch == BIOMAP_INVALID) goto INVALID_CHARACTER;
                    *pBody++ = ch;
                    if (pBody >= REG_blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                    length += 1;
                    NEXT_CHAR(pEnd);
#if BSLASH_ESCAPE
                    if ( ch == escapeChar )
                        NEXT_CHAR(pEnd);
                    else
#endif // BSLASH_ESCAPE
                    IF_STOPPER_GOTO(REG_valueDelim,pEnd,FINISH_PROT);
                    }
            FINISH_PROT:
                // trailing null sentinel byte
                *pBody++ = '\0';
                if (pBody >= REG_blobBufferEnd) goto REALLOCATE_BLOB_BUFFER;
                length += 1;
                *((ParsedBlob* )REG_pField)->body = length;
                ((ParsedVarString*)REG_pField)->length = COALESCED_BLOB_LENGTH;
                ((ParsedVarString*)REG_pField)->pureCopy = COALESCED_BLOB;
                // no checks against blobBufferEnd because size is multiple of 4
                while ( ((int)pBody) & 3 )
                    *pBody++ = 0;
                blobBufferPosition = (uint* )pBody;
                goto NEXT_FIELD;
                }
#endif // PTN_PROT | PT_PROT | JUST_COMPILE
#endif //BLOB_SUPPORT_AGAIN
// =============================
#if PT_INT1 | JUST_COMPILE
            case PT_INT1:
#endif
#if PT_INT1_ZERO_CHECK | JUST_COMPILE
            case PT_INT1_ZERO_CHECK:
#endif
#if PT_INT1 | PT_INT1_ZERO_CHECK | JUST_COMPILE
                {
                BEGIN_CASE(8);

#if ( defined(PT_INT1) & defined(PT_INT1_ZERO_CHECK) ) | JUST_COMPILE
                parseDataType -= PT_INT1;
                COPY_TO_MEMORY(parseDataType,adjustZeroDist);
#endif
            RESTART_INT1:
                val = ch - '0';
                if ( val > 9 ) goto CHECK_SIGNS_INT1;
            CHECK_SIGNS_RETURN_INT1:
                NEXT_CHAR(pEnd);
                COLLECT_SMALL_INT(val, 128, INT1_OUT_OF_RANGE); // leaves ch biased by -'0'
#if ( defined(PT_INT1) & defined(PT_INT1_ZERO_CHECK) ) | JUST_COMPILE
                if ( adjustZeroDist )
#endif
#if PT_INT1_ZERO_CHECK | JUST_COMPILE
                    goto CHECK_ADJUST_ZERO_INT1;
            ADJUST_ZERO_RETURN_INT1:
#endif

                CMOVE_NEG(flags, val);
                *((char*)REG_pField) = val;
                if ( val == ((signed int)(signed char)val) ) goto NEXT_FIELD;
                goto INT1_OUT_OF_RANGE;

            CHECK_SIGNS_INT1:
                if ( ch != '-' ) goto CHECK_PLUS_INT1;
                flags |= FPF_NEGATE;
            PLUS_SIGN_INT1:
                NEXT_CHAR(pEnd);
                val = ch - '0';
                if ( val <= 9 ) goto CHECK_SIGNS_RETURN_INT1;
                goto EXPECTED_DIGIT;
                }
#endif // PT_INT1 | PT_INT1_ZERO_CHECK | JUST_COMPILE
// =============================
#if PT_INT2 | JUST_COMPILE
            case PT_INT2:
#endif
#if PT_INT2_ZERO_CHECK | JUST_COMPILE
            case PT_INT2_ZERO_CHECK:
#endif
#if PT_INT2 | PT_INT2_ZERO_CHECK | JUST_COMPILE
                {
                BEGIN_CASE(9);

#if ( defined(PT_INT2) & defined(PT_INT2_ZERO_CHECK) ) | JUST_COMPILE
                parseDataType -= PT_INT2;
                COPY_TO_MEMORY(parseDataType,adjustZeroDist);
#endif
            RESTART_INT2:
                val = ch - '0';
                if ( val > 9 ) goto CHECK_SIGNS_INT2;
            CHECK_SIGNS_RETURN_INT2:
                NEXT_CHAR(pEnd);
                COLLECT_SMALL_INT(val, 32768, INT2_OUT_OF_RANGE); // leaves ch biased by -'0'
#if ( defined(PT_INT2) & defined(PT_INT2_ZERO_CHECK) ) | JUST_COMPILE
                if ( adjustZeroDist )
#endif
#if PT_INT2_ZERO_CHECK | JUST_COMPILE
                    goto CHECK_ADJUST_ZERO_INT2;
            ADJUST_ZERO_RETURN_INT2:
#endif
                CMOVE_NEG(flags, val);
                *((short*)REG_pField) = val;
                if ( val == ((signed int)(signed short)val) ) goto NEXT_FIELD;
                goto INT2_OUT_OF_RANGE;

            CHECK_SIGNS_INT2:
                if ( ch != '-' ) goto CHECK_PLUS_INT2;
                flags |= FPF_NEGATE;
            PLUS_SIGN_INT2:
                NEXT_CHAR(pEnd);
                val = ch - '0';
                if ( val <= 9 ) goto CHECK_SIGNS_RETURN_INT2;
                goto EXPECTED_DIGIT;
                }
#endif // PT_INT2 | PT_INT2_ZERO_CHECK | JUST_COMPILE
// =============================
#if PT_INT4 | JUST_COMPILE
            case PT_INT4:
#endif
#if PT_INT4_ZERO_CHECK | JUST_COMPILE
            case PT_INT4_ZERO_CHECK:
#endif
#if PT_INT4 | PT_INT4_ZERO_CHECK | JUST_COMPILE
                {
                BEGIN_CASE(10);

#if ( defined(PT_INT4) & defined(PT_INT4_ZERO_CHECK) ) | JUST_COMPILE
                parseDataType -= PT_INT4;
                COPY_TO_MEMORY(parseDataType,adjustZeroDist);
#endif
            RESTART_INT4:
                val = ch - '0';
                if ( val > 9 ) goto CHECK_SIGNS_INT4;
            CHECK_SIGNS_RETURN_INT4:
                NEXT_CHAR(pEnd);
                COLLECT_SIGNED_INT(val, INT4_OUT_OF_RANGE, ALLOW_MAX_NEGATIVE_INT4); // leaves ch biased by -'0'
#if ( defined(PT_INT4) & defined(PT_INT4_ZERO_CHECK) ) | JUST_COMPILE
                if ( adjustZeroDist )
#endif
#if PT_INT4_ZERO_CHECK | JUST_COMPILE
                    goto CHECK_ADJUST_ZERO_INT4;
            ADJUST_ZERO_RETURN_INT4:
#endif
                CMOVE_NEG(flags, val);
            MAX_NEGATIVE_INT4:
                *((int*)REG_pField) = val;
                goto NEXT_FIELD;

            CHECK_SIGNS_INT4:
                if ( ch != '-' ) goto CHECK_PLUS_INT4;
                flags |= FPF_NEGATE;
            PLUS_SIGN_INT4:
                NEXT_CHAR(pEnd);
                val = ch - '0';
                if ( val <= 9 ) goto CHECK_SIGNS_RETURN_INT4;
                goto EXPECTED_DIGIT;
                }
#endif // PT_INT4 | PT_INT4_ZERO_CHECK | JUST_COMPILE
// =============================
#if PT_INT8 | JUST_COMPILE
            case PT_INT8:
                {
                BEGIN_CASE(11);

            RESTART_INT8:
                vlo = ch - '0';
                vhi = 0;
                if ( vlo > 9 ) goto CHECK_SIGNS_INT8;
            CHECK_SIGNS_RETURN_INT8:
                NEXT_CHAR(pEnd);
                COLLECT_SIGNED_INT8(vhi, vlo, INT8_OUT_OF_RANGE, ALLOW_MAX_NEGATIVE_INT8);
                CMOVE_NEG2(flags, vhi, vlo);
            MAX_NEGATIVE_INT8:
                ((int*)REG_pField)[0] = vlo;
                ((int*)REG_pField)[1] = vhi;
                goto NEXT_FIELD;

            CHECK_SIGNS_INT8:
                if ( ch != '-' ) goto CHECK_PLUS_INT8;
                flags |= FPF_NEGATE;
            PLUS_SIGN_INT8:
                NEXT_CHAR(pEnd);
                vlo = ch - '0';
                if ( vlo <= 9 ) goto CHECK_SIGNS_RETURN_INT8;
                goto EXPECTED_DIGIT;
                }
#endif // PT_INT8 | JUST_COMPILE
// =============================
#if PT_NUMERIC4 | JUST_COMPILE
            case PT_NUMERIC4:
                {
                BEGIN_CASE(12);

                int remainingPrecision = declExtra & 0xFF;
                int missingScale = declExtra >> 8;

            RESTART_NUM4:
                uint val = 0;
                if ( ch == '0' ) goto LEADING_0_NUM4;
                if ( ch < '0' || ch > '9' ) goto CHECK_SIGNS_NUM4;

            COLLECT_VALUE_NUM4:
                ch = ch - '0';
                do {
                    val *= 10;
                    val += ch;
                    --remainingPrecision;
                    if ( remainingPrecision < 0 ) break;
                DECIMAL_POINT_RETURN_NUM4:
                    NEXT_CHAR(pEnd);
                    if ( ch == DECIMAL_DELIM) goto DECIMAL_POINT_CHECK_NUM4;
                    ch = ch - '0';
                    }
                while (ch <= 9);

                if ( flags & FPF_DECIMAL_POINT ) {
                    // missingScale -= ( decPntPos - remainingPrecision );
                    uint decPnt = decPntPos;
                    missingScale -= decPnt;
                    if ( missingScale > 0 ) goto TOO_MANY_DIGITS_BEFORE_DP;
                    missingScale += remainingPrecision;
                    if ( missingScale < 0 ) goto TOO_MANY_DIGITS_AFTER_DP;
                    }
                else if ( remainingPrecision < missingScale ) goto TOO_MANY_DIGITS_BEFORE_DP;

                val *= powerOfTen[ missingScale ];

                CMOVE_NEG(flags, val);

            STORE_ZERO_NUM4:
                // Store final value
                ((long*)REG_pField)[0] = val;
                goto NEXT_FIELD;

            DECIMAL_POINT_CHECK_NUM4:
                if ( flags & FPF_DECIMAL_POINT ) goto MULTIPLE_DECIMAL_POINTS;
            DECIMAL_POINT_NUM4:
                flags |= FPF_DECIMAL_POINT;
                decPntPos = remainingPrecision;
                goto DECIMAL_POINT_RETURN_NUM4;

            CHECK_SIGNS_NUM4:
                if ( ch == '-' ) goto MINUS_SIGN_NUM4;
                if ( ch == '+' ) goto PLUS_SIGN_NUM4;
                /* Fix for SWS-66788.In nzload, the -nullValue is sometimes being interpreted as
                   bad data (and thus failing) ... rather than being interpreted as a null value.. */
                if ( pText[0] < '0' || pText[0] > '9' ) {
                    SKIP_SPACES_ELSE(EMPTY_NUMERIC4);
                    goto RESTART_NUM4;
                }
                if ( ch == DECIMAL_DELIM) goto LEADING_DECIMAL_POINT_NUM4;
                SKIP_SPACES_ELSE(EMPTY_NUMERIC4);
                goto RESTART_NUM4;

            MINUS_SIGN_NUM4:
                flags |= FPF_NEGATE;
            PLUS_SIGN_NUM4:
                NEXT_CHAR(pEnd);
                if ( ch > '0' && ch <= '9' ) goto COLLECT_VALUE_NUM4;
                if ( ch == DECIMAL_DELIM) goto LEADING_DECIMAL_POINT_NUM4;
                if ( ch != '0' ) goto EXPECTED_DIGIT_OR_DECIMAL_POINT;
            LEADING_0_NUM4:
                NEXT_CHAR(pEnd);
                if ( ch > '0' && ch <= '9' ) goto COLLECT_VALUE_NUM4;
                if ( ch == DECIMAL_DELIM) goto DECIMAL_POINT_NUM4;
                if ( ch != '0' ) goto STORE_ZERO_NUM4;
                goto LEADING_0_NUM4;

            LEADING_DECIMAL_POINT_NUM4:
                flags |= FPF_DECIMAL_POINT;
                decPntPos = remainingPrecision;
                NEXT_CHAR(pEnd);
                if ( ch >= '0' && ch <= '9' ) goto COLLECT_VALUE_NUM4;
                goto EXPECTED_DIGIT;
            }
#endif // PT_NUMERIC4 | JUST_COMPILE
// =============================
#if PT_NUMERIC8 | JUST_COMPILE
            case PT_NUMERIC8:
                {
                BEGIN_CASE(13);

                int remainingPrecision = declExtra & 0xFF;
                int missingScale = declExtra >> 8;

            RESTART_NUM8:
                vlo = 0;
                vhi = 0;

                if ( ch == '0' ) goto LEADING_0_NUM8;
                if ( ch < '0' || ch > '9' ) goto CHECK_SIGNS_NUM8;

            COLLECT_VALUE_NUM8:
                ch = ch - '0';
                do {
                    vhi *= 10;
                    uint tmp;
                    asm(   "movl	$10,%2\n"
                       "	mull	%2\n"
                       "	addl	%2,%0\n"
                       "	addl	%3,%1\n"
                       "	adcl	$0,%0"
                       : "+r" (vhi), "+a" (vlo), "=&d" (tmp)
                       :  "r" (ch)
                       : "cc"
                       );
                    --remainingPrecision;
                    if ( remainingPrecision < 0 ) break;
                DECIMAL_POINT_RETURN_NUM8:
                    NEXT_CHAR(pEnd);
                    if ( ch == DECIMAL_DELIM) goto DECIMAL_POINT_CHECK_NUM8;
                    ch = ch - '0';
                    }
                while (ch <= 9);

                if ( flags & FPF_DECIMAL_POINT ) {
                    // missingScale -= ( decPntPos - remainingPrecision );
                    uint decPnt = decPntPos;
                    missingScale -= decPnt;
                    if ( missingScale > 0 ) goto TOO_MANY_DIGITS_BEFORE_DP;
                    missingScale += remainingPrecision;
                    if ( missingScale < 0 ) goto TOO_MANY_DIGITS_AFTER_DP;
                    }
                else if ( remainingPrecision < missingScale ) goto TOO_MANY_DIGITS_BEFORE_DP;

                // no deferred multiplies, val is 0
                if ( missingScale != 0 ) {
                    uint tmp;
                    if ( missingScale > 9 ) {
                        missingScale -= 9;
                        register uint ten9 REG(edx) = 1000000000;
                        vhi *= ten9;
                        asm(   "mull	%2\n"
                           "	addl	%2,%0"
                           : "+r" (vhi), "+a" (vlo), "+d" (ten9)
                           :
                           : "cc"
                           );
                        }
                    register uint multiplier REG(edx) = powerOfTen[ missingScale ];
                    vhi *= multiplier;
                    asm(   "mull	%2\n"
                       "	addl	%2,%0"
                       : "+r" (vhi), "+a" (vlo), "+d" (multiplier)
                       :
                       : "cc"
                       );
                    }

            CHECK_NEGATE_NUM8:
                CMOVE_NEG2(flags, vhi, vlo);

            STORE_ZERO_NUM8:
                // Numeric "digits" are in BigEndian order
                ((int*)REG_pField)[0] = vhi;
                ((int*)REG_pField)[1] = vlo;
                goto NEXT_FIELD;

            DECIMAL_POINT_CHECK_NUM8:
                if ( flags & FPF_DECIMAL_POINT ) goto MULTIPLE_DECIMAL_POINTS;
            DECIMAL_POINT_NUM8:
                flags |= FPF_DECIMAL_POINT;
                decPntPos = remainingPrecision;
                goto DECIMAL_POINT_RETURN_NUM8;

            CHECK_SIGNS_NUM8:
                if ( ch == '-' ) goto MINUS_SIGN_NUM8;
                if ( ch == '+' ) goto PLUS_SIGN_NUM8;
                /* Fix for SWS-66788.In nzload, the -nullValue is sometimes being interpreted as
                   bad data (and thus failing) ... rather than being interpreted as a null value.. */
                if ( pText[0] < '0' || pText[0] > '9' ) {
                    SKIP_SPACES_ELSE(EMPTY_NUMERIC8);
                    goto RESTART_NUM8;
                }
                if ( ch == DECIMAL_DELIM) goto LEADING_DECIMAL_POINT_NUM8;
                SKIP_SPACES_ELSE(EMPTY_NUMERIC8);
                goto RESTART_NUM8;

            MINUS_SIGN_NUM8:
                flags |= FPF_NEGATE;
            PLUS_SIGN_NUM8:
                NEXT_CHAR(pEnd);
                if ( ch > '0' && ch <= '9' ) goto COLLECT_VALUE_NUM8;
                if ( ch == DECIMAL_DELIM) goto LEADING_DECIMAL_POINT_NUM8;
                if ( ch != '0' ) goto EXPECTED_DIGIT_OR_DECIMAL_POINT;
            LEADING_0_NUM8:
                NEXT_CHAR(pEnd);
                if ( ch > '0' && ch <= '9' ) goto COLLECT_VALUE_NUM8;
                if ( ch == DECIMAL_DELIM ) goto DECIMAL_POINT_NUM8;
                if ( ch != '0' ) goto STORE_ZERO_NUM8;
                goto LEADING_0_NUM8;

            LEADING_DECIMAL_POINT_NUM8:
                flags |= FPF_DECIMAL_POINT;
                decPntPos = remainingPrecision;
                NEXT_CHAR(pEnd);
                if ( ch >= '0' && ch <= '9' ) goto COLLECT_VALUE_NUM8;
                goto EXPECTED_DIGIT;
            }
#endif // PT_NUMERIC8 | JUST_COMPILE
// =============================
#if PT_NUMERIC16 | JUST_COMPILE
            case PT_NUMERIC16:
                {
                BEGIN_CASE(14);

                // Initialize the final value
                ((long*)REG_pField)[0] = 0;
                ((long*)REG_pField)[1] = 0;
                ((long*)REG_pField)[2] = 0;
                ((long*)REG_pField)[3] = 0;
                int remainingPrecision = decimalToEncoded[ declExtra & 0xFF ];
                int missingScale = declExtra >> 8;
                uint savedVal = 0;
                uint finish9 = 0;

            RESTART_NUM16:
                uint8 iter = 0;
                uint val = 0;
                if ( ch == '0' ) goto LEADING_0_NUM16;
                if ( ch < '0' || ch > '9' ) goto CHECK_SIGNS_NUM16;
                {
            COLLECT_VALUE_NUM16:
                ch = ch - '0';
                do {
                    val *= 10;
                    val += ch;
                    --remainingPrecision;
                    if ( (remainingPrecision & 0xF) == 0 ) {
                        uint localIter; localIter = iter;
                        switch ( localIter ) {
                            uint hi, lo;
                        default:
                            // digit counting guarantees no overflow
                            ((long*)REG_pField)[0] *= powerOfTen[9];
                        case 3:
                            asm(   "movl	4(%2),%1\n"
                               "	mull	%3\n"
                               "	movl	%1,4(%2)\n"
                               "	addl	%0,(%2)\n"
                               : "=&d" (hi), "=&a" (lo), "+r" (REG_pField)
                               : "m" (powerOfTen[9])
                               : "cc"
                               );
                        case 2:
                            asm(   "movl	8(%2),%1\n"
                               "	mull	%3\n"
                               "	movl	%1,8(%2)\n"
                               "	addl	%0,4(%2)\n"
                               "	jnc		1f\n"
                               "	incl	(%2)\n"
                               "1:"
                               : "=&d" (hi), "=&a" (lo), "+r" (REG_pField)
                               : "m" (powerOfTen[9])
                               : "cc"
                               );
                        case 1:
                            asm(   "movl	12(%2),%1\n"
                               "	mull	%3\n"
                               "	movl	%1,12(%2)\n"
                               "	addl	%0,8(%2)\n"
                               "	jnc		1f\n"
                               "	incl	4(%2)\n"
                               "	jnz		1f\n"
                               "	incl	(%2)\n"
                               "1:"
                               : "=&d" (hi), "=&a" (lo), "+r" (REG_pField)
                               : "m" (powerOfTen[9])
                               : "cc"
                               );
                        case 0:
                            asm(   "addl	%3,12(%2)\n"
                               "	jnc		1f\n"
                               "	incl	8(%2)\n"
                               "	jnz		1f\n"
                               "	incl	4(%2)\n"
                               "	jnz		1f\n"
                               "	incl	(%2)\n"
                               "1:"
                               : "=&d" (hi), "=&a" (lo), "+r" (REG_pField)
                               : "r" (val)
                               : "cc"
                               );
                            }
                        ++iter;
                        remainingPrecision -= (16-9);
                        val = 0;
                        }
                    if ( remainingPrecision < (0-(16-9)) ) break;
                DECIMAL_POINT_RETURN_NUM16:
                    NEXT_CHAR(pEnd);
                    if ( ch == DECIMAL_DELIM ) goto DECIMAL_POINT_CHECK_NUM16;
                    ch = ch - '0';
                    }
                while (ch <= 9);

                savedVal = val;
                finish9 = remainingPrecision & 0xF;
                if ( remainingPrecision == (0-(16-9)) ) remainingPrecision = 0;
                remainingPrecision = encodedToDecimal[ remainingPrecision ];

                if ( flags & FPF_DECIMAL_POINT ) {
                    // missingScale -= ( decPntPos - remainingPrecision );
                    uint decPnt = decPntPos;
                    // evaluate ENC2DEC() procedurally because GCC insists on
                    // materializing the array address and hence ends up one
                    // register short of what we would like.
                    ENC2DEC( decPnt );
                    missingScale -= decPnt;
                    if ( missingScale > 0 ) goto TOO_MANY_DIGITS_BEFORE_DP;
                    missingScale += remainingPrecision;
                    if ( missingScale < 0 ) goto TOO_MANY_DIGITS_AFTER_DP;
                    }
                else if ( remainingPrecision < missingScale ) goto TOO_MANY_DIGITS_BEFORE_DP;

                if ( finish9 == 9 ) {
                    // no deferred multiplies, savedVal is 0
                    if ( missingScale == 0 ) goto CHECK_NEGATE_NUM16;
                    }
                else {
                    uint* pPow10 = powerOfTen;
                    uint multiplier;
                    if ( finish9 >= missingScale )
                        // can accomplish all remaining scaling in a single pass
                        multiplier = pPow10[ missingScale ];
                    else
                        // must perform multiple passes
                        multiplier = pPow10[ finish9 ];
                    savedVal *= multiplier;
                    missingScale += 9;
                    missingScale -= finish9;
                    }

                uint localIter; localIter = iter;
                do {
                    uint multiplier;
                    if ( missingScale < 9 )
                        multiplier = powerOfTen[ missingScale ];
                    else
                        multiplier = powerOfTen[9];

                    switch ( localIter ) {
                        uint hi, lo;
                    default:
                        // digit counting guarantees no overflow
                        ((long*)REG_pField)[0] *= multiplier;
                    case 3:
                        asm(   "movl	4(%2),%1\n"
                           "	mull	%3\n"
                           "	movl	%1,4(%2)\n"
                           "	addl	%0,(%2)\n"
                           : "=&d" (hi), "=&a" (lo), "+r" (REG_pField)
                           : "g" (multiplier)
                           : "cc"
                           );
                    case 2:
                        asm(   "movl	8(%2),%1\n"
                           "	mull	%3\n"
                           "	movl	%1,8(%2)\n"
                           "	addl	%0,4(%2)\n"
                           "	jnc		1f\n"
                           "	incl	(%2)\n"
                           "1:"
                           : "=&d" (hi), "=&a" (lo), "+r" (REG_pField)
                           : "g" (multiplier)
                           : "cc"
                           );
                    case 1:
                        asm(   "movl	12(%2),%1\n"
                           "	mull	%3\n"
                           "	movl	%1,12(%2)\n"
                           "	addl	%0,8(%2)\n"
                           "	jnc		1f\n"
                           "	incl	4(%2)\n"
                           "	jnz		1f\n"
                           "	incl	(%2)\n"
                           "1:"
                           : "=&d" (hi), "=&a" (lo), "+r" (REG_pField)
                           : "g" (multiplier)
                           : "cc"
                           );
                    case 0:
                        asm(   "addl	%3,12(%2)\n"
                           "	jnc		1f\n"
                           "	incl	8(%2)\n"
                           "	jnz		1f\n"
                           "	incl	4(%2)\n"
                           "	jnz		1f\n"
                           "	incl	(%2)\n"
                           "1:"
                           : "=&d" (hi), "=&a" (lo), "+r" (REG_pField)
                           : "r" (savedVal)
                           : "cc"
                           );
                        }
                    ++localIter;
                    savedVal = 0;
                    missingScale -= 9;
                    }
                while ( missingScale > 0 );
                }
            CHECK_NEGATE_NUM16:
                if ( flags & FPF_NEGATE ) {
                    uint t0, t1, t2, t3;
                    asm volatile
                        (  "movl	$0,%3\n"
                        "	subl	12(%4),%3\n"
                        "	movl	$0,%2\n"
                        "	sbbl	8(%4),%2\n"
                        "	movl	$0,%1\n"
                        "	sbbl	4(%4),%1\n"
                        "	movl	$0,%0\n"
                        "	sbbl	(%4),%0\n"
                        "	movl	%3,12(%4)\n"
                        "	movl	%2,8(%4)\n"
                        "	movl	%1,4(%4)\n"
                        "	movl	%0,(%4)"
                        : "=&r" (t0), "=&r" (t1), "=&r" (t2), "=&r" (t3), "+r" (REG_pField)
                        :
                        : "cc"
                       );
                    }
                goto NEXT_FIELD;


            DECIMAL_POINT_CHECK_NUM16:
                if ( flags & FPF_DECIMAL_POINT ) goto MULTIPLE_DECIMAL_POINTS;
            DECIMAL_POINT_NUM16:
                flags |= FPF_DECIMAL_POINT;
                decPntPos = remainingPrecision;
                goto DECIMAL_POINT_RETURN_NUM16;

            CHECK_SIGNS_NUM16:
                if ( ch == '-' ) goto MINUS_SIGN_NUM16;
                if ( ch == '+' ) goto PLUS_SIGN_NUM16;
                /* Fix for SWS-66788.In nzload, the -nullValue is sometimes being interpreted as
                   bad data (and thus failing) ... rather than being interpreted as a null value.. */
                if ( pText[0] < '0' || pText[0] > '9' ) {
                    SKIP_SPACES_ELSE(EMPTY_NUMERIC16);
                    goto RESTART_NUM16;
                }
                if ( ch == DECIMAL_DELIM) goto LEADING_DECIMAL_POINT_NUM16;
                SKIP_SPACES_ELSE(EMPTY_NUMERIC16);
                goto RESTART_NUM16;

            MINUS_SIGN_NUM16:
                flags |= FPF_NEGATE;
            PLUS_SIGN_NUM16:
                NEXT_CHAR(pEnd);
                if ( ch > '0' && ch <= '9' ) goto COLLECT_VALUE_NUM16;
                if ( ch == DECIMAL_DELIM) goto LEADING_DECIMAL_POINT_NUM16;
                if ( ch != '0' ) goto EXPECTED_DIGIT_OR_DECIMAL_POINT;
            LEADING_0_NUM16:
                NEXT_CHAR(pEnd);
                if ( ch > '0' && ch <= '9' ) goto COLLECT_VALUE_NUM16;
                if ( ch == DECIMAL_DELIM ) goto DECIMAL_POINT_NUM16;
                if ( ch != '0' ) goto NEXT_FIELD;
                goto LEADING_0_NUM16;

            LEADING_DECIMAL_POINT_NUM16:
                flags |= FPF_DECIMAL_POINT;
                decPntPos = remainingPrecision;
                NEXT_CHAR(pEnd);
                if ( ch >= '0' && ch <= '9' ) goto COLLECT_VALUE_NUM16;
                goto EXPECTED_DIGIT;
            }
#endif // PT_NUMERIC16 | JUST_COMPILE
// =============================
#if PT_DATE_N_DMMMY | JUST_COMPILE
            case PT_DATE_N_DMMMY:
                {
                BEGIN_CASE(15);

                uint digit;

                // [SPACES] DIGIT DIGIT
                day = ch - '0';
                if ( day > 9 ) goto SPACES_N_DMMMY;
            SPACES_RETURN_N_DMMMY:
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit > 9) goto EXPECTED_DAY_DIGIT;
                NEXT_CHAR(pEnd);
                day *= 10;
                day += digit;

                // MMM
                MATCH_MMM_MONTH;
                goto TRAILING_YEAR;

            SPACES_N_DMMMY:
                SKIP_SPACES_ELSE(EMPTY_DATE);
                day = ch - '0';
                if ( day <= 9 ) goto SPACES_RETURN_N_DMMMY;
                goto EMPTY_DATE;
                }
#endif // PT_DATE_N_DMMMY | JUST_COMPILE
// =============================
#if PT_DATE_D_DMMMY | JUST_COMPILE
            case PT_DATE_D_DMMMY:
                {
                BEGIN_CASE(16);

                uint digit;

                // [SPACES] DIGIT [DIGIT]
                day = ch - '0';
                if ( day > 9 ) goto SPACES_D_DMMMY;
            SPACES_RETURN_D_DMMMY:
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    day *= 10;
                    day += digit;
                    }

                // DELIM
                REQUIRE(ch,dateDelim,EXPECTED_DATE_DELIMITER,pEnd);

                // MMM
                MATCH_MMM_MONTH;
                goto DATE_DELIM_AND_TRAILING_YEAR;

            SPACES_D_DMMMY:
                SKIP_SPACES_ELSE(EMPTY_DATE);
                day = ch - '0';
                if ( day <= 9 ) goto SPACES_RETURN_D_DMMMY;
                goto EMPTY_DATE;
                }
#endif // PT_DATE_D_DMMMY | JUST_COMPILE
// =============================
#if PT_DATE_N_DMY | JUST_COMPILE
            case PT_DATE_N_DMY:
                {
                BEGIN_CASE(17);

                uint digit;

                // [SPACES] DIGIT DIGIT
                day = ch - '0';
                if ( day > 9 ) goto SPACES_N_DMY;
            SPACES_RETURN_N_DMY:
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit > 9) goto EXPECTED_DAY_DIGIT;
                NEXT_CHAR(pEnd);
                day *= 10;
                day += digit;

                // DIGIT DIGIT
                month = ch - '0';
                if ( month > 9 ) goto EXPECTED_MONTH_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit > 9) goto EXPECTED_MONTH_DIGIT;
                NEXT_CHAR(pEnd);
                month *= 10;
                month += digit;

                goto TRAILING_YEAR;

            SPACES_N_DMY:
                SKIP_SPACES_ELSE(EMPTY_DATE);
                day = ch - '0';
                if ( day <= 9 ) goto SPACES_RETURN_N_DMY;
                goto EMPTY_DATE;
                }
#endif // PT_DATE_N_DMY | JUST_COMPILE
// =============================
#if PT_DATE_D_DMY | JUST_COMPILE
            case PT_DATE_D_DMY:
                {
                BEGIN_CASE(18);

                uint digit;

                // [SPACES] DIGIT [DIGIT]
                day = ch - '0';
                if ( day > 9 ) goto SPACES_D_DMY;
            SPACES_RETURN_D_DMY:
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    day *= 10;
                    day += digit;
                    }

                // DELIM
                REQUIRE(ch,dateDelim,EXPECTED_DATE_DELIMITER,pEnd);

                // DIGIT [DIGIT]
                month = ch - '0';
                if ( month > 9 ) goto EXPECTED_MONTH_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    month *= 10;
                    month += digit;
                    }

                goto DATE_DELIM_AND_TRAILING_YEAR;

            SPACES_D_DMY:
                SKIP_SPACES_ELSE(EMPTY_DATE);
                day = ch - '0';
                if ( day <= 9 ) goto SPACES_RETURN_D_DMY;
                goto EMPTY_DATE;
                }
#endif // PT_DATE_D_DMY | JUST_COMPILE
// =============================
#if PT_DATE_N_MDY | JUST_COMPILE
            case PT_DATE_N_MDY:
                {
                BEGIN_CASE(19);

                uint digit;

                // [SPACES] DIGIT DIGIT
                month = ch - '0';
                if ( month > 9 ) goto SPACES_N_MDY;
            SPACES_RETURN_N_MDY:
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit > 9) goto EXPECTED_MONTH_DIGIT;
                NEXT_CHAR(pEnd);
                month *= 10;
                month += digit;

                // DIGIT DIGIT
                day = ch - '0';
                if ( day > 9 ) goto EXPECTED_DAY_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if ( day > 9 ) goto EXPECTED_DAY_DIGIT;
                NEXT_CHAR(pEnd);
                day *= 10;
                day += digit;

                goto TRAILING_YEAR;

            SPACES_N_MDY:
                SKIP_SPACES_ELSE(EMPTY_DATE);
                month = ch - '0';
                if ( month <= 9 ) goto SPACES_RETURN_N_MDY;
                goto EMPTY_DATE;
                }
#endif // PT_DATE_N_MDY | JUST_COMPILE
// =============================
#if PTN_DATE_MMM_D_Y | JUST_COMPILE
            case PTN_DATE_MMM_D_Y:
                NULL_TOKEN_CHECK;
#endif
#if PT_DATE_MMM_D_Y | JUST_COMPILE
            case PT_DATE_MMM_D_Y:
#endif
#if PT_DATE_MMM_D_Y | PTN_DATE_MMM_D_Y | JUST_COMPILE
                {
                BEGIN_CASE(20);

                uint digit;

                // MMM
                MATCH_MMM_MONTH;

                // DELIM
                REQUIRE(ch,dateDelim,EXPECTED_DATE_DELIMITER,pEnd);

                // SPACE DIGIT or DIGIT [DIGIT]
                day = ch - '0';
                if ( day > 9 ) {
                    // Allow 2nd ' ' in-lieu of a digit only if dateDelim is ' '
                    if ( dateDelim != ' ' ) goto EXPECTED_DAY_DIGIT;
                    COND_CH(' ', EXPECTED_DAY_DIGIT_OR_SPACE);
                    day = ch - '0';
                    if ( day <= 9 ) goto CONSUME_DAY_DIGIT;
                    goto EXPECTED_DAY_DIGIT;
                    }
                else {
                    NEXT_CHAR(pEnd);
                    digit = ch - '0';
                    if (digit <= 9) {
                        day *= 10;
                        day += digit;
                CONSUME_DAY_DIGIT:
                        NEXT_CHAR(pEnd);
                        }
                    }

                // DELIM | COMMA | COMMA DELIM
                if ( ch != dateDelim ) {
                    COND_CH(',', EXPECTED_COMMA_OR_DATE_DELIM);
                    if ( ch != dateDelim ) goto TRAILING_YEAR;
                    }
                NEXT_CHAR(pEnd);
                goto TRAILING_YEAR;
                }
#endif // PT_DATE_MMM_D_Y | PTN_DATE_MMM_D_Y | JUST_COMPILE
// =============================
#if PT_DATE_D_MDY | JUST_COMPILE
            case PT_DATE_D_MDY:
#endif
#if TRAILING_YEAR_SUPPORT
                {
                uint digit;
#endif
#if PT_DATE_D_MDY | JUST_COMPILE
                BEGIN_CASE(21);

                // [SPACES] DIGIT [DIGIT]
                month = ch - '0';
                if ( month > 9 ) goto SPACES_D_MDY;
            SPACES_RETURN_D_MDY:
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    month *= 10;
                    month += digit;
                    }

                // DELIM
                REQUIRE(ch,dateDelim,EXPECTED_DATE_DELIMITER,pEnd);

                // DIGIT [DIGIT]
                day = ch - '0';
                if ( day > 9 ) goto EXPECTED_DAY_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    day *= 10;
                    day += digit;
                    }
#endif //  PT_DATE_D_MDY | JUST_COMPILE
#if DATE_DELIM_AND_TRAILING_YEAR_SUPPORT
            DATE_DELIM_AND_TRAILING_YEAR:

                // DELIM
                REQUIRE(ch,dateDelim,EXPECTED_DATE_DELIMITER,pEnd);
#endif
#if TRAILING_YEAR_SUPPORT
            TRAILING_YEAR:

                // [SPACES] DIGIT DIGIT DIGIT DIGIT
                year = ch - '0';
                if ( year > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                year *= 10;
                year += digit;
                uint y2b; y2b = y2Base;
                if ( y2b ) goto TRAILING_Y2;
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                year *= 10;
                year += digit;
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                year *= 10;
                year += digit;
                goto DATE_COMMON_TAIL;

            TRAILING_Y2:
                asm(   "cmpl	%1,%0\n"
                   "	cmovll	%2,%0"
                   : "+r" (year)
                   :  "r" (y2b), "g" (year+100)
                   : "cc"
                   );
                year += 1900;
                goto DATE_COMMON_TAIL;
#endif
#if PT_DATE_D_MDY | JUST_COMPILE
            SPACES_D_MDY:
                SKIP_SPACES_ELSE(EMPTY_DATE);
                month = ch - '0';
                if ( month <= 9 ) goto SPACES_RETURN_D_MDY;
                goto EMPTY_DATE;
#endif
#if TRAILING_YEAR_SUPPORT
                }
#endif
// =============================
#if PT_DATE_N_YMD | JUST_COMPILE
            case PT_DATE_N_YMD:
                {
                BEGIN_CASE(22);

                uint digit;

                // [SPACES] DIGIT DIGIT DIGIT DIGIT
                year = ch - '0';
                if ( year > 9 ) goto SPACES_N_YMD;
            SPACES_RETURN_N_YMD:
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                year *= 10;
                year += digit;
                uint y2b; y2b = y2Base;
                if ( y2b ) goto N_Y2MD;
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                year *= 10;
                year += digit;
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                year *= 10;
                year += digit;
            N_Y2MD_RETURN:

                // DIGIT DIGIT
                month = ch - '0';
                if ( month > 9 ) goto EXPECTED_MONTH_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_MONTH_DIGIT;
                NEXT_CHAR(pEnd);
                month *= 10;
                month += digit;

                // DIGIT DIGIT
                day = ch - '0';
                if ( day > 9 ) goto EXPECTED_DAY_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_DAY_DIGIT;
                NEXT_CHAR(pEnd);
                day *= 10;
                day += digit;
                goto DATE_COMMON_TAIL;

            SPACES_N_YMD:
                SKIP_SPACES_ELSE(EMPTY_DATE);
                year = ch - '0';
                if ( year <= 9 ) goto SPACES_RETURN_N_YMD;
                goto EMPTY_DATE;

            N_Y2MD:
                asm(   "cmpl	%1,%0\n"
                   "	cmovll	%2,%0"
                   : "+r" (year)
                   :  "r" (y2b), "g" (year+100)
                   : "cc"
                   );
                year += 1900;
                goto N_Y2MD_RETURN;
                }
#endif // PT_DATE_N_YMD | JUST_COMPILE
// =============================
#if PT_DATE_D_YMD | JUST_COMPILE
            case PT_DATE_D_YMD:
#endif
#if DATE_COMMON_TAIL_SUPPORT
                {
#endif
#if PT_DATE_D_YMD | JUST_COMPILE
                BEGIN_CASE(23);

                uint digit;

                // [SPACES] DIGIT DIGIT DIGIT DIGIT
                year = ch - '0';
                if ( year > 9 ) goto SPACES_D_YMD;
            SPACES_RETURN_D_YMD:
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                year *= 10;
                year += digit;
                uint y2b; y2b = y2Base;
                if ( y2b ) goto D_Y2MD;
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                year *= 10;
                year += digit;
                digit = ch - '0';
                if ( digit > 9 ) goto EXPECTED_YEAR_DIGIT;
                NEXT_CHAR(pEnd);
                year *= 10;
                year += digit;
            D_Y2MD_RETURN:

                // DELIM
                REQUIRE(ch,dateDelim,EXPECTED_DATE_DELIMITER,pEnd);

                // DIGIT [DIGIT]
                month = ch - '0';
                if ( month > 9 ) goto EXPECTED_MONTH_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    month *= 10;
                    month += digit;
                    }

                // DELIM
                REQUIRE(ch,dateDelim,EXPECTED_DATE_DELIMITER,pEnd);

                // DIGIT [DIGIT]
                day = ch - '0';
                if ( day > 9 ) goto EXPECTED_DAY_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    day *= 10;
                    day += digit;
                    }
                goto DATE_COMMON_TAIL;

            SPACES_D_YMD:
                SKIP_SPACES_ELSE(EMPTY_DATE);
                year = ch - '0';
                if ( year <= 9 ) goto SPACES_RETURN_D_YMD;
                goto EMPTY_DATE;

            D_Y2MD:
                asm(   "cmpl	%1,%0\n"
                   "	cmovll	%2,%0"
                   : "+r" (year)
                   :  "r" (y2b), "g" (year+100)
                   : "cc"
                   );
                year += 1900;
                goto D_Y2MD_RETURN;
#endif // PT_DATE_D_YMD | JUST_COMPILE
#if DATE_COMMON_TAIL_SUPPORT
            DATE_COMMON_TAIL:
                if ( day == 0 ) goto ZERO_DAY;
                if ( month == 0 ) goto ZERO_MONTH;
                if ( month > 12 ) goto MONTH_TOO_LARGE;

                int yi = yearInfo[year];
                uint leapBit = yi & 1;
                month += leapBit * (sizeof(monthInfo.Normal) / sizeof(monthInfo.Normal[0]));
                yi >>= 1;
                day += monthInfo.Normal[month];
                if ( day > monthInfo.Normal[month+1] ) goto DAY_TOO_LARGE_FOR_MONTH;
                ENCACHE_REG(pFldPrsCtl);
                REG_pField = pField;
                yi += day;
                parseDataType = REG_pFldPrsCtl->extra.tsTimeFormat;
                *((int*)REG_pField) = yi;
                if ( parseDataType == 0 ) goto NEXT_FIELD;
                // Date value is available to time[stamp] parsing from *((int*)REG_pField)
//                 REG_pFldPrsCtl = pFldPrsCtl;
                ENCACHE_REG(pEnd);
                goto TIMESTAMP_REDISPATCH;
                }
#endif // DATE_COMMON_TAIL_SUPPORT
// ===========================
// Accepted interval syntax:
//   ' '*
//   [ [ '-' ] <digit>+ ' '*     'y'['e'['a'['r'['s']]]]  ' '* ]
//   [ [ '-' ] <digit>+ ' '* 'm'['o'['n'['t'['h'['s']]]]] ' '* ]
//   [ [ '-' ] <digit>+ ' '*         'd'['a'['y'['s']]]   ' '* ]
//   [ [ '-' ] <time> ]
//
// Note: time style is interpreted as 24 hours irrespective of that used
// for parsing other temporal types.  If the timeDelim is empty ('') then
// hours is restricted to 0..23.
//
//
// pField[0]: timeLo
// pField[1]: timeHi (signed)
// pField[2]: months (signed)
//
// timeHi:timeLo is a signed 64 bit count of micro-seconds
//
// micro-seconds per hour:                       1000000*60*60
// max hours:              0x7fffffffffffffff / (1000000*60*60)
// multiply hours by micro-seconds per hour to convert to micro-seconds
//
// micro-seconds per day:                        1000000*60*60*24
// max days:               0x7fffffffffffffff / (1000000*60*60*24)
// multiply days by micro-seconds per day to convert to micro-seconds
//
// max months: 0x7fffffff
// multiply years by 12 to convert to months
// max years:  0x7fffffff/12
//
// At present the interval parsing code enforces an arbitrary limitation
// months inherited from Postgres' original floating point representation
// for intervals.  This restricts total months to +/- 3000000.

#if PTN_INTERVAL
            case PTN_INTERVAL:
                NULL_TOKEN_CHECK;
                // simply check at bottom of time parsing
#if PT_INTERVAL
                parseDataType = PT_INTERVAL;
#endif
#endif
#if PT_INTERVAL
            case PT_INTERVAL:
#endif
#if INTERVAL_SUPPORT
                {
                BEGIN_CASE(31);

                ((int*)REG_pField)[2] = 0; // years and months if missing
                *(int64*)REG_pField = 0;   // days as micro-seconds  (negate immediately)
# if !TIME_N_SUPPORT
                intervalHours.i64 = 0;     // hours as micro-seconds (negate after collecting time)
# endif

            INTERVAL_RESTART:
# if TIME_N_SUPPORT
                pTextHours = pText;
# endif
                val = ch - '0';
                if (val > 9) {
                    if ( ch == '-' ) {
                        flags |= FPF_NEGATE;
                        NEXT_CHAR(pEnd);
# if TIME_N_SUPPORT
                        pTextHours = pText;
# endif
                        val = ch - '0';
                    }
                    else {
                        SKIP_SPACES_ELSE(EMPTY_INTERVAL);
                        goto INTERVAL_RESTART;
                    }
                }
                NEXT_CHAR(pEnd);
                COLLECT_UNSIGNED_INT(val, INTERVAL_OVERFLOW); // leaves ch biased by -'0'
                ch += '0';
                SKIP_SPACES;
                COND_CH('y', INTERVAL_MAYBE_MONTHS);
                COND_CH('e', INTERVAL_YEARS);
                COND_CH('a', INTERVAL_YEARS);
                COND_CH('r', INTERVAL_YEARS);
                COND_CH('s', INTERVAL_YEARS);
            INTERVAL_YEARS:
                if (val > (0x7fffffff/12)) goto INTERVAL_YEARS_RANGE;
                CMOVE_NEG(flags, val);
                flags &= ~FPF_NEGATE;
                val *= 12;
                ((int*)REG_pField)[2] = val;

                SKIP_SPACES;
# if TIME_N_SUPPORT
                pTextHours = pText;
# endif
                val = ch - '0';
                if (val > 9) {
                    if ( ch != '-' ) goto INTERVAL_VALIDATE_MONTHS;
                    flags |= FPF_NEGATE;
                    NEXT_CHAR(pEnd);
# if TIME_N_SUPPORT
                    pTextHours = pText;
# endif
                    val = ch - '0';
                    if (val > 9) goto EXPECTED_DIGIT;
                }
                NEXT_CHAR(pEnd);
                COLLECT_UNSIGNED_INT(val, INTERVAL_OVERFLOW); // leaves ch biased by -'0'
                ch += '0';
                SKIP_SPACES;
            INTERVAL_MAYBE_MONTHS:
                COND_CH('m', INTERVAL_MAYBE_DAYS);
                COND_CH('o', INTERVAL_MONTHS);
                COND_CH('n', INTERVAL_MONTHS);
                COND_CH('t', INTERVAL_MONTHS);
                COND_CH('h', INTERVAL_MONTHS);
                COND_CH('s', INTERVAL_MONTHS);
            INTERVAL_MONTHS:
                if (val > (0x7fffffff)) goto INTERVAL_MONTHS_RANGE;
                CMOVE_NEG(flags, val);
                flags &= ~FPF_NEGATE;
                {// Combine years and months while checking for overflow
                    bool ovf;
                    asm(   "addl	%[val],%[months]\n"
                       "	setob	%[ovf]\n"
                       : [ovf]    "=qQm" (ovf)
                       , [months]   "+g" (((int*)REG_pField)[2])
                       : [val]       "r" (val)
                       : "cc"
                       );
                    if (ovf) goto INTERVAL_SUM_YEAR_MONTH_OVERFLOW;
                }
            INTERVAL_VALIDATE_MONTHS:
                // Validate arbitrary frontend imposed range
                if (((int*)REG_pField)[2] > MAX_INTERVAL_MONTHS || ((int*)REG_pField)[2] < -MAX_INTERVAL_MONTHS) goto INTERVAL_PG_MAX_MONTHS;

                SKIP_SPACES;
# if TIME_N_SUPPORT
                pTextHours = pText;
# endif
                val = ch - '0';
                if (val > 9) {
                    if ( ch != '-' ) goto NEXT_FIELD;
                    flags |= FPF_NEGATE;
                    NEXT_CHAR(pEnd);
# if TIME_N_SUPPORT
                    pTextHours = pText;
# endif
                    val = ch - '0';
                    if (val > 9) goto EXPECTED_DIGIT;
                }
                NEXT_CHAR(pEnd);
                COLLECT_UNSIGNED_INT(val, INTERVAL_OVERFLOW); // leaves ch biased by -'0'
                ch += '0';
                SKIP_SPACES;
            INTERVAL_MAYBE_DAYS:
                COND_CH('d', INTERVAL_TIME_HAVE_HOURS);
                COND_CH('a', INTERVAL_DAYS);
                COND_CH('y', INTERVAL_DAYS);
                COND_CH('s', INTERVAL_DAYS);
            INTERVAL_DAYS:
                if (val > (unsigned)(((1ULL<<63)-1)/(1000000ULL*60*60*24))) goto INTERVAL_DAYS_RANGE;
                CMOVE_NEG(flags, val);
                flags &= ~FPF_NEGATE;
                *(int64*)REG_pField = ((int64)((int)val)) * (1000000LL*60*60*24);

                SKIP_SPACES;
                goto INTERVAL_TIME_HAVE_DAYS;
                }
#endif // INTERVAL_SUPPORT

























// =============================
#if PT_TIME_N_24 | JUST_COMPILE
            case PT_TIME_N_24:
#endif
#if PT_TIME_D_24 | JUST_COMPILE
            case PT_TIME_D_24:
#endif
#if PT_TIME_N_12 | JUST_COMPILE
            case PT_TIME_N_12:
#endif
#if PT_TIME_D_12 | JUST_COMPILE
            case PT_TIME_D_12:
#endif
#if PT_TIME_N_24_TZ | JUST_COMPILE
            case PT_TIME_N_24_TZ:
#endif
#if PT_TIME_D_24_TZ | JUST_COMPILE
            case PT_TIME_D_24_TZ:
#endif
#if PT_TIME_N_12_TZ | JUST_COMPILE
            case PT_TIME_N_12_TZ:
#endif
#if PT_TIME_D_12_TZ | JUST_COMPILE
            case PT_TIME_D_12_TZ:
#endif
#if PT_TIME_N_24_TRUNC | JUST_COMPILE
            case PT_TIME_N_24_TRUNC:
#endif
#if PT_TIME_D_24_TRUNC | JUST_COMPILE
            case PT_TIME_D_24_TRUNC:
#endif
#if PT_TIME_N_12_TRUNC | JUST_COMPILE
            case PT_TIME_N_12_TRUNC:
#endif
#if PT_TIME_D_12_TRUNC | JUST_COMPILE
            case PT_TIME_D_12_TRUNC:
#endif
#if TIME_SUPPORT
                {
                BEGIN_CASE(24);

                register uint timeLo REG(eax);
                uint minutes;
                uint seconds;
                uint digit;

                // [SPACES] DIGIT [DIGIT]
            INTERVAL_TIME_HOURS_NO_DELIM:
                timeLo = ch - '0';
                if ( timeLo > 9 ) goto SPACES_TIME;
            SPACES_RETURN_TIME:
                NEXT_CHAR(pEnd);

#if TIME_N_SUPPORT | JUST_COMPILE
                // DIGIT DIGIT
                digit = ch - '0';
                if (digit > 9) goto EXPECTED_HOUR_DIGIT;
                NEXT_CHAR(pEnd);
                timeLo *= 10;
                timeLo += digit;

#if TIME_24_SUPPORT | JUST_COMPILE
            	if (bEnableTime24)
                {
                   if ( timeLo > 24 ) goto HOURS25_TOO_LARGE;
                }
                else
                {
                   if ( timeLo > 23 ) goto HOURS24_TOO_LARGE;
                }
#endif
#if TIME_12_SUPPORT | JUST_COMPILE
# if INTERVAL_SUPPORT
                if (parseDataType ==
#  if PT_INTERVAL
                                     PT_INTERVAL
#  else
                                     PTN_INTERVAL
#  endif
                                                 ) {
                    if ( timeLo > 23 ) goto HOURS24_TOO_LARGE;
                }
                else {
# endif
                if ( timeLo > 12 ) goto HOURS12_TOO_LARGE;
                if ( timeLo == 12 ) timeLo = 0;
# if INTERVAL_SUPPORT
                }
#endif
#endif
                // DIGIT DIGIT
                minutes = ch - '0';
                if ( minutes > 9 ) goto EXPECTED_MINUTE_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit > 9) goto EXPECTED_MINUTE_DIGIT;
                NEXT_CHAR(pEnd);
                minutes *= 10;
                minutes += digit;
                if ( minutes > 59 ) goto MINUTES_TOO_LARGE;
#if TIME_24_SUPPORT | JUST_COMPILE
                {
                	if (bEnableTime24)
                	{
                		if (timeLo == 24 && minutes > 0  ) goto TIME_GREATER_THAN_240000;
                   	}
                }
#endif
                timeLo *= 60;
                timeLo += minutes;

                // [DIGIT DIGIT]
                seconds = 0;
                if ( ch < '0' || ch > '9' ) goto NO_SECONDS;
                seconds = ch - '0';
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit > 9) goto EXPECTED_SECOND_DIGIT;
                NEXT_CHAR(pEnd);
                seconds *= 10;
                seconds += digit;
#if TIME_24_SUPPORT | JUST_COMPILE
                {
                	if (bEnableTime24)
                	{
                		if (timeLo == 1440 && seconds > 0  ) goto TIME_GREATER_THAN_240000;
                   	}
                }
#endif
                goto VALIDATE_SECONDS;
#endif // TIME_N_SUPPORT
#if TIME_D_SUPPORT | JUST_COMPILE
            TIME_D:
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    timeLo *= 10;
                    timeLo += digit;
                    }
#if TIME_24_SUPPORT | JUST_COMPILE
            	if (bEnableTime24)
            	{
            	    if ( timeLo > 24 ) goto HOURS25_TOO_LARGE;
               	}
            	else
            	{
                    if ( timeLo > 23 ) goto HOURS24_TOO_LARGE;
            	}
#endif
#if TIME_12_SUPPORT | JUST_COMPILE
# if INTERVAL_SUPPORT
                if (parseDataType ==
#  if PT_INTERVAL
                                     PT_INTERVAL
#  else
                                     PTN_INTERVAL
#  endif
                                                 ) {
                    if ( timeLo > 23 ) goto HOURS24_TOO_LARGE;
                }
                else {
# endif
                if ( timeLo > 12 ) goto HOURS12_TOO_LARGE;
                if ( timeLo == 12 ) timeLo = 0;
# if INTERVAL_SUPPORT
                }
# endif
#endif

                // DELIM
            INTERVAL_TIME_MINUTES_DELIM:
                REQUIRE(ch,timeDelim,EXPECTED_TIME_DELIMITER,pEnd);

            INTERVAL_TIME_MINUTES:
                // DIGIT [DIGIT]
                minutes = ch - '0';
                if ( minutes > 9 ) goto EXPECTED_MINUTE_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    minutes *= 10;
                    minutes += digit;
                    }
                if ( minutes > 59 ) goto MINUTES_TOO_LARGE;
#if TIME_24_SUPPORT | JUST_COMPILE
                {
                	if (bEnableTime24)
                	{
                		if (timeLo == 24 && minutes > 0  ) goto TIME_GREATER_THAN_240000;
                   	}
                }
#endif
                timeLo *= 60;
                timeLo += minutes;

                // [DELIM DIGIT [DIGIT]]
                seconds = 0;
                REQUIRE(ch,timeDelim,NO_SECONDS,pEnd);
                seconds = ch - '0';
                if ( seconds > 9 ) goto EXPECTED_SECOND_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    seconds *= 10;
                    seconds += digit;
                }


#endif
            VALIDATE_SECONDS:
                if ( seconds > 59 ) goto SECONDS_TOO_LARGE;
#if TIME_24_SUPPORT | JUST_COMPILE
                {
                	if (bEnableTime24)
                	{
                		if (timeLo == 1440 && seconds > 0  ) goto TIME_GREATER_THAN_240000;
                   	}
                }
#endif
            NO_SECONDS:
                timeLo *= 60;
                timeLo += seconds;

                uint usecs; usecs = 0;
                if ( ch == DECIMAL_DELIM) goto DECIMAL_POINT_TIME;
            DECIMAL_POINT_RETURN_TIME:
#if TIME_24_SUPPORT | JUST_COMPILE
                {
                	if (bEnableTime24)
                	{
                		//  is invalid timestamp
                		if (timeLo == 86400 && usecs > 0  ) goto TIME_GREATER_THAN_240000;
                		// is 24:00:00 timestamp
                		if ((flags & FPF_TIMESTAMP) && timeLo == 86400 && usecs ==0){
                			// decode 24:00:00 timestamp
                			timeLo = 86399;
                			usecs = 999999;

                		}
                   	}
                }
#endif

#if TIME_12_SUPPORT | JUST_COMPILE
# if INTERVAL_SUPPORT
                if (parseDataType !=
#  if PT_INTERVAL
                                     PT_INTERVAL
#  else
                                     PTN_INTERVAL
#  endif
                                                 )
# endif
                    {
					if ( ch == meridianDelim) goto EMBEDDED_SPACE_TIME;
                EMBEDDED_SPACE_RETURN_TIME:

                    ch |= 'a' - 'A';
                    if ( ch != 'a' ) {
                        if ( ch != 'p' ) goto BAD_AM_PM;
                        timeLo += (12*60*60);
                        }
                    NEXT_CHAR(pEnd);
                    ch |= 'a' - 'A';
                    if ( ch != 'm' ) goto BAD_AM_PM;
                    NEXT_CHAR(pEnd);
                    }
#endif
                register uint timeHi REG(edx);
                if ( flags & FPF_TIMESTAMP ) {
                    uint saveLo = timeLo;
                    timeLo = ((int*)pField)[0];
                    timeHi = 24*60*60;
                    uint saveHi;
                    asm(   "imull	%0\n"           // edx:eax = date * 84600
                       "	addl	%3,%1\n"        //     eax += saveLo (secs)
                       "	adcl	$0,%0\n"        // edx:    += CF
                       "	movl	%0,%2\n"        // saveHi  = edx
                       "	movl	$1000000,%0\n"  // edx     = 1000000
                       "	imull	%0,%2\n"        // saveHi  *= 1000000
                       "	mull	%0\n"           // edx:eax = eax * 1000000
                       "	addl	%4,%1\n"        //     eax += uSecs
                       "	adcl	%2,%0"          // edx:    += CF + saveHi
                       : "+d" (timeHi), "+a" (timeLo), "=&r" (saveHi)
                       :  "r" (saveLo),  "r" (usecs)
                       : "cc"
                       );
                    }
                else {
                    timeHi = 1000000;
                    asm(   "mull	%0\n"           // edx:eax = timeLo * 1000000
                       "	addl	%2,%1\n"        //     eax += uSecs
                       "	adcl	$0,%0"          // edx:    += CF
                       : "+d" (timeHi), "+a" (timeLo)
                       :  "r" (usecs)
                       : "cc"
                       );
                    }
                ENCACHE_REG(pField);

#if INTERVAL_SUPPORT
                if (parseDataType ==
# if PT_INTERVAL
                                     PT_INTERVAL
# else
                                     PTN_INTERVAL
# endif
                                                 ) {
                    bool ovf;
# if TIME_D_SUPPORT
                    // Combine separately collected hours (stored as
                    // micro-seconds) with MM:SS.uuuuuu
                    asm(   "addl	%[hoursLo],%[timeLo]\n"
                       "	adcl	%[hoursHi],%[timeHi]\n"
                       "	setob   %[ovf]"
                       : [timeHi]   "+r" (timeHi)
                       , [timeLo]   "+r" (timeLo)
                       , [ovf]    "+qQm" (ovf)
                       : [hoursHi]   "g" (intervalHours.i32[1])
                       , [hoursLo]   "g" (intervalHours.i32[0])
                       : "cc"
                       );
# endif
                    // Negate the works if needed
                    CMOVE_NEG2(flags, timeHi, timeLo);
                    // Finally add-in (possibly already negated) days
                    asm(   "addl	%[daysLo],%[timeLo]\n"
                       "	adcl	%[daysHi],%[timeHi]\n"
# if TIME_D_SUPPORT
                       "	jno	1f\n"
# endif
                       "	setob   %[ovf]\n"
                       "1:"
                       : [timeHi]   "+r" (timeHi)
                       , [timeLo]   "+r" (timeLo)
# if TIME_D_SUPPORT
                       , [ovf]    "+qQm" (ovf)
# else
                       , [ovf]    "=qQm" (ovf)
# endif
                       : [daysHi]    "g" (((int*)REG_pField)[1])
                       , [daysLo]    "g" (((int*)REG_pField)[0])
                       : "cc"
                       );
                    if (ovf) goto INTERVAL_TIME_OVERFLOW;
                }
#endif

                ((int*)REG_pField)[0] = timeLo;
                ((int*)REG_pField)[1] = timeHi;

#if TIME_TZ_SUPPORT
                if ( parseDataType != PT_TIME_TZ ) goto NEXT_FIELD;
#endif
#if TIME_TZ_SUPPORT | JUST_COMPILE
                if ( ch == '-' ) goto TZ_MINUS;
                if ( ch == '+' ) goto TZ_PLUS;
                goto EXPECTED_TZ_SIGN;

                // Time zone bias is pre-negated
            TZ_PLUS:
                flags |= FPF_NEGATE;
            TZ_MINUS:
                NEXT_CHAR(pEnd);

                uint tzHours; tzHours = ch - '0';
                if ( tzHours > 9 ) goto EXPECTED_TZ_HOUR_DIGIT;
                NEXT_CHAR(pEnd);
                digit = ch - '0';
                if (digit <= 9) {
                    NEXT_CHAR(pEnd);
                    tzHours *= 10;
                    tzHours += digit;
                    }

                register int tzMinutes REG(eax); tzMinutes = 0;
                if ( ch == ':' ) {
                    NEXT_CHAR(pEnd);
                    tzMinutes = ch - '0';
                    if ( ((uint)tzMinutes) > 9 ) goto EXPECTED_TZ_MINUTE_DIGIT;
                    NEXT_CHAR(pEnd);
                    digit = ch - '0';
                    if (digit <= 9) {
                        NEXT_CHAR(pEnd);
                        tzMinutes *= 10;
                        tzMinutes += digit;
                        }
                    if ( tzMinutes > 59 ) goto TZ_MINUTES_TOO_LARGE;
                    }
                tzMinutes += tzHours * 60;
                CMOVE_NEG(flags,tzMinutes);

                // These relations appear backwards because tzMinutes is
                // already pre-negated
                if ( tzMinutes < -(13*60+00) ) goto TZ_TOO_LARGE;
                if ( tzMinutes > +(12*60+59) ) goto TZ_TOO_SMALL;

                // TimeZone store as an offset expressed in seconds
                ((int*)REG_pField)[2] = tzMinutes*60;
#endif
                goto NEXT_FIELD;

            SPACES_TIME:
				if ( pFldPrsCtl->flags & FPF_TIMESTAMP ){
					SKIP_SPACES_ELSE_TIMESTAMP(EXPECTED_TIMESTAMP_TIME);
				}
                SKIP_SPACES_ELSE(EMPTY_TIME);
				RETURN_TO_SPACES_TIME:
                timeLo = ch - '0';
                if ( timeLo <= 9 ) goto SPACES_RETURN_TIME;
                goto EMPTY_TIME;

#if TIME_12_SUPPORT | JUST_COMPILE
            EMBEDDED_SPACE_TIME:
				if ( ch == ' ' ) {
					do {
						NEXT_CHAR(pEnd);
					}
					while ( ch == ' ' );
					goto EMBEDDED_SPACE_RETURN_TIME;
				}
                NEXT_CHAR(pEnd);
				goto EMBEDDED_SPACE_RETURN_TIME;
#endif
            DECIMAL_POINT_TIME:
                NEXT_CHAR(pEnd);
                {
                uint placesRemaining = 6;
                do {
                    digit = ch - '0';
                    if ( digit > 9 ) goto FINISH_SCALING_TIME;
                    usecs *= 10;
                    usecs += digit;
                    NEXT_CHAR(pEnd);
                    }
                while ( --placesRemaining );
                // At this point ch may or may not be a digit; the following line
                // will change (increment) usecs ONLY if ch is in range '5'..'9'.
                usecs += (((unsigned)(ch - '5')) < 5);
            SWALLOWED_EXTRA_TIME_DIGIT:
                digit = ch - '0';
                if ( digit > 9 ) goto DECIMAL_POINT_RETURN_TIME;
#if !GC_TIME_ROUND_NANOS
                if ( digit != 0 )
                    goto MICROSECONDS_TOO_MANY_DIGITS;
#endif
                NEXT_CHAR(pEnd);
                goto SWALLOWED_EXTRA_TIME_DIGIT;

            FINISH_SCALING_TIME:
                usecs *= powerOfTen[ placesRemaining ];
                goto DECIMAL_POINT_RETURN_TIME;
                }

#if INTERVAL_SUPPORT
            INTERVAL_TIME_HAVE_DAYS:
# if TIME_N_SUPPORT
                if ( ch == '-' ) {
                    flags |= FPF_NEGATE;
                    NEXT_CHAR(pEnd);
                    timeLo = ch - '0';
                    if ( timeLo <= 9 ) goto SPACES_RETURN_TIME;
                    goto EXPECTED_DIGIT;
                }
                IF_STOPPER_GOTO(valueDelim,pEnd,NEXT_FIELD);
                goto INTERVAL_TIME_HOURS_NO_DELIM;
# else
                val = ch - '0';
                if (val > 9) {
                    IF_STOPPER_GOTO(valueDelim,pEnd,NEXT_FIELD);
                    if ( ch != '-' ) goto INVALID_CHARACTER;
                    flags |= FPF_NEGATE;
                    NEXT_CHAR(pEnd);
                    val = ch - '0';
                    if (val > 9) goto EXPECTED_DIGIT;
                }
                NEXT_CHAR(pEnd);
                COLLECT_UNSIGNED_INT(val, INTERVAL_OVERFLOW); // leaves ch biased by -'0'
                ch += '0';
                SKIP_SPACES;
# endif

            INTERVAL_TIME_HAVE_HOURS:
# if TIME_N_SUPPORT
                pText = pTextHours;
                ch = pText[-1];
                timeHi = 0;
                timeLo = 0;
                goto INTERVAL_TIME_HOURS_NO_DELIM;
# else
                if (val > (unsigned)(((1ULL<<63)-1)/(1000000ULL*60*60))) goto INTERVAL_HOURS_RANGE;
                intervalHours.i64 = val * (1000000ULL*60*60);
                timeHi = 0;
                timeLo = 0;
#  if GC_timeDelim == ' '
                goto INTERVAL_TIME_MINUTES;
# else
                goto INTERVAL_TIME_MINUTES_DELIM;
#  endif
# endif
#endif // INTERVAL_SUPPORT
                }
#endif // TIME_SUPPORT
// =============================
// !FIX-jsy: these parsers are "branch-predictor unfriendly" if space is present
#if PT_BOOL_1_0 | JUST_COMPILE
            case PT_BOOL_1_0:
                {
                BEGIN_CASE(25);

            RESTART_BOOL_1_0:
                uint val = ch - '0';
                if ( val > 1 ) goto SPACES_BOOL_1_0;
                *((char*)REG_pField) = val;
                NEXT_CHAR(pEnd);
                goto NEXT_FIELD;

            SPACES_BOOL_1_0:
                SKIP_SPACES_ELSE(EMPTY_BOOL);
                goto RESTART_BOOL_1_0;
                }
#endif

#if PTN_BOOL_T_F | JUST_COMPILE
            case PTN_BOOL_T_F:
                NULL_TOKEN_CHECK;
#endif
#if PT_BOOL_T_F | JUST_COMPILE
            case PT_BOOL_T_F:
#endif
#if PT_BOOL_T_F | PTN_BOOL_T_F | JUST_COMPILE
                {
                BEGIN_CASE(26);

            RESTART_BOOL_T_F:
                uint8 val = ch | ('a' - 'A');
                val -= 'f';
                if ( val != 0 ) {
                    val -= ('t' -'f');
                    if ( val != 0 ) goto SPACES_BOOL_T_F;
                    ++val;
                    }
                *((char*)REG_pField) = val;
                NEXT_CHAR(pEnd);
                goto NEXT_FIELD;

            SPACES_BOOL_T_F:
                SKIP_SPACES_ELSE(EMPTY_BOOL);
                goto RESTART_BOOL_T_F;
                }
#endif // PT_BOOL_T_F | PTN_BOOL_T_F | JUST_COMPILE

#if PTN_BOOL_TRUE_FALSE | JUST_COMPILE
            case PTN_BOOL_TRUE_FALSE:
                NULL_TOKEN_CHECK;
#endif
#if PT_BOOL_TRUE_FALSE | JUST_COMPILE
            case PT_BOOL_TRUE_FALSE:
#endif
#if PT_BOOL_TRUE_FALSE | PTN_BOOL_TRUE_FALSE | JUST_COMPILE
                {
                BEGIN_CASE(27);

            RESTART_BOOL_TRUE_FALSE:
                uint ch4; ch4 = *((uint*)(((char*)pText)-1+0));
                ch4 |= 0x20202020;
                uint val = 0;
                if ( ch4 == ('f'<<0|'a'<<8|'l'<<16|'s'<<24) ) {
                    ch = pText[3];
                    ch |= 0x20;
                    if ( ch != 'e' ) goto EMPTY_BOOL;
                    pText += 1;
                    }
                else if ( ch4 != ('t'<<0|'r'<<8|'u'<<16|'e'<<24) ) {
                    if ( ch != ' ' ) goto EMPTY_BOOL;
                    NEXT_CHAR(pEnd);
                    goto RESTART_BOOL_TRUE_FALSE;
                    }
                else {
                    val += 1;
                    }
                *((char*)REG_pField) = val;

                pText += 4-1;
                NEXT_CHAR(pEnd);
                goto NEXT_FIELD;
                }
#endif // PT_BOOL_TRUE_FALSE | PTN_BOOL_TRUE_FALSE | JUST_COMPILE

#if PTN_BOOL_Y_N | JUST_COMPILE
            case PTN_BOOL_Y_N:
                NULL_TOKEN_CHECK;
#endif
#if PT_BOOL_Y_N | JUST_COMPILE
            case PT_BOOL_Y_N:
#endif
#if PT_BOOL_Y_N | PTN_BOOL_Y_N | JUST_COMPILE
                {
                BEGIN_CASE(28);

            RESTART_BOOL_Y_N:
                uint8 val = ch | ('a' - 'A');
                val -= 'n';
                if ( val != 0 ) {
                    val -= ('y' -'n');
                    if ( val != 0 ) goto SPACES_BOOL_Y_N;
                    ++val;
                    }
                *((char*)REG_pField) = val;
                NEXT_CHAR(pEnd);
                goto NEXT_FIELD;

            SPACES_BOOL_Y_N:
                SKIP_SPACES_ELSE(EMPTY_BOOL);
                goto RESTART_BOOL_Y_N;
                }
#endif // PT_BOOL_Y_N | PTN_BOOL_Y_N | JUST_COMPILE

#if PTN_BOOL_YES_NO | JUST_COMPILE
            case PTN_BOOL_YES_NO:
                NULL_TOKEN_CHECK;
#endif
#if PT_BOOL_YES_NO | JUST_COMPILE
            case PT_BOOL_YES_NO:
#endif
#if PT_BOOL_YES_NO | PTN_BOOL_YES_NO | JUST_COMPILE
                {
                BEGIN_CASE(29);

            RESTART_BOOL_YES_NO:
                uint16 ch2; ch2 = *((uint16*)(((char*)pText)-1+0));
                ch2 |= 0x2020;
                uint val = 0;
                if ( ch2 != ('n'<<0|'o'<<8) ) {
                    if ( ch2 != ('y'<<0|'e'<<8) ) {
                        if ( ch != ' ' ) goto EMPTY_BOOL;
                        NEXT_CHAR(pEnd);
                        goto RESTART_BOOL_YES_NO;
                        }
                    ch = pText[1];
                    ch |= 0x20;
                    if ( ch != 's' ) goto EMPTY_BOOL;
                    val += 1;
                    pText += 1;
                    }
                *((char*)REG_pField) = val;

                pText += 2-1;
                NEXT_CHAR(pEnd);
                goto NEXT_FIELD;
                }
#endif // PT_BOOL_YES_NO | PTN_BOOL_YES_NO | JUST_COMPILE
// =============================
#if PT_FLOAT | JUST_COMPILE
            case PT_FLOAT:
#endif
#if PT_DOUBLE | JUST_COMPILE
            case PT_DOUBLE:
#endif
#if PT_FLOAT | PT_DOUBLE | JUST_COMPILE
                {
                BEGIN_CASE(30);

                enum { N_BCD_DIGITS = 18 };
                        
#if ( defined(PT_FLOAT) & defined(PT_DOUBLE) ) | JUST_COMPILE
                parseDataType -= PT_FLOAT;
                int resultIsDouble = parseDataType;
#else
# if PT_FLOAT
                int resultIsDouble = FALSE;
# else
                int resultIsDouble = TRUE;
# endif
#endif
                x87_packed_bcd bcd_tmp;
                uint8* bcd = &bcd_tmp.bytes[9];
                ((long*)(bcd-9))[0] = 0;
                ((long*)(bcd-9))[1] = 0;
                ((long*)(bcd-9))[2] = 0;

                // x86 packed BCD representation contains 18 digits
                int remainingPrecision = N_BCD_DIGITS;

                bool negInfinity = FALSE;
                bool hasSpaces = FALSE;
                double inf_val = INFINITY; // defined in Macro INFINITY in math.h

            RESTART_FLOAT:
                if ( ch < '0' || ch > '9' )  goto CHECK_SIGNS_FLOAT;
            CHECK_LEADING_0_FLOAT:
                ch = ch - '0';
                if ( ch != 0 ) goto COLLECT_SIGNIFICAND_FLOAT;
                goto LEADING_0_FLOAT;

                uint val;
                do {
                    val += ch;
                    --remainingPrecision;
                    if ( remainingPrecision >= 0 )
                        *--bcd = val;
                DECIMAL_POINT_RETURN_1_FLOAT:
                    NEXT_CHAR(pEnd);
                    if ( ch == DECIMAL_DELIM ) goto DECIMAL_POINT_CHECK_1_FLOAT;
                    ch = ch - '0';
                    if ( ch > 9 ) goto COLLECT_SIGNIFICAND_EXIT_FLOAT;
                COLLECT_SIGNIFICAND_FLOAT:
                    val = ch << 4;
                    --remainingPrecision;
                DECIMAL_POINT_RETURN_2_FLOAT:
                    NEXT_CHAR(pEnd);
                    if ( ch == DECIMAL_DELIM) goto DECIMAL_POINT_CHECK_2_FLOAT;
                    ch = ch - '0';
                    }
                while (ch <= 9);
                if ( remainingPrecision >= 0 )
                    *--bcd = val;

            COLLECT_SIGNIFICAND_EXIT_FLOAT:
                ch = ch + '0';
                asm(   "testb	%3,%2\n"
                   "	cmovnel	%1,%0"
                   : "+r" (remainingPrecision)
                   :  "g" (decPntPos), "qQm" (flags), "i" (FPF_DECIMAL_POINT)
                   : "cc"
                   );
                
            CHECK_FOR_EXPONENT_FLOAT:

                int exp; exp = 0;

                ch |= 'a'-'A';
                if ( ch == 'e' ) {
                    NEXT_CHAR(pEnd);
                    if ( ch == '+' ) goto EXP_PLUS_FLOAT;
                    if ( ch != '-' ) goto EXP_NO_SIGN_FLOAT;
                    flags |= FPF_NEGATE;
                EXP_PLUS_FLOAT:
                    NEXT_CHAR(pEnd);
                EXP_NO_SIGN_FLOAT:

                    ch = ch - '0';
                    if ( ch > 9 ) goto EXPECTED_DIGIT;

                    uint chkOvf = 0;
                    do {
                        exp *= 10;
                        exp += ch;
                        NEXT_CHAR(pEnd);
                        ch = ch - '0';
                        chkOvf |= exp;
                        }
                    while (ch <= 9);
                    if ( chkOvf > 0xFFFF ) goto EXPONENT_OUT_OF_RANGE;
                    CMOVE_NEG(flags, exp);
                    }

                exp -= remainingPrecision;

                {

                packedLongDouble* pTbl    = &xp_binaryPowersOf10[0];
                packedLongDouble* pNegTbl = &xp_binaryPowersOf10[9];

                asm volatile
                    (  "finit\n"                        // empty stack, clear all exceptions
                    "   fldz\n"                         // push +0.0 (a non-negative zero)
                    "   fbld    %[bcd_tmp]\n"           // load & convert bcd significand
                    "   fcomi   %%st(1)\n"              // look for zero, update FLAGS
                    "   fcmove  %%st(1),%%st(0)\n"      //  e: canonicalize to +0.0
                    "   or  %[exp],%[exp]\n"            // check for negative or zero exp
                    "   jg  1f\n"                       //  g: exp and multipliers are ready
                    "   jz  2f\n"                       //  z: no scaling needed
                    "   negl    %[exp]\n"               // negative exponent, get absolute
                    "   movl    %[pNegTbl],%[pTbl]\n"   // switch multipliers
                    "1: fld %%st(0)\n"                  // dupe ST0
                    "   fldt    (%[pTbl])\n"            // load multiplier
                    "   addl    %[elemBytes],%[pTbl]\n" // bump pointer
                    "   shrl    %[exp]\n"               // inspect exponent bit
                    "   fmulp\n"                        // multiply unconditionally
                    "   fcmovnb %%st(1),%%st(0)\n"      // restore if bit was not set
                    "   fstp    %%st(1)\n"              // squeeze out st(1)
                    "   jnz 1b\n"                       // repeat for all exp bits
                    "2:\n"
#if ( defined(PT_FLOAT) & defined(PT_DOUBLE) )
                    "	cmpl    $0,%[resultIsDouble]\n" // float or double?  (after loop %[exp] is 0)
                    "   jz  3f\n"
#endif
#if defined(PT_DOUBLE)
                    "   fstpl   (%[REG_pField])\n"      // round to DP and emit
                    "   fldl    (%[REG_pField])\n"      // reload to test for underflow to zero
#endif
#if ( defined(PT_FLOAT) & defined(PT_DOUBLE) )
                    "   jmp 4f\n"
                    "3:\n"
#endif
#if defined(PT_FLOAT)
                    "	fstps   (%[REG_pField])\n"      // round to SP and emit
                    "   flds    (%[REG_pField])\n"      // reload to test for underflow to zero
#endif
#if ( defined(PT_FLOAT) & defined(PT_DOUBLE) )
                    "4:\n"
#endif
                    "	ftst\n"                         // FSW.C3 = 1 IFF ST(0) is zero
                    "   fnstsw  %%ax"                   // capture final status bits
                    : [exp]           "+a" (exp)          // on return contains FPSW
                    : [bcd_tmp]        "m" (bcd_tmp)
                    , [pTbl]           "r" (pTbl)
                    , [pNegTbl]        "g" (pNegTbl)
                    , [elemBytes]      "i" (sizeof(*pTbl))
                    , [REG_pField]     "r" (REG_pField)
#if ( defined(PT_FLOAT) & defined(PT_DOUBLE) )
                    , [resultIsDouble] "g" (resultIsDouble)
#endif
                    : "cc"

                    );
                }
                if ( (exp & 0x0018) == 0 ) goto NEXT_FIELD;
                if (  exp & 0x0008 ) goto FP_FORMAT_OVERFLOW;
                // Underflow has occurred.  In the IEEE scheme this means
                // that we are now using denormalized values (that is values
                // with less than full precision).  We allow such conversions
                // through until the underflow is so drastic that the result
                // is zero.  The ftst instruction above set FSW.C3 (= 0x4000)
                // iff the stored value was zero.
                if ( (exp & 0x4000) == 0 ) goto NEXT_FIELD;
                goto FP_FORMAT_UNDERFLOW;

            DECIMAL_POINT_CHECK_1_FLOAT:
                if ( flags & FPF_DECIMAL_POINT ) goto MULTIPLE_DECIMAL_POINTS;
                flags |= FPF_DECIMAL_POINT;
                decPntPos = remainingPrecision;
                goto DECIMAL_POINT_RETURN_1_FLOAT;

            DECIMAL_POINT_CHECK_2_FLOAT:
                if ( flags & FPF_DECIMAL_POINT ) goto MULTIPLE_DECIMAL_POINTS;
                flags |= FPF_DECIMAL_POINT;
                decPntPos = remainingPrecision;
                goto DECIMAL_POINT_RETURN_2_FLOAT;

            CHECK_SIGNS_FLOAT:
                if ( ch == '-' ) goto MINUS_SIGN_FLOAT;
                if ( ch == '+' ) goto PLUS_SIGN_FLOAT;
                if ( ch == 'I' || ch == 'i' ) goto INFINITY_FLOAT;
                /* Fix for SWS-66788.In nzload, the -nullValue is sometimes being interpreted as
                   bad data (and thus failing) ... rather than being interpreted as a null value.. */
                if ( pText[0] < '0' || pText[0] > '9' ) {
                    SKIP_SPACES_ELSE(EMPTY_FP);
                    goto RESTART_FLOAT;
                }
                if ( ch == DECIMAL_DELIM) goto FLAG_LEADING_DECIMAL_POINT_FLOAT;
                SKIP_SPACES_ELSE(EMPTY_FP);
                goto RESTART_FLOAT;
            EMPTY_FP:
                if ( resultIsDouble ) goto EMPTY_DOUBLE;
                goto EMPTY_FLOAT;

            MINUS_SIGN_FLOAT:
                // flip sign byte
                *bcd = 0x80;
                negInfinity = TRUE;
            PLUS_SIGN_FLOAT:
                NEXT_CHAR(pEnd);
                if ( ch == 'I' || ch == 'i' ) goto INFINITY_FLOAT;
                if ( ch >= '0' && ch <= '9' ) goto CHECK_LEADING_0_FLOAT;
                if ( ch != DECIMAL_DELIM) goto EXPECTED_DIGIT_OR_DECIMAL_POINT;
                goto FLAG_LEADING_DECIMAL_POINT_FLOAT;
            INFINITY_FLOAT: 
               NEXT_CHAR(pEnd);
               CHECK_INF_CH('N', 'n', INVALID_INFINITY);
               CHECK_INF_CH('F', 'f', INVALID_INFINITY);
               if ( ch == ' ') {
                SKIP_SPACES;
                hasSpaces = true;
               }
               // check next ch either field Delim or default record delim (unix and windows)
               if ( ch == fieldDelim || ch == '\n' || (ch == '\r' && *pText == '\n') || (ch == '\n' && *pText == '\r')) {
                   goto COLLECT_INFINITY;
               }
               else if ( hasSpaces ) 
                   goto INVALID_INFINITY;
               CHECK_INF_CH('I', 'i', INVALID_INFINITY);
               CHECK_INF_CH('N', 'n', INVALID_INFINITY);
               CHECK_INF_CH('I', 'i', INVALID_INFINITY);
               CHECK_INF_CH('T', 't', INVALID_INFINITY);
               CHECK_INF_CH('Y', 'y', INVALID_INFINITY);
               SKIP_SPACES;
               // check next ch either field Delim or default record delim (unix and windows)
               if ( ch == fieldDelim || ch == '\n' || (ch == '\r' && *pText == '\n') || (ch == '\n' && *pText == '\r')) {
            COLLECT_INFINITY:
                   if ( !negInfinity )
                      *((double*)REG_pField) = inf_val;
                   else 
                      *((double*)REG_pField) = -inf_val;
                   goto NEXT_FIELD;
               }
               else goto INVALID_INFINITY;
            FLAG_LEADING_DECIMAL_POINT_FLOAT:
                flags |= FPF_DECIMAL_POINT | FPF_EXPECT_DIGIT;
                goto LEADING_DECIMAL_POINT_FLOAT;

            LEADING_0_FLOAT:
                flags &= -1-FPF_EXPECT_DIGIT;
            CONSUME_DECIMAL_POINT_FLOAT:
                NEXT_CHAR(pEnd);
                if ( ch > '0' && ch <= '9' ) goto COLLECT_SIGNIFICAND_FLOAT;
                if ( ch == DECIMAL_DELIM ) {
                    if ( flags & FPF_DECIMAL_POINT ) goto MULTIPLE_DECIMAL_POINTS;
                    flags |= FPF_DECIMAL_POINT;
            LEADING_DECIMAL_POINT_FLOAT:
                    decPntPos = N_BCD_DIGITS;
                    goto CONSUME_DECIMAL_POINT_FLOAT;
                    }
                ++decPntPos;
                if ( ch == '0' ) goto LEADING_0_FLOAT;
                if ( flags & FPF_EXPECT_DIGIT ) goto EXPECTED_DIGIT;
                goto CHECK_FOR_EXPONENT_FLOAT;
                }
#endif // PT_FLOAT | PT_DOUBLE | JUST_COMPILE
// =============================
            case PT_ZERO:
            default:
                char number[16];
                sprintf(number,"%d)",parseDataType);
                throwError(8 /* = NZ_ERROR_ILLVAL */,"bad case value (parseDataType=",number);
                } // switch( parseDataType )
            } // while (TRUE) -- loop over all fields


// End of record (trailing delimiter, spaces, end of record char, etc)

    COMPLETED_LAST_FIELD:
        // check immediately for EOR
        if ( ch == '\n' )
            goto END_OF_RECORD_IS_NL;
#if CR_IS_EOR
        if ( ch == '\r' )
            goto END_OF_RECORD_IS_CR;
#endif
	COMPARE_TO_REC_DELIM (recDelimLen, NO_EQUAL_LAST_FIELD);
        goto END_OF_RECORD_IS_NL;

    NO_EQUAL_LAST_FIELD:
        // trailing delimiter followed by EOR
        if ( ch == fieldDelim ) {
            NEXT_CHAR(pEnd);
            pFldPrsCtl++;
            if ( ch == '\n' )
                goto END_OF_RECORD_IS_NL;
#if CR_IS_EOR
            if ( ch == '\r' )
                goto END_OF_RECORD_IS_CR;
#endif
	    COMPARE_TO_REC_DELIM (recDelimLen, NO_EQUAL_LAST_FIELD_TRAILING);
            goto END_OF_RECORD_IS_NL;

     NO_EQUAL_LAST_FIELD_TRAILING:
            goto LAST_FIELD_TRAILING_SPACES;
            }

        // only remaining possibility is white space
        SKIP_SPACES_ELSE(EXPECTED_END_OF_FIELD);

        if ( ch != fieldDelim ) goto END_OF_RECORD;
        NEXT_CHAR(pEnd);
        pFldPrsCtl++;
    LAST_FIELD_TRAILING_SPACES:
        SKIP_SPACES_ELSE(END_OF_RECORD);

    END_OF_RECORD:
#if CR_IS_EOR
        if ( ch == '\n' )
            END_OF_RECORD_IS_NL: eor2 = '\r';
        else if ( ch == '\r' )
            END_OF_RECORD_IS_CR: eor2 = '\n';
        else
	    COMPARE_TO_REC_DELIM (recDelimLen, NO_EQUAL_REC_DELIM_END_OF_REC2);
            goto END_OF_RECORD_IS_NL2;
        NO_EQUAL_REC_DELIM_END_OF_REC2:
            goto EXPECTED_END_OF_RECORD;
#else
	if ( ch == '\n')
            goto END_OF_RECORD_IS_NL;

        COMPARE_TO_REC_DELIM (recDelimLen, NO_EQUAL_END_OF_REC);
        goto END_OF_RECORD_IS_NL;

    NO_EQUAL_END_OF_REC:
            goto EXPECTED_END_OF_RECORD;
    END_OF_RECORD_IS_NL:
#endif
END_OF_RECORD_IS_NL2:

        // Found begining of next row so this row is complete
        bytesConsumed += ((size_t)(pText - pTextStart));
        // reduce size by 1 as we do consider EOR again in next row
        bytesConsumed--;
	plan->m_unTermFlg = 1;
        *pRemainingText = pText - 1;

        // Handle any requested skip count
        if ( rowsToBeSkipped ) {
            flags |= FPF_SUPRESS_LOAD;
            }


// =============================
// End of record processing irrespective of whether good or bad

#if IGNORE_ZERO
#undef  NEXT_CHAR_NO_EOB
#define NEXT_CHAR_NO_EOB \
do {\
    ch = *pText;\
    pText++;\
    }\
while( ch == '\0' )
#else
#undef  NEXT_CHAR_NO_EOB
#define NEXT_CHAR_NO_EOB \
do {\
    ch = *pText;\
    pText++;\
    }\
while( FALSE )
#endif

        // Complete and distribute any non-supressed records
        if ( (flags & FPF_SUPRESS_LOAD) )
            goto ROW_SUPRESSED;
            {

            uint recSize; recSize = recordSize;
#if GC_HAS_SIZE_WORD | JUST_COMPILE
                {
                recordSize = recSize = ((recSize+3) & (-4));
                *((unsigned short*)((char*)pRecordBuffer)) = recSize;
                }
#endif

#if GC_ENABLE_ROW_NUM | JUST_COMPILE
                *pRowNum = RowIdGen::getRowNum();
#endif

            if ( nVarFields )
                {
                // materialize varyings into the binary record image for hashing
                ParsedVarString* pvsCur = pPVS;
                ParsedVarString* pvsEnd = pvsCur + nVarFields;
                char* pVarying = (char*)((((size_t)pRecordBuffer)+fixedSize+1) & (-2));
                do {
                    uint length = pvsCur->length;
                    pText = pvsCur->body;
                    *(vlen_t*)pVarying = length + sizeof(vlen_t);
                    pVarying += sizeof(vlen_t);
                    if ( length ) {
                        if ( pvsCur->pureCopy == COALESCED_BLOB ) {
                            *(uint32** )pVarying = (uint32* )pText;
                            pVarying += sizeof(uint32*);
                        }
                        else {
                            pText -= 1;
                            if ( pvsCur->pureCopy ) {
                                length = ((length + 1) & (-2));
                                if ( length & 2 ) {
                                    *(uint16*)pVarying = *(uint16*)pText;
                                    pText += sizeof(uint16);
                                    pVarying += sizeof(uint16);
                                    length -= 2;
                                    if ( length == 0 ) goto REC_BUF_PURE_COPY_DONE;
                                    }
                                do {
                                    *(uint32*)pVarying = *(uint32*)pText;
                                    pText += sizeof(uint32);
                                    pVarying += sizeof(uint32);
                                    length -= 4;
                                    }
                                while ( length );
                                }
                            else {
                                do {
                                    NEXT_CHAR_NO_EOB;
#if BSLASH_ESCAPE || QUOTED_VALUES
                                    if (
#  if BSLASH_ESCAPE
                                        ch == escapeChar
#  endif
#  if BSLASH_ESCAPE && QUOTED_VALUES
                                        ||
#  endif
#  if QUOTED_VALUES
                                        ch == pvsCur->quoteChar
#  endif
                                       )
                                        NEXT_CHAR_NO_EOB;
#endif
                                    *pVarying++ = ch;
                                    }
                                while ( --length );
                                }
                            }
                        pVarying = (char*)((((size_t)pVarying)+1) & (-2));
                        }
                REC_BUF_PURE_COPY_DONE:;
                    }
                while ( ++pvsCur != pvsEnd );
                }
            }

// provide a block for the code generated on behalf of subsequent nodes
{

//******************************************************************************
