//******************************************************************************

#undef INTERVAL_SUPPORT
#if PT_INTERVAL | PTN_INTERVAL
#define INTERVAL_SUPPORT 1

// Magic non-exported Postgres constant from timestamp.c
#define MAX_INTERVAL_MONTHS (3000000)
#endif

#undef  STRING_SUPPORT
#if PT_CHAR1 | PTN_CHAR1 | PT_CHAR | PTN_CHAR | PT_VAR_CHAR | PTN_VAR_CHAR | PT_VAR_FIXED_CHAR | PTN_VAR_FIXED_CHAR | PT_NVAR_CHAR | PTN_NVAR_CHAR | PT_NVAR_FIXED_CHAR | PTN_NVAR_FIXED_CHAR | JUST_COMPILE
#define STRING_SUPPORT 1
#endif

#undef  BLOB_SUPPORT_AGAIN
#undef  BLOB_SUPPORT
#if BLOB_SUPPORT_AGAIN
#if PT_BLOB | PTN_BLOB | PT_CLOB | PTN_CLOB | PT_NUCL | PTN_NUCL | PT_PROT | PTN_PROT | PT_NCLOB | PTN_NCLOB | JUST_COMPILE
#define BLOB_SUPPORT 1
#endif
#endif //BLOB_SUPPORT_AGAIN

#undef  DATE_DELIM_AND_TRAILING_YEAR_SUPPORT
#if PT_DATE_D_DMMMY | PT_DATE_D_MDY | PT_DATE_D_DMY | JUST_COMPILE
#define DATE_DELIM_AND_TRAILING_YEAR_SUPPORT 1
#endif

#undef  TRAILING_YEAR_SUPPORT
#if PT_DATE_MMM_D_Y | PTN_DATE_MMM_D_Y | PT_DATE_N_DMMMY | PT_DATE_N_DMY | PT_DATE_N_MDY | DATE_DELIM_AND_TRAILING_YEAR_SUPPORT | JUST_COMPILE
#define TRAILING_YEAR_SUPPORT 1
#endif

#undef  DATE_COMMON_TAIL_SUPPORT
#if PT_DATE_N_YMD | PT_DATE_D_YMD | TRAILING_YEAR_SUPPORT | JUST_COMPILE
#define DATE_COMMON_TAIL_SUPPORT 1
#endif

#undef  TIME_SUPPORT
#if PT_TIME_N_24 | PT_TIME_D_24 | PT_TIME_N_12 | PT_TIME_D_12 | PT_TIME_N_24_TZ | PT_TIME_D_24_TZ | PT_TIME_N_12_TZ | PT_TIME_D_12_TZ | PT_TIME_N_24_TRUNC | PT_TIME_D_24_TRUNC | PT_TIME_N_12_TRUNC | PT_TIME_D_12_TRUNC | INTERVAL_SUPPORT | JUST_COMPILE
#define TIME_SUPPORT 1
#endif

#undef  TIME_N_SUPPORT
#if TIME_SUPPORT && !GC_timeDelim
#define TIME_N_SUPPORT 1
#endif

#undef  TIME_D_SUPPORT
#if TIME_SUPPORT && GC_timeDelim
#define TIME_D_SUPPORT 1
#endif

#undef  TIME_12_SUPPORT
#if PT_TIME_N_12 | PT_TIME_D_12 | PT_TIME_N_12_TZ | PT_TIME_D_12_TZ | PT_TIME_N_12_TRUNC | PT_TIME_D_12_TRUNC
#define TIME_12_SUPPORT 1
#endif

#undef  TIME_24_SUPPORT
#if PT_TIME_N_24 | PT_TIME_D_24 | PT_TIME_N_24_TZ | PT_TIME_D_24_TZ | PT_TIME_N_24_TRUNC | PT_TIME_D_24_TRUNC | (INTERVAL_SUPPORT && !TIME_12_SUPPORT)
#define TIME_24_SUPPORT 1
#endif

#undef  TIME_TZ_SUPPORT
#if PT_TIME_N_24_TZ | PT_TIME_D_24_TZ | PT_TIME_N_12_TZ | PT_TIME_D_12_TZ
#define TIME_TZ_SUPPORT 1
#endif

#undef  TIME_TRUNC_SUPPORT
#if PT_TIME_N_24_TRUNC | PT_TIME_D_24_TRUNC | PT_TIME_N_12_TRUNC | PT_TIME_D_12_TRUNC
#define TIME_TRUNC_SUPPORT 1
#endif

    // Copy all object's frequently referenced values into locals;
    // goal is to have NO references to implicit "this" within the
    // rest of the method
    Parser* myObj; myObj = this;

    // Many values are invariant over an entire run.  These are
    // past to nzload through the parser object.  In the case of
    // generated code the value is provide directly as a #define.
    // We still introduce a static const declaration to ensure
    // that typing is identical to the nzload scenario.
# undef  INVARIANT
# define INVARIANT(TYPE,NAME) static const TYPE NAME = GC_##NAME

    // Dynamic state that will need to be copied back on exit
    // (see code following label END_OF_BUFFER at bottom of file).
    bool                halted; halted           = myObj->m_halted;
    if ( halted ) return;

#if CR_IS_EOR
    uint                eor2; eor2             = myObj->m_eor2;
#endif
    uint                rowsToBeProcessed; rowsToBeProcessed= myObj->m_rowsToBeProcessed;
    uint                rowsToBeSkipped; rowsToBeSkipped  = myObj->m_rowsToBeSkipped;
    bool                bEnableTime24; bEnableTime24 = myObj->m_enableTime24;
    bool                suppressLineFeed; suppressLineFeed = FALSE;

    INVARIANT( uint16,  fixedSize );
    INVARIANT( uint16,  fixedLongs );
    INVARIANT( uint8,   leaderLongs );
    INVARIANT( uint16,  nVarFields );
    INVARIANT( uint16,  firstBlobInPVS );
    INVARIANT( uint8,   nBlobFields );
    INVARIANT( uint,    fieldDelim );
#if QUOTED_VALUES
    INVARIANT( uint,    quoteChar );
#endif
#if BSLASH_ESCAPE
    INVARIANT( uint,    escapeChar );
#endif
    INVARIANT( uint8,   sbcspcChar );
    INVARIANT( uint,    dateDelim );
	INVARIANT( uint,	dateTimeDelim );
    INVARIANT( uint,    timeDelim );
    INVARIANT( uint64,  recDelim );
    INVARIANT( uint,    recDelimLen );
	INVARIANT( uint,	meridianDelim );
    INVARIANT( bool,    lfInString );
    uint64*             defaults; defaults         = myObj->m_defaults;
    FieldParseControl*  pFPC; pFPC             = myObj->m_FPC;
    INVARIANT( uint,    nullText_0_3 );
    INVARIANT( uint,    nullMask_0_3 );
    INVARIANT( uint,    stopperCtrlChars );
    uint                syntheticDistKey; syntheticDistKey = myObj->m_syntheticDistKey;
    INVARIANT( uint,    adjustZeroWrap );
#if BLOB_SUPPORT
    uint*               blobBuffer       = myObj->m_blobBuffer;
    size_t              blobBufferSize   = myObj->m_blobBufferSize;
#endif

    // Decide what the terminator of a well-formed value should be
#if NO_QUOTES
#   undef  valueDelim
#   define valueDelim fieldDelim
#elif REQUIRE_QUOTES
#   undef  valueDelim
#   define valueDelim quoteChar
#else // ALLOW_QUOTES
    uint valueDelim;
#endif

    // Space to accumulate the record; initially fixed, then append varyings
    uint64*             pRecordBuffer; pRecordBuffer = myObj->m_record;
#if GC_ENABLE_ROW_NUM | JUST_COMPILE
    TRowId*             pRowNum;  pRowNum = myObj->m_pRowNum;
#endif

    // Space to record properties of parsed varyings (including var fixed)
    ParsedVarString*    pPVS; pPVS        = myObj->m_PVS;

    static const size_t offset_from_rec_to_def = ((char*)defaults)-((char*)pRecordBuffer);
    static const size_t offset_from_rec_to_PVS = ((char*)pPVS    )-((char*)pRecordBuffer);

#if BLOB_SUPPORT
#undef  BLOB_BUFFER_END_SAFETY
#define BLOB_BUFFER_END_SAFETY 32
    uint8* blobBufferEnd = (uint8* )blobBuffer + blobBufferSize - BLOB_BUFFER_END_SAFETY;
#endif

    uint8 const* pStartOfField;
    uint8 const* pStartOfBadRow;
    uint8 const* pErrorPosition;
    uint8 const* pUTF8ErrorPosition;
    // changed style of initialization in following lines for TT 27529
    const uint8* pUtf8GraphemeStart; pUtf8GraphemeStart = 0;
    const uint8* pUtf8GraphemeEnd; pUtf8GraphemeEnd = 0;
    uint8 CurWeight; CurWeight = NO_WEIGHT;
    uint8 PrecomposedOrMaybe; PrecomposedOrMaybe = 0;
    uint badUnicodeCodePoint; badUnicodeCodePoint = 0;
#if QUOTED_VALUES && IGNORE_ZERO
    uint8 const* pTextSave;
#endif

#if INTERVAL_SUPPORT
# if TIME_N_SUPPORT
    uint8 const* pTextHours;
# else
    union { int64 i64; int32 i32[2]; } intervalHours = { 0 };
# endif
#endif

    uint rowsConsumed; rowsConsumed = 0;
    uint64 bytesConsumed; bytesConsumed = 0;
    uint decPntPos; decPntPos = 0;

    // Even though this argument never gets modified it is referenced
    // in every call to NEXT_CHAR; since we are compiling without
    // support of a frame pointer arguments are moderately distant
    // from the base of the frame; by copy the argument it ends up
    // being addressable using a 1 byte displacement (instead of 4).
    const uint8* pEnd; pEnd = pEndArg;


    int adjustZeroDist;
    uint8 flags;                    // modifiable copy of REG_pFldPrsCtl->flags
    register uint ch REG(ebx);      // current char (byte addressible)
    const uint8* pText;
    const uint8* pTextStart;
    uint val;
    uint vhi;
    register uint vlo REG(eax);
    int idx;

#if BLOB_SUPPORT
    if (!blobBuffer) goto REALLOCATE_BLOB_BUFFER;
#endif

// decimal deliminter
#if DECIMAL_COMMA
#define DECIMAL_DELIM ','
#else
#define DECIMAL_DELIM '.'
#endif

    // Process successive full rows in this buffer
    while (TRUE) {

//******************************************************************************
