//******************************************************************************

// end block containing subsequent nodes' generated code
}

ROW_SUPRESSED:
        // Update number of input rows processed
        rowsConsumed++;

        if ( rowsToBeSkipped )
            --rowsToBeSkipped;
        else if (rowsToBeProcessed) {
            if (--rowsToBeProcessed == 0)
                halted = TRUE;
        }

        if ( !halted )
            continue;

        goto END_OF_BUFFER;


// =============================
#if BLOB_SUPPORT
    REALLOCATE_BLOB_BUFFER:
        {
            uint* newBuffer = (uint*) mem::allocBlock(blobBufferSize + BLOB_BUFFER_EXTEND_INCREMENT,
                                                      mem::AllocContext(mt_ldr_parser));

            uint* pSrc = blobBuffer;
            if ( pSrc ) {
                uint* pDst = (uint* )newBuffer;
                uint llcnt = blobBufferSize >> 2;
                while ( llcnt ) {
                    *pDst++ = *pSrc++;
                    --llcnt;
                    }
                mem::freeBlock(blobBuffer);
                }
            blobBufferSize += BLOB_BUFFER_EXTEND_INCREMENT;
            blobBufferEnd = (uint8* )newBuffer + blobBufferSize - BLOB_BUFFER_END_SAFETY;;
            blobBuffer = newBuffer;
            m_blobBuffer = newBuffer;
            m_blobBufferSize = blobBufferSize;
        }
        // reparse entire record...
        continue;
#endif // BLOB_SUPPORT
// =============================
    MAYBE_FILL_RECORD:
        if ( ch != '\n' && ! CH_IS_CR_EOR ) goto EXPECTED_END_OF_FIELD;
    FILL_RECORD:
#if !GC_FILL_RECORD
        if ( plan->m_unTermFlg2 )
            suppressLineFeed = TRUE;

        goto INCOMPLETE_NO_FILL_RECORD;
#endif
        char* pRecord; pRecord = (char*)pRecordBuffer;
        uint8 fillFlags;
        ENCACHE_REG(pFldPrsCtl);
        do {
            REG_pFldPrsCtl++;
            uint nFixedFieldBytes;
            switch ( REG_pFldPrsCtl->parseDataType ) {

            // Length already zeroed for types that use varying representation
#if PT_VAR_CHAR | JUST_COMPILE
            case PT_VAR_CHAR:
#endif
#if PTN_VAR_CHAR | JUST_COMPILE
            case PTN_VAR_CHAR:
#endif
#if PT_VAR_FIXED_CHAR | JUST_COMPILE
            case PT_VAR_FIXED_CHAR:
#endif
#if PTN_VAR_FIXED_CHAR | JUST_COMPILE
            case PTN_VAR_FIXED_CHAR:
#endif
#if PT_NVAR_FIXED_CHAR | JUST_COMPILE
            case PT_NVAR_FIXED_CHAR:
#endif
#if PTN_NVAR_FIXED_CHAR | JUST_COMPILE
            case PTN_NVAR_FIXED_CHAR:
#endif
#if PT_NVAR_CHAR | JUST_COMPILE
            case PT_NVAR_CHAR:
#endif
#if PTN_NVAR_CHAR | JUST_COMPILE
            case PTN_NVAR_CHAR:
#endif
#if PT_VAR_CHAR | PTN_VAR_CHAR | PT_VAR_FIXED_CHAR | PTN_VAR_FIXED_CHAR | PT_NVAR_FIXED_CHAR | PTN_NVAR_FIXED_CHAR | PT_NVAR_CHAR | PTN_NVAR_CHAR | JUST_COMPILE
                break;
#endif

#if BLOB_SUPPORT_AGAIN                
            // Body pointer already zeroed for types that use blob representation
#if PT_BLOB | JUST_COMPILE
            case PT_BLOB:
#endif
#if PTN_BLOB | JUST_COMPILE
            case PTN_BLOB:
#endif
#if PT_CLOB | JUST_COMPILE
            case PT_CLOB:
#endif
#if PTN_CLOB | JUST_COMPILE
            case PTN_CLOB:
#endif
#if PT_NUCL | JUST_COMPILE
            case PT_NUCL:
#endif
#if PTN_NUCL | JUST_COMPILE
            case PTN_NUCL:
#endif
#if PT_PROT | JUST_COMPILE
            case PT_PROT:
#endif
#if PTN_PROT | JUST_COMPILE
            case PTN_PROT:
#endif
#if PT_NCLOB | JUST_COMPILE
            case PT_NCLOB:
#endif
#if PTN_NCLOB | JUST_COMPILE
            case PTN_NCLOB:
#endif
#if PT_BLOB | PTN_BLOB | PT_CLOB | PTN_CLOB | PT_NUCL | PTN_NUCL | PT_PROT | PTN_PROT | PT_NCLOB | PTN_NCLOB | JUST_COMPILE
                break;
#endif
#endif //BLOB_SUPPORT_AGAIN                

                // special cases with an implied size of 4 bytes
#if PT_DATE_MMM_D_Y | JUST_COMPILE
            case PT_DATE_MMM_D_Y:
#endif
#if PTN_DATE_MMM_D_Y | JUST_COMPILE
            case PTN_DATE_MMM_D_Y:
#endif
#if PT_DATE_N_DMMMY | JUST_COMPILE
            case PT_DATE_N_DMMMY:
#endif
#if PT_DATE_D_DMMMY | JUST_COMPILE
            case PT_DATE_D_DMMMY:
#endif
#if PT_DATE_N_DMY | JUST_COMPILE
            case PT_DATE_N_DMY:
#endif
#if PT_DATE_D_DMY | JUST_COMPILE
            case PT_DATE_D_DMY:
#endif
#if PT_DATE_N_MDY | JUST_COMPILE
            case PT_DATE_N_MDY:
#endif
#if PT_DATE_D_MDY | JUST_COMPILE
            case PT_DATE_D_MDY:
#endif
#if PT_DATE_N_YMD | JUST_COMPILE
            case PT_DATE_N_YMD:
#endif
#if PT_DATE_D_YMD | JUST_COMPILE
            case PT_DATE_D_YMD:
#endif
#if PT_DATE_MMM_D_Y | PTN_DATE_MMM_D_Y | PT_DATE_N_DMMMY | PT_DATE_D_DMMMY | PT_DATE_N_DMY | PT_DATE_D_DMY | PT_DATE_N_MDY | PT_DATE_D_MDY | PT_DATE_N_YMD | PT_DATE_D_YMD | JUST_COMPILE
                if (REG_pFldPrsCtl->flags & FPF_TIMESTAMP) goto ZERO_FIXED_FIELD_8_BYTES;
#endif
#if PT_NUMERIC4 | JUST_COMPILE
            case PT_NUMERIC4:
#endif
#if PT_NUMERIC4 | PT_DATE_MMM_D_Y | PTN_DATE_MMM_D_Y | PT_DATE_N_DMMMY | PT_DATE_D_DMMMY | PT_DATE_N_DMY | PT_DATE_D_DMY | PT_DATE_N_MDY | PT_DATE_D_MDY | PT_DATE_N_YMD | PT_DATE_D_YMD | JUST_COMPILE
                nFixedFieldBytes = 4;
                goto ZERO_FIXED_FIELD;
#endif

                // special cases with an implied size of 8 bytes
#if PT_TIME_N_24 | JUST_COMPILE
            case PT_TIME_N_24:
#endif
#if PT_TIME_D_24 | JUST_COMPILE
            case PT_TIME_D_24:
#endif
#if PT_TIME_N_12 | JUST_COMPILE
            case PT_TIME_N_12:
#endif
#if PT_TIME_D_12 | JUST_COMPILE
            case PT_TIME_D_12:
#endif
#if PT_TIME_N_24_TRUNC | JUST_COMPILE
            case PT_TIME_N_24_TRUNC:
#endif
#if PT_TIME_D_24_TRUNC | JUST_COMPILE
            case PT_TIME_D_24_TRUNC:
#endif
#if PT_TIME_N_12_TRUNC | JUST_COMPILE
            case PT_TIME_N_12_TRUNC:
#endif
#if PT_TIME_D_12_TRUNC | JUST_COMPILE
            case PT_TIME_D_12_TRUNC:
#endif
#if PT_NUMERIC8 | JUST_COMPILE
            case PT_NUMERIC8:
#endif
#if PT_NUMERIC8 | PT_DATE_MMM_D_Y | PTN_DATE_MMM_D_Y | PT_DATE_N_DMMMY | PT_DATE_D_DMMMY | PT_DATE_N_DMY | PT_DATE_D_DMY | PT_DATE_N_MDY | PT_DATE_D_MDY | PT_DATE_N_YMD | PT_DATE_D_YMD | PT_TIME_N_24 | PT_TIME_D_24 | PT_TIME_N_12 | PT_TIME_D_12 | PT_TIME_N_24_TRUNC | PT_TIME_D_24_TRUNC | PT_TIME_N_12_TRUNC | PT_TIME_D_12_TRUNC | JUST_COMPILE
            ZERO_FIXED_FIELD_8_BYTES:
                nFixedFieldBytes = 8;
                goto ZERO_FIXED_FIELD;
#endif

                // special cases with an implied size of 12 bytes
#if PT_TIME_N_24_TZ | JUST_COMPILE
            case PT_TIME_N_24_TZ:
#endif
#if PT_TIME_D_24_TZ | JUST_COMPILE
            case PT_TIME_D_24_TZ:
#endif
#if PT_TIME_N_12_TZ | JUST_COMPILE
            case PT_TIME_N_12_TZ:
#endif
#if PT_TIME_D_12_TZ | JUST_COMPILE
            case PT_TIME_D_12_TZ:
#endif
#if PT_TIME_N_24_TZ | PT_TIME_D_24_TZ | PT_TIME_N_12_TZ | PT_TIME_D_12_TZ | JUST_COMPILE
                nFixedFieldBytes = 12;
                goto ZERO_FIXED_FIELD;
#endif

               // special cases with an implied size of 16 bytes
#if PT_NUMERIC16 | JUST_COMPILE
            case PT_NUMERIC16:
                nFixedFieldBytes = 16;
                goto ZERO_FIXED_FIELD;
#endif

            // Zero out storage of remaining fixed representation types
            default:
                nFixedFieldBytes = REG_pFldPrsCtl->extra.declSize;
            ZERO_FIXED_FIELD:
                uint8* pFixedField = (uint8* )pRecordBuffer;
                pFixedField += REG_pFldPrsCtl->offset;
                do
                    *pFixedField++ = 0;
                while ( --nFixedFieldBytes );
            }

            fillFlags = REG_pFldPrsCtl->flags;
            if ( !(fillFlags & FPF_NULLABLE) ) goto CANNOT_FILL_FIELD;
            // REG_pFldPrsCtl->nullIndex is prebiased to avoid need to sizeWordSize to pRecord
            pRecord[ REG_pFldPrsCtl->nullIndex >> 3 ] |= 1 << (REG_pFldPrsCtl->nullIndex & 7);
            }
        while ( !(fillFlags & FPF_LAST_FIELD) );
        goto END_OF_RECORD;

// =============================
// Abort the current record delivering a particular error
        {
            int errCode;

#define REPORT_ERROR(CODE) errCode = LDR_SC_##CODE; goto EMIT_DIAGNOSTIC
#define DIAGNOSE(CODE) CODE: REPORT_ERROR(CODE)

DIAGNOSE_BAD_WEIGHT:
    switch( unicodeProperties[ badUnicodeCodePoint ] ) {
UNASSIGNED_UNICODE_CODEPOINT:
    case UNASS:
        REPORT_ERROR(UNASSIGNED_UNICODE_CODEPOINT);
    case BOM16:
        REPORT_ERROR(UNICODE_BOM);
    case SROGT:
        REPORT_ERROR(SURROGATE_HALF_ONLY_IN_UTF16);
    case _NOT_:
        REPORT_ERROR(UNSUPPORTED_PRECOMPOSED_CODEPOINT);
BAD_SEQUENCE:
    default:
        REPORT_ERROR(NOT_NFC);
    }
EXCEED:
        REPORT_ERROR(EXCEED_COMBINING);

    DIAGNOSE(UTF8_ILLEGAL_INITIAL_BYTE);
    DIAGNOSE(CESU8_ILLEGAL_INITIAL_BYTE);
//    DIAGNOSE(UTF8_MISPLACED_CONTINUATION_BYTE);
    DIAGNOSE(UTF8_BAD_CONTINUATION_BYTE);
    DIAGNOSE(TOO_MANY_DIGITS_BEFORE_DP);
    DIAGNOSE(TOO_MANY_DIGITS_AFTER_DP);
    DIAGNOSE(TEXT_FIELD_TOO_LONG);
    DIAGNOSE(INCOMPLETE_NO_FILL_RECORD);
    DIAGNOSE(CANNOT_FILL_FIELD);
    DIAGNOSE(NULL_TOKEN_BUT_NOT_NULLABLE);
    DIAGNOSE(INVALID_CHARACTER);
    DIAGNOSE(TRUNC_TIME_OUT_OF_RANGE);
    DIAGNOSE(ILLEGAL_EMPTY_FIELD);
    DIAGNOSE(ZERO_DAY);
    DIAGNOSE(ZERO_MONTH);
    DIAGNOSE(MICROSECONDS_TOO_MANY_DIGITS);
    DIAGNOSE(UNKNOWN_MONTH);
    DIAGNOSE(BAD_AM_PM);
    DIAGNOSE(MONTH_TOO_LARGE);
    DIAGNOSE(DAY_TOO_LARGE_FOR_MONTH);
    DIAGNOSE(HOURS12_TOO_LARGE);
    DIAGNOSE(HOURS24_TOO_LARGE);
    DIAGNOSE(HOURS25_TOO_LARGE);
    DIAGNOSE(MINUTES_TOO_LARGE);
    DIAGNOSE(SECONDS_TOO_LARGE);
    DIAGNOSE(TIME_GREATER_THAN_240000);
    DIAGNOSE(TZ_MINUTES_TOO_LARGE);
    DIAGNOSE(TZ_TOO_LARGE);
    DIAGNOSE(TZ_TOO_SMALL);
    DIAGNOSE(FP_FORMAT_OVERFLOW);
    DIAGNOSE(FP_FORMAT_UNDERFLOW);
    DIAGNOSE(INT1_OUT_OF_RANGE);
    DIAGNOSE(INT2_OUT_OF_RANGE);
    DIAGNOSE(INT4_OUT_OF_RANGE);
    DIAGNOSE(INT8_OUT_OF_RANGE);
    DIAGNOSE(EXPONENT_OUT_OF_RANGE);
    DIAGNOSE(EXPECTED_TIMESTAMP_TIME);
    DIAGNOSE(EXPECTED_YEAR_DIGIT);
    DIAGNOSE(EXPECTED_MONTH_DIGIT);
    DIAGNOSE(EXPECTED_DAY_DIGIT);
    DIAGNOSE(EXPECTED_DAY_DIGIT_OR_SPACE);
    DIAGNOSE(EXPECTED_DATE_DELIMITER);
    DIAGNOSE(EXPECTED_HOUR_DIGIT);
    DIAGNOSE(EXPECTED_MINUTE_DIGIT);
    DIAGNOSE(EXPECTED_SECOND_DIGIT);
    DIAGNOSE(EXPECTED_TIME_DELIMITER);
    DIAGNOSE(EXPECTED_TZ_SIGN);
    DIAGNOSE(EXPECTED_TZ_HOUR_DIGIT);
    DIAGNOSE(EXPECTED_TZ_MINUTE_DIGIT);
    DIAGNOSE(EXPECTED_DIGIT);
    DIAGNOSE(EXPECTED_DIGIT_OR_DECIMAL_POINT);
    DIAGNOSE(EXPECTED_OPENING_QUOTE);
    DIAGNOSE(EXPECTED_OPENING_QUOTE_OR_NULL_TOKEN);
    DIAGNOSE(EXPECTED_CLOSING_QUOTE);
    DIAGNOSE(EXPECTED_FIELD_DELIMITER);
    DIAGNOSE(EXPECTED_END_OF_RECORD);
    DIAGNOSE(EXPECTED_COMMA_OR_DATE_DELIM);
    DIAGNOSE(EXPECTED_SPACE);
    DIAGNOSE(MULTIPLE_DECIMAL_POINTS);
    DIAGNOSE(UNIDENTIFIED_FIELD_VALUE);
    DIAGNOSE(INVALID_CTRLCHARS);
    DIAGNOSE(EXPECTED_IGNORE_ZERO);
    DIAGNOSE(INTERVAL_EXPECTED_NUMBER);
    DIAGNOSE(INTERVAL_OVERFLOW);
    DIAGNOSE(INTERVAL_YEARS_RANGE);
    DIAGNOSE(INTERVAL_MONTHS_RANGE);
    DIAGNOSE(INTERVAL_SUM_YEAR_MONTH_OVERFLOW);
    DIAGNOSE(INTERVAL_PG_MAX_MONTHS);
    DIAGNOSE(INTERVAL_DAYS_RANGE);
    DIAGNOSE(INTERVAL_HOURS_RANGE);
    DIAGNOSE(INTERVAL_TIME_OVERFLOW);
    DIAGNOSE(INVALID_INFINITY);
    
    EXPECTED_END_OF_FIELD:
    if ( ch < ' ' ) {
        switch ( REG_pFldPrsCtl->parseDataType ) {
#if PT_VAR_CHAR | JUST_COMPILE
            case PT_VAR_CHAR:
#endif
#if PTN_VAR_CHAR | JUST_COMPILE
            case PTN_VAR_CHAR:
#endif
#if PT_VAR_FIXED_CHAR | JUST_COMPILE
            case PT_VAR_FIXED_CHAR:
#endif
#if PTN_VAR_FIXED_CHAR | JUST_COMPILE
            case PTN_VAR_FIXED_CHAR:
#endif
#if PT_NVAR_FIXED_CHAR | JUST_COMPILE
            case PT_NVAR_FIXED_CHAR:
#endif
#if PTN_NVAR_FIXED_CHAR | JUST_COMPILE
            case PTN_NVAR_FIXED_CHAR:
#endif
#if PT_NVAR_CHAR | JUST_COMPILE
            case PT_NVAR_CHAR:
#endif
#if PTN_NVAR_CHAR | JUST_COMPILE
            case PTN_NVAR_CHAR:
#endif
#if PT_VAR_CHAR | PTN_VAR_CHAR | PT_VAR_FIXED_CHAR | PTN_VAR_FIXED_CHAR | PT_NVAR_FIXED_CHAR | PTN_NVAR_FIXED_CHAR | PT_NVAR_CHAR | PTN_NVAR_CHAR | JUST_COMPILE
                // SWS-68873: to handle <NUL>'s case 
                if (ch == '\0') 
                    goto EXPECTED_IGNORE_ZERO;

                goto INVALID_CTRLCHARS;
                break;
#endif
            default:
                goto EXPECTED_FIELD_DELIMITER;
        }
    }
    else
        goto EXPECTED_FIELD_DELIMITER;

    EMIT_DIAGNOSTIC:
        // isolate entire line, stop at first end of record character
        pErrorPosition = pUTF8ErrorPosition = pText;
        pText = *pRemainingText;
        // "Prime the pump", fill ch with first <EOR>
        NEXT_CHAR(pEnd);
        // Step over previously identified <EOR> character
        NEXT_CHAR(pEnd);
        pStartOfBadRow = pText;
#if CR_IS_EOR
        // Allow <\r><\n> (DOS) and <\n><\r> (MAC) pairs
        if ( ch == eor2 ) {
            NEXT_CHAR(pEnd);
            pStartOfBadRow = pText;
            }
#endif

        uint8* pBadRec = m_badRec;
        uint8* pEndOfBadRec = &m_badRec[BAD_REC_MAX];
        uint8* pBadField = m_badField;
        uint8* pEndOfBadField = &m_badField[BAD_FIELD_MAX];

#if BSLASH_ESCAPE
        // Need a true variable to handle escape semantics
        bool escaped = FALSE;
#endif

        bool malformedUtf8 = (errCode == LDR_SC_UTF8_ILLEGAL_INITIAL_BYTE ||
                              errCode == LDR_SC_UTF8_BAD_CONTINUATION_BYTE);
        bool badCodepoint  = (errCode == LDR_SC_UNSUPPORTED_PRECOMPOSED_CODEPOINT ||
                              errCode == LDR_SC_UNASSIGNED_UNICODE_CODEPOINT ||
                              errCode == LDR_SC_UNICODE_BOM);
        bool notNFC        = (errCode == LDR_SC_NOT_NFC ||
                              errCode == LDR_SC_EXCEED_COMBINING);

        if (malformedUtf8 || badCodepoint || notNFC)
            pErrorPosition = pUtf8GraphemeStart + 1;
        while ( TRUE ) {
            if ( pStartOfField <= pText &&
                 pText <= pErrorPosition &&
                 pBadField < pEndOfBadField
               )
                *pBadField++ = ch;

#if BSLASH_ESCAPE
            if ( escaped ) {
                escaped = FALSE;
            }
            else {
#endif
            	if ( ch == '\n' ||  CH_IS_CR_EOR )
                    break;
#if BSLASH_ESCAPE
                else if ( ch == escapeChar )
                    escaped = TRUE;
            }
#endif
            if ( pBadRec < pEndOfBadRec )
                *pBadRec++ = ch;
            NEXT_CHAR(pEnd);
            }

        int badCh;
        if ( suppressLineFeed )
            badCh = pBadField[-2];
        else
            badCh = pBadField[-1];
        pBadField[-1] = '\0';
        pBadRec[0] = '\0';

        int recLen = pText - pStartOfBadRow;

        // All message have similar prefix:
        //  {1}: Error counter (effectively index into nzbad file)
        //  {2}: Input record #
        //  {3}: Byte offset to character when error was detected
        //  {4}: Input field #
        //  {5}: Column's type in schema
        //  {6}: Type arguments ("", "(<max len>)", or "(<p>,<s>)")
        //  {7}: Bad field text
        //  {8}: Error character (%c if printable else %02x)

        char typeArg[16];
        pFldPrsCtl=REG_pFldPrsCtl; // SWS-71993: To improve error message in log file  
        switch ( pFldPrsCtl->parseDataType ) {
#if PT_CHAR1 | JUST_COMPILE
        case PT_CHAR1:
#endif
#if PTN_CHAR1 | JUST_COMPILE
        case PTN_CHAR1:
#endif
#if PT_CHAR | JUST_COMPILE
        case PT_CHAR:
#endif
#if PTN_CHAR | JUST_COMPILE
        case PTN_CHAR:
#endif
#if PT_VAR_CHAR | JUST_COMPILE
        case PT_VAR_CHAR:
#endif
#if PTN_VAR_CHAR | JUST_COMPILE
        case PTN_VAR_CHAR:
#endif
#if PT_NVAR_CHAR | JUST_COMPILE
        case PT_NVAR_CHAR:
#endif
#if PTN_NVAR_CHAR | JUST_COMPILE
        case PTN_NVAR_CHAR:
#endif
#if PT_VAR_FIXED_CHAR | JUST_COMPILE
        case PT_VAR_FIXED_CHAR:
#endif
#if PTN_VAR_FIXED_CHAR | JUST_COMPILE
        case PTN_VAR_FIXED_CHAR:
#endif
#if PT_NVAR_FIXED_CHAR | JUST_COMPILE
        case PT_NVAR_FIXED_CHAR:
#endif
#if PTN_NVAR_FIXED_CHAR | JUST_COMPILE
        case PTN_NVAR_FIXED_CHAR:
#endif
#if PT_CHAR1 | PTN_CHAR1 | PT_CHAR | PTN_CHAR | PT_VAR_CHAR | PTN_VAR_CHAR | PT_VAR_FIXED_CHAR | PTN_VAR_FIXED_CHAR | PT_NVAR_CHAR | PTN_NVAR_CHAR | PT_NVAR_FIXED_CHAR | PTN_NVAR_FIXED_CHAR | JUST_COMPILE
            sprintf(typeArg, "(%d)", pFldPrsCtl->extra.declSize);
            break;
#endif
#if PT_NUMERIC4 | JUST_COMPILE
        case PT_NUMERIC4:
#endif
#if PT_NUMERIC8 | JUST_COMPILE
        case PT_NUMERIC8:
#endif
#if PT_NUMERIC16 | JUST_COMPILE
        case PT_NUMERIC16:
#endif
#if PT_NUMERIC4 | PT_NUMERIC8 | PT_NUMERIC16 | JUST_COMPILE
            sprintf(typeArg, "(%d,%d)", pFldPrsCtl->extra.precAndScale&255, pFldPrsCtl->extra.precAndScale>>8);
            break;
#endif
        default:
            typeArg[0] = '\0';
            }

        char badChStr[32];
        const char* pBadChStr = badChStr;
        // if problem was malformed UTF-8 show all bytes examined
        if (malformedUtf8){
            const uint8* p = pUtf8GraphemeStart;
            char* q = badChStr;
            do {
                if (q != badChStr)
                    *q++ = ' ';
                *q++ = '0';
                *q++ = 'x';
                uint32 nibble = *p >> 4;
                nibble += '0';
                if (nibble > '9')
                    nibble += (-'9'-1+'A');
                *q++ = nibble;
                nibble = *p++ & 0xF;
                nibble += '0';
                if (nibble > '9')
                    nibble += (-'9'-1+'A');
                *q++ = nibble;
                }
            while (p != pUTF8ErrorPosition);
            *q = 0;
            }
        // if problem was a bad Unicode code point display Unicode, not UTF-8
        else if (badCodepoint) {
            char* q = badChStr;
            int shift = (badUnicodeCodePoint > 0xFFFF) ? 4*4 : 3*4;
            *q++ = 'U';
            *q++ = '+';
            do {
                uint32 nibble = badUnicodeCodePoint >> shift;
                nibble &= 0xF;
                nibble += '0';
                if (nibble > '9')
                    nibble += (-'9'-1+'A');
                *q++ = nibble;
                shift -= 4;
                }
            while (shift >= 0);
            *q = 0;
            }
        else {
            switch ( badCh ) {
            case '\0':
                pBadChStr = "0x00<NUL>";
                break;
            case '\a':
                pBadChStr = "0x07<BEL>";
                break;
            case '\b':
                pBadChStr = "0x08<BS>";
                break;
            case '\t':
                pBadChStr = "0x09<HT>";
                break;
            case '\n':
                pBadChStr = "0x0a<LF>";
                break;
            case '\v':
                pBadChStr = "0x0b<VT>";
                break;
            case '\f':
                pBadChStr = "0x0c<FF>";
                break;
            case '\r':
                pBadChStr = "0x0d<CR>";
                break;
            case 0x1b:
                pBadChStr = "0x1b<ESC>";
                break;
            case 0x7f:
                pBadChStr = "0x7f<DEL>";
                break;
            default:
//            if ( badCh < ' ' )
                sprintf(badChStr, badCh < ' ' ? "0x%02x" : "%c", badCh);
                break;
                }
            }

        // Count rejected rows
        if ( rowsToBeSkipped )
            m_badRowsSkipped += 1;
        else {
            // only report bad records when no longer skipping rows
            m_rowsRejected += 1;

            logError(errCode,
                     m_rowsRejected,
                     m_rowsConsumed + rowsConsumed + 1,
                     pErrorPosition - pStartOfBadRow,
                     (pFldPrsCtl - pFPC) + 1,
                     ( pFldPrsCtl->flags & FPF_TIMESTAMP ? "TIMESTAMP"
                       : sqlTypeString(pFldPrsCtl->parseDataType) ),
                     typeArg,
                     (char*)m_badField,
                     pBadChStr);

            //!FIXME-tho - fudge factor for now - really need to check for record
            // too long (exceeds 2 X readbuffer size, governed by socketBufSize
            // in LoadOpt.
            //!FIXME-jsy - this logic really belongs in logBadRecord
            if (recLen <= 2048000) {
                // copy the bad input record into the nzbad file
                if ( !suppressLineFeed )
                    logBadRecord(pStartOfBadRow-1, recLen);
                else
                    logBadRecord(pStartOfBadRow-1, recLen, TRUE);
            }


            if ( m_maxErrors && --m_maxErrors == 0 )
                halted = TRUE;
            }

        flags = FPF_SUPRESS_LOAD;

        goto END_OF_RECORD;
        }

    } // while (TRUE) // Process successive full rows in this buffer

// =============================
#if PT_INT1 | PT_INT1_ZERO_CHECK | JUST_COMPILE
            CHECK_PLUS_INT1:
                if ( ch != '+' ) goto SPACES_INT1;
                goto PLUS_SIGN_INT1;

            SPACES_INT1:
                SKIP_SPACES_ELSE(EMPTY_INT1);
                goto RESTART_INT1;
#endif

#if PT_INT2 | PT_INT2_ZERO_CHECK | JUST_COMPILE
            CHECK_PLUS_INT2:
                if ( ch != '+' ) goto SPACES_INT2;
                goto PLUS_SIGN_INT2;

            SPACES_INT2:
                SKIP_SPACES_ELSE(EMPTY_INT2);
                goto RESTART_INT2;
#endif

#if PT_INT4 | PT_INT4_ZERO_CHECK | JUST_COMPILE
            CHECK_PLUS_INT4:
                if ( ch != '+' ) goto SPACES_INT4;
                goto PLUS_SIGN_INT4;

            SPACES_INT4:
                SKIP_SPACES_ELSE(EMPTY_INT4);
                goto RESTART_INT4;

            ALLOW_MAX_NEGATIVE_INT4:
                if ( val == 0x80000000 && (flags & FPF_NEGATE) ) goto MAX_NEGATIVE_INT4;
                goto INT4_OUT_OF_RANGE;
#endif

#if PT_INT8 | JUST_COMPILE
            CHECK_PLUS_INT8:
                if ( ch != '+' ) goto SPACES_INT8;
                goto PLUS_SIGN_INT8;

            SPACES_INT8:
                SKIP_SPACES_ELSE(EMPTY_INT8);
                goto RESTART_INT8;

            ALLOW_MAX_NEGATIVE_INT8:
                if ( vhi == 0x80000000 && vlo == 0 && (flags & FPF_NEGATE) )
                    goto MAX_NEGATIVE_INT8;
                goto INT8_OUT_OF_RANGE;
#endif
// =============================
// Handle the -AdjustDistZeroInt flag for INT1, INT2, and INT4 (for Orange)

#if PT_INT1_ZERO_CHECK | JUST_COMPILE
CHECK_ADJUST_ZERO_INT1:
    if ( val != 0 ) goto ADJUST_ZERO_RETURN_INT1;
    val = syntheticDistKey;
    if (val == MIN_INT1) val = 0;
    --val;
    syntheticDistKey = val;
    goto ADJUST_ZERO_RETURN_INT1;
#endif

#if PT_INT2_ZERO_CHECK | JUST_COMPILE
CHECK_ADJUST_ZERO_INT2:
    if ( val != 0 ) goto ADJUST_ZERO_RETURN_INT2;
    val = syntheticDistKey;
    if ( val == adjustZeroWrap || val == MIN_INT2) val = 0;
    --val;
    syntheticDistKey = val;
    goto ADJUST_ZERO_RETURN_INT2;
#endif

#if PT_INT4_ZERO_CHECK | JUST_COMPILE
CHECK_ADJUST_ZERO_INT4:
    if ( val != 0 ) goto ADJUST_ZERO_RETURN_INT4;
    val = syntheticDistKey;
    if ( val == adjustZeroWrap ) val = 0;
    --val;
    syntheticDistKey = val;
    goto ADJUST_ZERO_RETURN_INT4;
#endif


END_OF_BUFFER:

    // copy state back into object
    myObj = this;
#if CR_IS_EOR
    myObj->m_eor2 = eor2;
#endif
    myObj->m_rowsToBeProcessed = rowsToBeProcessed;
    myObj->m_rowsToBeSkipped   = rowsToBeSkipped;
    myObj->m_rowsConsumed += rowsConsumed;
    myObj->m_bytesConsumed += bytesConsumed;
    myObj->m_halted = halted;
    myObj->m_syntheticDistKey  = syntheticDistKey;

    // return pointer to first unconsumed character

//******************************************************************************
