#ifndef LDR_DB2_LIST_H
#define LDR_DB2_LIST_H

/// Length of a BIGINT value
#define DB2Z_BIGINT_LENGTH 8
/// Length of a BIGINT value (nullable)
#define DB2Z_BIGINT_LENGTH_NULLABLE 9
/// Length of a DATE value
#define DB2Z_DATE_LENGTH 4
/// Length of a DATE value (nullable)
#define DB2Z_DATE_LENGTH_NULLABLE 5
/// Length of a DOUBLE value
#define DB2Z_DOUBLE_LENGTH 8
/// Length of a DOUBLE value (nullable)
#define DB2Z_DOUBLE_LENGTH_NULLABLE 9
/// Length of the header of a record
#define DB2Z_HEADER_LENGTH 6
/// Length of an INT value
#define DB2Z_INT_LENGTH 4
/// Length of an INT value (nullable)
#define DB2Z_INT_LENGTH_NULLABLE 5
/// Length of the NULL indicator header
#define DB2Z_NULL_HEADER_LENGTH 1
/// Length of the offset to a varying-length column (RRF)
#define DB2Z_OFFSET_LENGTH 2
/// Length of a REAL value
#define DB2Z_REAL_LENGTH 4
/// Length of a REAL value (nullable)
#define DB2Z_REAL_LENGTH_NULLABLE 5
/// Length of the size and NULL indicator headers of a varying-length value (BRF)
#define DB2Z_SIZE_AND_NULL_HEADERS_LENGTH 3
/// Length of the size header of a varying-length value
#define DB2Z_SIZE_HEADER_LENGTH 2
/// Length of a SMALLINT value
#define DB2Z_SMALLINT_LENGTH 2
/// Length of a SMALLINT value (nullable)
#define DB2Z_SMALLINT_LENGTH_NULLABLE 3
/// Length of a TIME value
#define DB2Z_TIME_LENGTH 3
/// Length of a TIME value (nullable)
#define DB2Z_TIME_LENGTH_NULLABLE 4
/// Length of a TIMESTAMP(12) value
#define DB2Z_TIMESTAMP12_LENGTH 13
/// Length of a TIMESTAMP(12) value (nullable)
#define DB2Z_TIMESTAMP12_LENGTH_NULLABLE 14
/// Length of a TIMESTAMP(6) value
#define DB2Z_TIMESTAMP6_LENGTH 10
/// Length of a TIMESTAMP(6) value (nullable)
#define DB2Z_TIMESTAMP6_LENGTH_NULLABLE 11
/// Maximum length of an NVARCHAR value (NPS)
#define MAX_NVARCHAR_SIZE 16000

#define DB2_TYPE_LIST \
_EMIT_(DB2_BIGINT,                  "BIGINT"                  ) _DELIM_ \
_EMIT_(DB2N_BIGINT,                 "BIGINT"                  ) _DELIM_ \
_EMIT_(DB2_CHAR_MIXED,              "CHAR FOR MIXED DATA"     ) _DELIM_ \
_EMIT_(DB2N_CHAR_MIXED,             "CHAR FOR MIXED DATA"     ) _DELIM_ \
_EMIT_(DB2_CHAR_MIXED_ICU,          "CHAR FOR MIXED DATA"     ) _DELIM_ \
_EMIT_(DB2N_CHAR_MIXED_ICU,         "CHAR FOR MIXED DATA"     ) _DELIM_ \
_EMIT_(DB2_CHAR_SBCS,               "CHAR FOR SBCS DATA"      ) _DELIM_ \
_EMIT_(DB2N_CHAR_SBCS,              "CHAR FOR SBCS DATA"      ) _DELIM_ \
_EMIT_(DB2_CHAR_SBCS_16,            "CHAR FOR SBCS DATA"      ) _DELIM_ \
_EMIT_(DB2N_CHAR_SBCS_16,           "CHAR FOR SBCS DATA"      ) _DELIM_ \
_EMIT_(DB2_CHAR_SBCS_ICU,           "CHAR FOR SBCS DATA"      ) _DELIM_ \
_EMIT_(DB2N_CHAR_SBCS_ICU,          "CHAR FOR SBCS DATA"      ) _DELIM_ \
_EMIT_(DB2_DATE,                    "DATE"                    ) _DELIM_ \
_EMIT_(DB2N_DATE,                   "DATE"                    ) _DELIM_ \
_EMIT_(DB2_DECIMAL_1,               "DECIMAL"                 ) _DELIM_ \
_EMIT_(DB2N_DECIMAL_1,              "DECIMAL"                 ) _DELIM_ \
_EMIT_(DB2_DECIMAL_2_9,             "DECIMAL"                 ) _DELIM_ \
_EMIT_(DB2N_DECIMAL_2_9,            "DECIMAL"                 ) _DELIM_ \
_EMIT_(DB2_DECIMAL_10_18,           "DECIMAL"                 ) _DELIM_ \
_EMIT_(DB2N_DECIMAL_10_18,          "DECIMAL"                 ) _DELIM_ \
_EMIT_(DB2_DECIMAL_19_38,           "DECIMAL"                 ) _DELIM_ \
_EMIT_(DB2N_DECIMAL_19_38,          "DECIMAL"                 ) _DELIM_ \
_EMIT_(DB2_DOUBLE,                  "DOUBLE"                  ) _DELIM_ \
_EMIT_(DB2N_DOUBLE,                 "DOUBLE"                  ) _DELIM_ \
_EMIT_(DB2_GRAPHIC,                 "GRAPHIC"                 ) _DELIM_ \
_EMIT_(DB2N_GRAPHIC,                "GRAPHIC"                 ) _DELIM_ \
_EMIT_(DB2_INT,                     "INT"                     ) _DELIM_ \
_EMIT_(DB2N_INT,                    "INT"                     ) _DELIM_ \
_EMIT_(DB2_REAL,                    "REAL"                    ) _DELIM_ \
_EMIT_(DB2N_REAL,                   "REAL"                    ) _DELIM_ \
_EMIT_(DB2_REAL_TO_DOUBLE,          "REAL"                    ) _DELIM_ \
_EMIT_(DB2N_REAL_TO_DOUBLE,         "REAL"                    ) _DELIM_ \
_EMIT_(DB2_SKIPPED,                 "SKIPPED COLUMN"          ) _DELIM_ \
_EMIT_(DB2_SMALLINT,                "SMALLINT"                ) _DELIM_ \
_EMIT_(DB2N_SMALLINT,               "SMALLINT"                ) _DELIM_ \
_EMIT_(DB2_TIME,                    "TIME"                    ) _DELIM_ \
_EMIT_(DB2N_TIME,                   "TIME"                    ) _DELIM_ \
_EMIT_(DB2_TIMESTAMP,               "TIMESTAMP"               ) _DELIM_ \
_EMIT_(DB2N_TIMESTAMP,              "TIMESTAMP"               ) _DELIM_ \
_EMIT_(DB2_TIMESTAMP_12,            "TIMESTAMP"               ) _DELIM_ \
_EMIT_(DB2N_TIMESTAMP_12,           "TIMESTAMP"               ) _DELIM_ \
_EMIT_(DB2_VARCHAR_MIXED,           "VARCHAR FOR MIXED DATA"  ) _DELIM_ \
_EMIT_(DB2N_VARCHAR_MIXED,          "VARCHAR FOR MIXED DATA"  ) _DELIM_ \
_EMIT_(DB2_VARCHAR_MIXED_ICU,       "VARCHAR FOR MIXED DATA"  ) _DELIM_ \
_EMIT_(DB2N_VARCHAR_MIXED_ICU,      "VARCHAR FOR MIXED DATA"  ) _DELIM_ \
_EMIT_(DB2_VARCHAR_SBCS,            "VARCHAR FOR SBCS DATA"   ) _DELIM_ \
_EMIT_(DB2N_VARCHAR_SBCS,           "VARCHAR FOR SBCS DATA"   ) _DELIM_ \
_EMIT_(DB2_VARCHAR_SBCS_ICU,        "VARCHAR FOR SBCS DATA"   ) _DELIM_ \
_EMIT_(DB2N_VARCHAR_SBCS_ICU,       "VARCHAR FOR SBCS DATA"   ) _DELIM_ \
_EMIT_(DB2_VARGRAPHIC,              "VARGRAPHIC"              ) _DELIM_ \
_EMIT_(DB2N_VARGRAPHIC,             "VARGRAPHIC"              ) _DELIM_ \
_EMIT_(DB2_VARSKIPPED,              "SKIPPED COLUMN"          ) _DELIM_ \
_EMIT_(DB2_DWA_HIDDEN_PARTITION_ID, "DWA_HIDDEN_PARTITION_ID" ) _DELIM_ \
_EMIT_(DB2_END_OF_RECORD,           "*END OF RECORD*"         )

// Define the DB2_XXX values within an enumeration
#define _EMIT_(parseType,sqlTypeString) parseType
#define _DELIM_ ,
    enum { DB2_TYPE_LIST };
#undef _EMIT_
#undef _DELIM_

#endif // LDR_DB2_LIST_H
