

/*
 *  nzfenceddatuml.h
 *  Netezza Fenced Exception
 * (C) Copyright IBM Corp. 2009, 2011  All Rights Reserved.
 */

#ifndef __NZFENCEDDATUM_H__
#define __NZFENCEDDATUM_H__

extern "C" {
#include "nzrep.h"
#include "nzrepcommands.h"
#include "nzsds.h"
}

#include "nzudsfenced.h"

#include <udx.h>

struct NzFencedModeDatum
{
    NzFencedModeDatum();
    ~NzFencedModeDatum();
    nz::udx::FuncDatum makeFromBuffer(NzUdsFenced &uds, bool &bNull, bool stringArg);
    nz::udx::FuncDatum makeFromStored(int type, bool &bNull, bool stringArg);


    // ArgType means primitives plus Numeric*Val, StringArg, TimeTzADT,
    // Interval
    // ReturnType means primitives plus Numeric*Val, StringReturn,
    // IntervalReturn, TimeTzReturn
    // State means primitives plus Numeric*Val, StringArg, TimeTzADT,
    // Inteval
    // TableFunc means primitives plus Numeric*Val, StringReturn, TimeTzADT, Interval
    enum DataType
    {
        ArgType=0,
        ReturnType,
        State,
        TableFunc
    };
    static void readDatum(NzUdsFenced &sds, nz::udx::FuncDatum &datum , bool &null, int dataType=ArgType);

    static void sendDatum(NzUdsFenced &sds, int type, nz::udx::FuncDatum datum , bool null, int dataType);
    static void sendReturnInfo(NzUdsFenced &uds, int type, nz::udx::ReturnValue datum, bool null);

    nz::udx::FuncDatum makeReturnInfo(NzUdsFenced &uds);
    nz::udx::FuncDatum makeReturnInfoStored(int type);

    static nz::udx::ReturnValue makeReturnValue(NzUdsFenced &uds, nz::udx::FuncDatum datum, bool &null);
    
    void *m_data;
    void *m_extra;

    int size1;
    int size2;
};


#endif
