/*
 *  nzfencedexception.h
 *  Netezza Fenced Exception
 * (C) Copyright IBM Corp. 2009, 2011  All Rights Reserved.
 */

#ifndef __NZFENCEDEXCEPTION_H__
#define __NZFENCEDEXCEPTION_H__

#define MAX_ERROR_STR_LEN 300

#define NZFENCED_NORMAL_EXIT 0
#define NZFENCED_EXIT_WITH_ERROR_SENT 1
#define NZFENCED_EXIT_WITH_ERROR_UNSENT 2
#define NZFENCED_EXIT_STARTUP_ERROR 3
#define NZFENCED_EXIT_UNKNOWN_ERROR 4

struct CFencedException
{
    CFencedException(const char* strMsg, bool canBeSent);

    char m_Str[MAX_ERROR_STR_LEN];
    bool m_canBeSent;

    const char *str() const { return m_Str; }
    bool canBeSentToClient() {
        return m_canBeSent;
    }
};

extern void throwFencedError(const char* fmt, ...);
extern void throwSendableFencedError(const char* fmt, ...);

#endif
