/*
 *  nzfencedmethods.h
 *  Netezza Fenced Remote Execution Protocol
 *  command list for nz fenced API
 * (C) Copyright IBM Corp. 2009, 2014  All Rights Reserved.
 */

#ifndef __NZFENCEDMETHODS_H__
#define __NZFENCEDMETHODS_H__

enum NzFencedMethods
{
    NZFENCED_METHOD_INVALID = -1,         // invalid or missing command
    NZFENCED_METHOD_CHILD_INIT,           // invalid or missing command


    NZFENCED_METHOD_UDF_CONSTRUCTOR_V1,   // UDF Constructor V1
    NZFENCED_METHOD_UDF_DESTRUCTOR_V1,    // UDF Destructor V1
    NZFENCED_METHOD_UDF_EVALUATE_V1,      // UDF Evaluate V1
    NZFENCED_METHOD_UDF_CALCULATE_SIZE_V1,// UDF CalculateSize V1

    NZFENCED_METHOD_UDA_CONSTRUCTOR_V1,   // UDA Constructor V1
    NZFENCED_METHOD_UDA_DESTRUCTOR_V1,    // UDA Destructor V1
    NZFENCED_METHOD_UDA_INITIALIZE_V1,    // UDA Initialize State V1
    NZFENCED_METHOD_UDA_ACCUMULATE_V1,    // UDA Accumulate V1
    NZFENCED_METHOD_UDA_MERGE_V1,         // UDA Merge V1
    NZFENCED_METHOD_UDA_FINAL_V1,         // UDA Final Result V1

    NZFENCED_METHOD_UDF_CONSTRUCTOR_V2,   // UDF Constructor V2
    NZFENCED_METHOD_UDF_DESTRUCTOR_V2,    // UDF Destructor V2
    NZFENCED_METHOD_UDF_EVALUATE_V2,      // UDF Evaluate V2
    NZFENCED_METHOD_UDF_CALCULATE_SIZE_V2,// UDF CalculateSize V2
    NZFENCED_METHOD_UDF_PROVIDE_OPTIMIZER_INFO_V2,// UDF provideOptimizerInfo V2

    NZFENCED_METHOD_UDA_CONSTRUCTOR_V2,   // UDA Constructor V2
    NZFENCED_METHOD_UDA_DESTRUCTOR_V2,    // UDA Destructor V2
    NZFENCED_METHOD_UDA_INITIALIZE_V2,    // UDA Initialize State V2
    NZFENCED_METHOD_UDA_ACCUMULATE_V2,    // UDA Accumulate V2
    NZFENCED_METHOD_UDA_MERGE_V2,         // UDA Merge V2
    NZFENCED_METHOD_UDA_FINAL_V2,         // UDA Final Result V2
    NZFENCED_METHOD_UDA_PROVIDE_OPTIMIZER_INFO_V2,// UDA provideOptimizerInfo V2
    
    NZFENCED_METHOD_UDRF_CONSTRUCTOR_V2,  // UDRF Constructor V2
    NZFENCED_METHOD_UDRF_DESTRUCTOR_V2,   // UDRF Destructor V2
    NZFENCED_METHOD_UDRF_EVALUATE_V2,     // UDRF Evaluate V2

    NZFENCED_METHOD_UDTF_CONSTRUCTOR_V2,        // UDTF Constructor V2
    NZFENCED_METHOD_UDTF_DESTRUCTOR_V2,         // UDTF Destructor V2
    NZFENCED_METHOD_UDTF_NEXT_OUTPUT_ROW_V2,    // UDF Next Row V2
    NZFENCED_METHOD_UDTF_NEXT_EOI_OUTPUT_ROW_V2,// UDF Next Row V2
    NZFENCED_METHOD_UDTF_NEXT_EOP_OUTPUT_ROW_V2,// UDF Next Row V2
    NZFENCED_METHOD_UDTF_NEW_INPUT_ROW_V2,      // UDF New Input Row V2
    NZFENCED_METHOD_UDTF_NEW_INPUT_STREAM_V2,      // UDF New Input Row V2
    NZFENCED_METHOD_UDTF_NEW_INPUT_PARTITION_V2,      // UDF New Input Row V2
    NZFENCED_METHOD_UDTF_CALCULATE_SHAPE_V2,      // UDF  CalcuateShape V2
    NZFENCED_METHOD_UDTF_PROVIDE_OPTIMIZER_INFO_V2,// UDTF provideOptimizerInfo V2

    NZFENCED_METHOD_UDRA_CONSTRUCTOR_V2,  // UDRA Constructor V2
    NZFENCED_METHOD_UDRA_DESTRUCTOR_V2,   // UDRA Destructor V2
    NZFENCED_METHOD_UDRA_INITIALIZE_V2,   // UDRA Initialize State V2
    NZFENCED_METHOD_UDRA_ACCUMULATE_V2,   // UDRA Accumulate V2
    NZFENCED_METHOD_UDRA_MERGE_V2,        // UDRA Merge V2
    NZFENCED_METHOD_UDRA_FINAL_V2,        // UDRA Final Result V2

    NZFENCED_METHOD_UDX_SET_LOGMASK,      // UDX Set LogMask
    NZFENCED_METHOD_UDX_SET_MEMORY        // UDX Set Memory
    
};

#endif
