//!ALERT - no guard against multiple #include appearances, please!
// ____________________________________________________________________________
// ____________________________________________________________________________
//
// (C) Copyright IBM Corp. 2007, 2011  All Rights Reserved.
// ____________________________________________________________________________
//
// File:                nzpack_x86_off.h
//
// Description:
// ------------
// Contains compiler specific struct/union packing pragmas for those compilers
// we support.
//
// Design Notes:
// -------------
// Keep synchronized with nzpack_x86_on.h.
// ____________________________________________________________________________
// ____________________________________________________________________________
//
// Header files
//
// (none)
//
#ifdef __DCC__
#   if NZPACK_DCC == 4
// This functionality is provided on the DIAB/Nucleus command line
// with the -Xmember-max-align=4 option.  (Though it might be better
// to make the DIAB language #pragma work. But remember to unwind the
// throw patch in the DIAB C++ library if removing the
// -Xmember-max-align).
#   else
#       error "nzpack_x86_off.h included without matching nzpack_x86_on.h (__DCC__)"
#   endif
#   undef NZPACK_DCC
#elif _WIN32
#   if NZPACK_WIN32 == 4
// The following line seems to have single file scope -- not rest-of-compilation scope
#       pragma warning( disable : 4103 ) 
#       pragma pack ()   // Note MS help doc's are incorrect
#   else
#       error "nzpack_x86_off.h included without matching nzpack_x86_on.h (_WIN32)"
#   endif
#   undef NZPACK_WIN32
#elif __GNUC__
#   if NZPACK_GNUC == 4
#       pragma pack ()
#   else
#       error "nzpack_x86_off.h included without matching nzpack_x86_on.h (__GNUC__)"
#   endif
#   undef NZPACK_GNUC
#else
#   error "Ending x86 pack structs not yet defined for this compiler"
#endif
// ____________________________________________________________________________
//
