//!ALERT - no guard against multiple #include appearances, please!
// ____________________________________________________________________________
// ____________________________________________________________________________
//
// (C) Copyright IBM Corp. 2007, 2011  All Rights Reserved.
// ____________________________________________________________________________
//
// File:                nzpack_x86_on.h
//
// Description:
// ------------
// Contains compiler specific struct/union packing pragmas for those compilers
// we support.
//
// Design Notes:
// -------------
// Keep synchronized with nzpack_x86_off.h.
// ____________________________________________________________________________
// ____________________________________________________________________________
//
// Header files
//
// (none)
//
#ifdef __DCC__
#  ifdef NZPACK_DCC
#    error "nzpack_x86_on: diagnosing attempt to nest this file"
#  endif
#  define NZPACK_DCC 4
// This functionality is provided on the DIAB/Nucleus command line
// with the -Xmember-max-align=4 option.  (Though it might be better
// to make the DIAB language #pragma work. But remember to unwind the
// throw patch in the DIAB C++ library if removing the
// -Xmember-max-align).
#elif _WIN32
#  ifdef NZPACK_WIN32
#    error "nzpack_x86_on: diagnosing attempt to nest this file"
#  endif
// The following line seems to have single file scope -- not rest-of-compilation scope
#  pragma warning( disable : 4103 ) 
#  define NZPACK_WIN32 4
#  pragma pack (4)
#elif __GNUC__
#  ifdef NZPACK_GNUC
#    error "nzpack_x86_on: diagnosing attempt to nest this file"
#  endif
#  define NZPACK_GNUC 4
#  pragma pack (4)
#else
#  error "x86 pack struct not yet defined for this compiler"
#endif
// ____________________________________________________________________________
//
