/*
 *  nzrepcommands.h
 *  Netezza Remote Execution Protocol
 *  command list for nzrep API
 * (C) Copyright IBM Corp. 2008, 2011  All Rights Reserved.
 */

#ifndef __NZREPCOMMANDS_H__
#define __NZREPCOMMANDS_H__

typedef enum NzrepCommands
{
    NZREP_INVALID = -1, // invalid or missing command
    NZREP_CANCEL, // cancel the current operation
    NZREP_DATA, // contains one item of binary data of specified length
    NZREP_DONE, // operation complate, no more data will be requested, do not send any more data
    NZREP_END, // end of data, there is no more data to send
    NZREP_ERROR, // implies done, contains binary error information of specified length
    NZREP_PING, // sender still alive, listen for another command
    NZREP_REQUEST, // requests exactly one item of data
    NZREP_LOG, // log message, contains character log message of specified length
    NZREP_METADATA, // contains one item of binary metadata of specified length
    NZREP_PARTITION_END, // end of partion
    NZREP_DATA_BLOCK, // one or more data items
    NZREP_DATA_BLOCK_END_OF_INPUT, // one or more data items followed by EOI
    NZREP_DATA_BLOCK_END_OF_PARTITION, // one or more data items followed by EOP
    NZREP_DATA_BLOCK_DONE, // one or more data items followed by DONE
    NZREP_MAX_COMMAND_VALUE // all command numeric values less than this value
} NzrepCommands;

#endif
