/*
 *  nzsdsfenced.h
 *  Netezza C++ wrapper for nzsds
 * (C) Copyright IBM Corp. 2009, 2011  All Rights Reserved.
 */

#ifndef __NZSDSFENCED_H__
#define __NZSDSFENCED_H__

extern "C" {
#include "nzsds.h"
}


class NzSdsFenced
{
public:
    NzSdsFenced();
    NzSdsFenced(const NzsdsBuffer & arg);
    ~NzSdsFenced();

    void setData(const NzsdsBuffer & arg);
    void setDataNoCopy(const NzsdsBuffer & arg);

    void write(int8_t data);
    void write(const int8_t * data, int numElements);
    void write(int16_t data);
    void write(const int16_t * data, int numElements);
    void write(int32_t data);
    void write(const int32_t * data, int numElements);
    void write(int64_t data);
    void write(const int64_t * data, int numElements);
    void write(float data);
    void write(const float * data, int numElements);
    void write(double data);
    void write(const double * data, int numElements);
    void write(const char* data, int numelements);


    int8_t readInt8();
    const int8_t* readInt8(int &numelements);
    int16_t readInt16();
    const int16_t* readInt16(int &numelements);
    int32_t readInt32();
    const int32_t* readInt32(int &numelements);
    int64_t readInt64();
    const int64_t* readInt64(int &numelements);
    float readFloat();
    const float* readFloat(int &numelements);
    double readDouble();
    const double* readDouble(int &numelements);
    const char* readString(int &numelements);

    void getBuffer(NzsdsBuffer &buffer);
    void getBufferCompressed(NzsdsBuffer &buffer);
    void readNext(NzsdsData &data);
    int numElements();
    void setReadPosition(int pos);
    void shrinkTo(int num);
    
private:
    NZSDS_HANDLE m_handle;
};

#endif
