#ifndef NZSHMALLOC_INCLUDED
#define NZSHMALLOC_INCLUDED

#ifndef NZMEMORY_INCLUDED
# include "memInterface.h"
#endif

#if defined(__DCC__)
# include <alloc>
#elif defined(__GNUC__)
# if (__GNUC__ > 3) || ((__GNUC__ == 3) && (__GNUC_MINOR__ >= 3))
#  ifndef RCSTLALLOCADAPTOR_INCLUDED
#   include "rcStlAllocAdaptor.h"
#  endif
# elif ((__GNUC__ == 3) && (__GNUC_MINOR__ >= 2))
#  include <bits/stl_alloc.h>
# else
#  include <alloc.h>
# endif
  using namespace std;
#endif

template<typename T, int mt>
struct NzShmAlloc
{
#if (__GNUC__ > 3) || ((__GNUC__ == 3) && (__GNUC_MINOR__ >= 3))
    typedef rc::StlAllocAdaptor<T, NzShmAlloc<T, mt> > stl_alloc;
    typedef allocator<void>::const_pointer const_ptr;
    typedef allocator<void>::pointer ptr;
#else
    typedef __allocator<void, NzShmAlloc<T, mt> > stl_alloc;
    typedef const void * const_ptr;
    typedef void * ptr;
#endif

    static void *allocate (size_t nbytes, const_ptr hint = 0)
    {
        /* NOTE - NzShmAlloc exposes a SGI - allocator style interface
         * which mandates the size to be specified in bytes and not
         * as number of elements of type 'T'. We used to be doing that
         * and were always allocating more memory than required.
         *
         * Both rc::StlAllocAdaptor<> and __allocator<> (we used to
         * use this in pre GCC3.2 days; no longer used!) pass
         * n * sizeof (T) as the first parameter to this method. So
         * we simply relay it onto the memory allocator
         *
         * - ask
         */
        return mem::allocBlock(nbytes, mem::AllocContext(static_cast<memType_t> (mt)));
    }

    static void deallocate (ptr p, size_t n)
    {
        mem::freeBlock(p);
    }

    bool operator== (const NzShmAlloc<T, mt> &other) const
    {
        return true;
    }

    template <typename U, int other_mt>
    bool operator== (const NzShmAlloc<U, other_mt> &other) const
    {
        return false;
    }

    bool operator!= (const NzShmAlloc<T, mt> &other) const
    {
        return false;
    }

    template <typename U, int other_mt>
    bool operator!= (const NzShmAlloc<U, other_mt> &other) const
    {
        return true;
    }

};

#endif
