#ifndef PMSCANLISTDEFS_INCLUDE
#define PMSCANLISTDEFS_INCLUDE
/// @file pmScanListDefs.h
/// @brief Scan list definitions
//////////////////////////////////////////////////////////////////////
/// Copyright (c) 2010 Netezza Corporation. All rights reserved.
//////////////////////////////////////////////////////////////////////
/// These enumerations are factored out so they can be generally included by DPM
/// without exposing the rest of the scan list stuff.
//////////////////////////////////////////////////////////////////////

#include <stdint.h>

namespace pm {

/// Make these types common across partition managers
/// TODO: are these the right names?

typedef uint64_t RawSid;
typedef unsigned PageNo;

/// Possible states for a table connection's scan list
enum SLState
{
    slsNone = 0,    ///< Connection has no scan list object
    slsInclude,     ///< Connection has a list object allowing includes
    slsExclude,     ///< Connection has a list object allowing excludes
    slsScan         ///< Connection has a list object allowing true scans
};

/// A SLScanInit value describes the desired page states and their relative ordering.
enum SLScanInit
{
    slsiAll,
    slsiDoneRedoNew,
    slsiRedoNew,
    slsiDoneRedo,
    slsiNew
};

}; // namespace pm

#endif // PMSCANLISTDEFS_INCLUDE
