/*
 * Copyright 2014 IBM Corporation.
 */

#ifndef PROJECTSPECIALS_INCLUDED
#define PROJECTSPECIALS_INCLUDED

#define PROJECT_EXPR        ( -1) // PG expr evaluator computed expression
#define PROJECT_ROWADDR     ( -2) // used to place rowAddrs in projected field
#define PROJECT_ROWNUM      ( -3) // used to place rowNums in projected field
#define PROJECT_HASH        ( -4) // used to project in a hash column
#define PROJECT_BYTE        ( -5) // !NOTE-bmz need more consisteny scheme!
#define PROJECT_COMPUTE     ( -6) // fsm based computed expression
#define PROJECT_SPUID       ( -7) // place spu id in projected field
#define PROJECT_CREATETXN   ( -8) // place created txn id in projected field
#define PROJECT_DELETETXN   ( -9) // place deleted txn id in projected field
//!TODO: PROJECT_BLOCKNUM has been superseded by PROJECT_PAGEID and is no longer used,
// should be removed from all code that checks for it.
#define PROJECT_BLOCKNUM    (-10) // used to project rowAddr's blocknum
#define PROJECT_DTIDBITADDR (-11) // put deleted txn id's bit address in proj fld
                                  // adjust following to track the lowest
                                  // project special value.
#define PROJECT_PAGEID      (-12)
#define PROJECT_EXTENTID    (-13)

#define PROJECT_ENDOFPARTITION (-14)
#define PROJECT_DEPENDENTMULTICOLEXPR (-15) // a column produced by a multi-col case expression,
                                            // but not the first one (which uses PROJECT_EXPR).

#define PROJECT_LOWEST_NUM PROJECT_DEPENDENTMULTICOLEXPR


enum { PROJECTS_SOURCED_AT_SCAN =
     ( 1 << -PROJECT_ROWADDR    ) |
     ( 1 << -PROJECT_ROWNUM     ) |
     ( 1 << -PROJECT_SPUID      ) |
     ( 1 << -PROJECT_CREATETXN  ) |
     ( 1 << -PROJECT_DELETETXN  ) |
//     ( 1 << -PROJECT_BLOCKNUM   ) |
     ( 1 << -PROJECT_DTIDBITADDR) |
     ( 1 << -PROJECT_PAGEID     ) |
     ( 1 << -PROJECT_EXTENTID   ) |
     0 };

inline
bool projectSourcedAtScan(int dex)
{
    return dex >= 0 ? true : PROJECTS_SOURCED_AT_SCAN & (1 << -dex);
}

#endif
