#ifndef RCBARRIER_INCLUDED
#define RCBARRIER_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

// compiler-only barier
#if defined(__DCC__)
inline asm volatile void BARRIER() {
%
}
#elif defined(__GNUC__)
# define BARRIER() asm volatile("": : :"memory")
#else
# if !defined(_WIN32)
#  warning "compiler barrier not defined for this compiler"
# endif
# define BARRIER()  do { } while (0)
#endif

// pick up processor specific definitions
#if defined(__PPC__)
# include "ppc_barrier.h"
#elif defined(__i386__) || defined(__x86_64__)
# include "i386_barrier.h"
#else
# if !defined(_WIN32)
#  warning "missing SMP barrier definitions for this architecture"
# endif
# define SMP_RMB() BARRIER()
# define SMP_WMB() BARRIER()
# define SMP_MB()  BARRIER()
#endif

#ifdef __cplusplus
}
#endif

#endif
