#ifndef SCHISTDATAENUMS_INCLUDED
#define SCHISTDATAENUMS_INCLUDED

#ifdef __cplusplus
extern "C"  {
#endif

typedef enum QueryStatusType {
    QUERY_EXECUTION_SUCCESS   =  0,
    QUERY_ABORTED             = -1,
    QUERY_CANCELLED           = -2,
    QUERY_FAILED_PARSING      = -3,
    QUERY_FAILED_REWRITE      = -4,
    QUERY_FAILED_PLANNING     = -5,
    QUERY_FAILED_EXECUTION    = -6,
    QUERY_FAILED_ACLCHECK     = -7,
    QUERY_FAILED_GENERIC      = -8,
    QUERY_TRANSACTION_ABORTED = -9,

    /* Should always be Last */
    NQUERY_STATUS = 10
} EQueryStatus;
/* Should be kept in sync with any changes to EQueryStatus */
extern const char *QueryStatusStrings[NQUERY_STATUS];

typedef enum PlanStatusType {
    PLAN_EXECUTION_SUCCESS =  0,
    PLAN_ABORTED           = -1,

    /* Should always be Last */
    NPLAN_STATUS = 2
} EPlanStatus;
/* Should be kept in sync with any changes to EPlanStatus */
extern const char *PlanStatusStrings[NPLAN_STATUS];

#ifdef __cplusplus
} // extern "C"
#endif

#endif // SCHISTDATAENUMS_INCLUDED
