#ifndef SPARSE_BITMAP_INCLUDED
#define SPARSE_BITMAP_INCLUDED

#include "sdlist.h"

struct sparse_bitmap
{
    static const unsigned int npos = (unsigned int) -1;
    dlink_t m_ranges;
};

inline static void
sparse_bitmap_init(sparse_bitmap *bmp)
{
    LIST_INIT(&bmp->m_ranges);
}

extern void sparse_bitmap_free(sparse_bitmap *bmp);
extern void sparse_bitmap_reset(sparse_bitmap *bmp);
extern bool sparse_bitmap_set_bit(sparse_bitmap *bmp, unsigned int pos);
extern bool sparse_bitmap_clear_bit(sparse_bitmap *bmp, unsigned int pos);
extern bool sparse_bitmap_test_bit(const sparse_bitmap *bmp, unsigned int pos);
extern unsigned int sparse_bitmap_first_pos(const sparse_bitmap *bmp);
extern unsigned int sparse_bitmap_last_pos(const sparse_bitmap *bmp);
extern unsigned int sparse_bitmap_next_pos(const sparse_bitmap *bmp, unsigned int pos);
extern unsigned int sparse_bitmap_size(const sparse_bitmap *bmp);

#endif
