#ifndef TASKXTNS_INCLUDED
#define TASKXTNS_INCLUDED

#ifndef ERROR_INCLUDED
# include "error.h"
#endif

#ifndef RCATOMIC_INCLUDED
# include "rcAtomic.h"
#endif

#ifndef RCPGMATTRS_INCLUDED
# include "rcPgmAttrs.h"
#endif

class CPlan;
struct job_dslice_t;
class SpuJob;

namespace hc {
  class HwThread;
}

#define MAX_TLS_INDEXES 16

// struct TaskXtns enhances the basic Nucleus task structure with
// Netezza appendages.

struct TaskXtns
{
    CPlan *x_plan;
    job_dslice_t *x_job_dslice;
    SpuJob *x_job;

    void *tls_array[MAX_TLS_INDEXES];

    hc::HwThread *x_hwthread; // HwThread task attributes

    CError thrown_cerror;   // local copy of thrown error, for core dumper
    int thrown_error_type;  // 1=CError 2=rc::Err 3=rc::IntnlErr
    void *thrown_error;     // pointer to the thrown error
};

#endif
