#ifndef UDX_CONTEXT_INCLUDED
#define UDX_CONTEXT_INCLUDED

#include <sys/types.h>


struct ChildRsUsage
{
    unsigned long long m_cpu_us;
    unsigned long m_mem_hwm;
};

extern int registerWLMProcess(pid_t pid, int udxType, void *udxObject);
extern void unregisterWLMProcess(int wlmCookie, pid_t pid, 
                                 struct ChildRsUsage * cru );


#ifdef  __cplusplus
extern "C" {
#endif

typedef void (plan_cleanup_func_t)(const void *, size_t);

extern void *NzRegisterPlanCleanupFunc(const void *cb_data,
                                       size_t cb_data_len,
                                       plan_cleanup_func_t *callback,
                                       int *error);

extern void NzUnregisterPlanCleanupFunc(void *cookie);

#ifdef  __cplusplus
}
#endif

#endif
