// udxrfunc.h
// Row Function class for User Defined Functions and Aggregates
//
// (C) Copyright IBM Corp. 2009, 2011  All Rights Reserved.

#ifndef UDX_RFUNC_INCLUDED
#define UDX_RFUNC_INCLUDED

#ifndef VARHDRSZ
#define VARHDRSZ 16
#endif

                          
namespace nz {  
namespace udx_ver2 {


class Udrf : public UdxNonScalarBase
{
public:
	Udrf(UdxInit *pInit) : UdxNonScalarBase(pInit) {} 	
	virtual ~Udrf() {}

	// Interface methods
	virtual void evaluate() = 0;
	
	// The derived class must have a static method like such:
	// static Udrf* instantiate(UdxInit *pInit);

	// Called from engine
	void performEvaluate(RowFuncCallInfo *pFcInfo)
	  {
	    
	    m_pInfo = pFcInfo;
	    evaluate();
	    m_pInfo = NULL;
	    
	  }

};
  
} // end namespace udx_ver2
} // end namespace nz

#endif //  #ifndef UDX_RFUNC_INCLUDED
