
#include "unicode/ucnv_err.h"
#include "unicode/ucnv_cb.h"

/**
 * This is a modified version of ICU's UCNV_FROM_U_CALLBACK_SUBSTITUTE
 * it unconditionally substitutes on irregular codepoints.
 * I'm keeping the original ICU code in place for comparison.
 *
 * Usage:
 *   ucnv_setFromUCallBack(c, UCNV_FROM_U_CALLBACK_SUBSTITUTE_ALWAYS, NULL, NULL, NULL, &status);
 *
 * srloomis@us.ibm.com 12/20/2016
 */
U_CAPI void    U_EXPORT2
UCNV_FROM_U_CALLBACK_SUBSTITUTE_ALWAYS (
				 const void *context,
				 UConverterFromUnicodeArgs *fromArgs,
				 const UChar* codeUnits,
				 int32_t length,
				 UChar32 codePoint,
				 UConverterCallbackReason reason,
				 UErrorCode * err)
{
  (void)codeUnits;
  (void)length;
  if (reason <= UCNV_IRREGULAR)
    {
      if (FALSE /* && reason == UCNV_UNASSIGNED && IS_DEFAULT_IGNORABLE_CODE_POINT(codePoint)*/)
        {
	  /*                                                                                                                                                   
	   * Skip if the codepoint has unicode property of default ignorable.                                                                                  
	   */
	  *err = U_ZERO_ERROR;
        }
      else /* if (context == NULL || (*((char*)context) == UCNV_PRV_STOP_ON_ILLEGAL && reason == UCNV_UNASSIGNED)) */
        {
	  *err = U_ZERO_ERROR;
	  ucnv_cbFromUWriteSub(fromArgs, 0, err);
        }
      /* else the caller must have set the error code accordingly. */
    }
  /* else ignore the reset, close and clone calls. */
}
