#ifndef XPCREATETEMP_INCLUDED
#define XPCREATETEMP_INCLUDED

#include "nodecommon.h"

struct TCreateTempTableMsg; /* nzcomm.h */
class CPlan;

/* Prep snippet create transient/temp table operation */

class TCreateTempTableNodeDef {
protected:
    TDownloadTableNode  * m_pDown;
};

class TCreateTempTableNodeRuntimeInfo {
protected:
    TCreateTempTableMsg * m_pCreateMsg;
    int                   m_msgSize;
};

class TCreateTempTableNode : public SnippetNode,
    private TCreateTempTableNodeDef, private TCreateTempTableNodeRuntimeInfo {
public:
    TableShape const * Init(TableShape const * src, EPlanNodeLocus place);
    virtual ~TCreateTempTableNode() { /* nothing to do here */ }

    // Accessors
    inline TCreateTempTableMsg* CreateMsg() const { return m_pCreateMsg; }
    inline int                  MsgSize()   const { return m_msgSize; }
    inline TDownloadTableNode*  Down()      const { return m_pDown; }

    // Setters
    inline void SetCreateMsg( TCreateTempTableMsg* val ) { m_pCreateMsg = val; }
    inline void SetMsgSize( int val )                    { m_msgSize = val; }
    inline void SetDown( TDownloadTableNode* val )       { m_pDown = val; }
};

extern "C" void gencCreateTempTable(CPlan *plan, TCreateTempTableNode* node);

#endif // !XPCREATETEMP_INCLUDED
