#ifndef XPDROP_INCLUDED
#define XPDROP_INCLUDED

#include "nodecommon.h"

class TDropTableNodeDef {
protected:
    int m_dropTableId;  // temp table to drop
    //The Savetemp case may use m_dropTableId to access the table when m_toDrop is null, the code avoids this by setting m_dropTableId to 0 at certain times, but we need this value for dumpSnippetStatsToPlanFile, so we'll cache the last non-zero set
    int m_lastNonZeroDropTableId;
};

class TDropTableNodeRuntimeInfo {
protected:
    CTable *m_toDrop;   // from linkId
};

class TDropTableNode : public SnippetNode,
    private TDropTableNodeDef, private TDropTableNodeRuntimeInfo {
public:
    TDropTableNode();
    virtual ~TDropTableNode();
    
    TableShape const * Init(TableShape const * src, EPlanNodeLocus place);
// dlm-check    virtual ~TDropTableNode() { /* nothing to do here */ }

    bool IsValidForSrc() { return true; }
    bool Serialize  ( CCommBuf * cbuf, ESerializeMode mode );
    void Deserialize( CCommBuf const * cbuf, ESerializeMode mode );

    // Accessors
    inline int     DropTableId() const { return m_dropTableId; }
    inline int     LastNonZeroDropTableId() const {return m_lastNonZeroDropTableId; }
    inline CTable* ToDrop() const { return m_toDrop; }

    // Setters
    inline void SetDropTableId( int id ) 
    { 
      m_dropTableId = id; 
      if(id != 0) {
        m_lastNonZeroDropTableId = id;
      }
    }
    inline void SetToDrop( CTable* tbl ) { m_toDrop = tbl; }

};

#endif // !XPDROP_INCLUDED

