#ifndef XPGROOMSTATS_INCLUDED
#define XPGROOMSTATS_INCLUDED


/****************************************************************/
/* FOR CLIENT+DBOS+SPU */
/****************************************************************/

#include "groomcgen.h"

class CCommBuf;
class CPlan;
class CTable;

/** Common ancesstor for TReorgStatsClntNode - fix-dle: leave only GroomStats node  */
class TGroomStatsClntNode: public GroomNodeBase {
public:
    /** Result/return table fields */
    enum {
        DSID,
        EOT,
        SCANNED_PAGES,
        EMPTIED_PAGES,
        ACQUIRED_PAGES,      // RECLAIMED_PAGES = EMPTIED_PAGES - ACQUIRED_PAGES
        FREED_EXTENTS,
        ALLOCATED_EXTENTS,   // RECLAIMED_EXTENTS = FREED_EXTENTS - ALLOCATED_EXTENTS
        INPUT_RECORDS,
        OUTPUT_RECORDS,      // RECLAIMED_RECORDS = INPUT_RECORDS - OUTPUT_RECORDS
        SCANNABLE_PAGES_NEW,
        SCANNABLE_PAGES_REDO,
        SCANNABLE_PAGES_DONE,
        MAX_RECLAIMED_XID,
        REORG_STATS_FIELD_CNT // field counter, must be last 
    };
public:
    TGroomStatsClntNode(int64 groomId) {m_groomId = groomId; m_step = 0; }

    int64 GroomId() const {return m_groomId;}
    int Step() const {return m_step;}
    void Step(int step) { m_step = step; }

protected:

    TGroomStatsClntNode() { m_groomId = 0; m_step = 0; } // For derived classes constructors from CCommBuf
protected:
    int64 m_groomId; // Groom operation id
    int m_step;      // Step number withing this groom operation
    
};


/****************************************************************/
/* end FOR CLIENT+DBOS+SPU */
/****************************************************************/

#endif // XPGROOMSTATS_INCLUDED 
