#ifndef XPLIMIT_INCLUDED
#define XPLIMIT_INCLUDED

#include "nodecommon.h"

#define LIMIT_NO_LIMIT -1   // no-limit value

class TLimitNodeDef {
protected:
    int64 limit;    // max # rows
    int64 offset;   // limit beginning from row #
};

class TLimitNodeRuntimeInfo {
protected:
    // none at this time
};

class TLimitNode : public SnippetNode, 
    private TLimitNodeDef, private TLimitNodeRuntimeInfo {
public:
    TableShape const * Init(TableShape const * src, EPlanNodeLocus place);
    virtual ~TLimitNode() { /* nothing to do here */ }

    bool IsValidForSrc() { return true; }
    bool Serialize( CCommBuf * cbuf, ESerializeMode mode );
    void Deserialize( CCommBuf const * cbuf, ESerializeMode mode );

    // Accessors
    inline int64 Limit()  const { return limit; }
    inline int64 Offset() const { return offset; }

    // Mutators
    inline int64 PostDecOffset()        { return offset--; }
    inline int64 PreDecLimit()          { return --limit; }

    // Setters
    inline void  SetLimit( int64 lim )  { limit = lim; }
    inline void  SetOffset( int64 off ) { offset = off; }

};

#endif // !XPLIMIT_INCLUDED

