#ifndef XPSCANCOUNT_INCLUDED
#define XPSCANCOUNT_INCLUDED

#include "nodecommon.h"

class TScanNode;

/* Count of scan reading to account for zone map effects */

class TScanBlockCountNodeDef {
protected:
    bool m_bGetSize;
};

class TScanBlockCountNodeRuntimeInfo {
protected:
    TScanNode* m_scanNode;
};

class TScanBlockCountNode : public SnippetNode,
    private TScanBlockCountNodeDef, private TScanBlockCountNodeRuntimeInfo {
public:
    TableShape const * Init(TableShape const * src, EPlanNodeLocus calledFrom);
    virtual ~TScanBlockCountNode() { /* nothing to do here */ }

    // Accessors
    inline bool       GetSize()  const { return m_bGetSize; }
    inline TScanNode* ScanNode()       { return m_scanNode; }

    // Setters
    inline void SetGetSize( bool val )        { m_bGetSize = val; }
    inline void SetScanNode( TScanNode* val ) { m_scanNode = val; }
    
};

#endif // !XPSCANCOUNT_INCLUDED
