#ifndef INCLUDED_SORTEDAGGR
#define INCLUDED_SORTEDAGGR

#include "xpaggregate.h"
#include "inodecgen.h"

#include "error.h"  // for NZ_VERIFY

class CCommBuf;

class TSortedAggregateClntNode: public CGenBase 
{
    const TableShape* Init( const TableShape* src, EPlanNodeLocus place ) { NZ_VERIFY( false ); } // dummy to make this class concrete
public:

    TSortedAggregateClntNode( CPlan * plan,
                          EPlanNodeLocus place,
                          int numAggrs,
                          TAggrField *aggrs,
                          int numGroups,
                          int *groupingList,
                          int numOrderCols,
                          int *orderColList,
                          int *ascendingList,
                          int *nullsLoList );

   void Dump( int detail, int indent);
   virtual ~TSortedAggregateClntNode();
   friend void Serialize( CCommBuf * cbuf, TSortedAggregateClntNode *node);

protected:
    TSortedAggregateClntNode( CPlan *plan, EPlanNodeLocus place);
    void initNode(
               CPlan * plan,
               EPlanNodeLocus place,
               int numAggrs,            // number of aggregates
               TAggrField *aggrs, // list of agrregates
               int numGroups,    // number of group-by columns
               int *groupingList,   // list of group-by columns
               int numOrderCols,        // number of order columns
               int *orderColList,      // list of order columns
               int *ascendingList,      // list of order direction flags
               int *nullsLoList      // list of order direction flags
            );

    int m_numGroups;
    int *m_groupingList ; //group by fields;
    int  m_numAggrs;
    TAggrField *m_aggrs; //aggregates evaluated by this sortedaggr
    int  m_numOrderCols;
    int *m_ordercolsList;// to force ordering of aggr-result by grouping fields
    int *m_ascendingList;// asc/desc flags for ordercolsList
    int *m_nullsLoList;// null 

};

#endif
