#ifndef XPSTREAMAPPEND_INCLUDED
#define XPSTREAMAPPEND_INCLUDED

#include "inodecgen.h"

#include "error.h"  // for NZ_VERIFY

class CCommBuf;
 
//
//  Appends records from stream and temp table.
//  The shape of the stream and temp table should be identical 
//
class TStreamAppendClntNode:public CGenBase {
    const TableShape* Init( const TableShape* src, EPlanNodeLocus place ) { NZ_VERIFY( false ); } // dummy to make this class concrete
public:
    TStreamAppendClntNode(CPlan * plan, 
                          EPlanNodeLocus place, 
                          int tblid);
    void Dump( int detail, int indent);
    virtual ~TStreamAppendClntNode();
    friend void Serialize(CCommBuf * cbuf, TStreamAppendClntNode *node);
    int Tblid() { return m_tblId; };
    
protected:
    int m_tblId;          // already existant temp table
};
#endif // !XPSTREAMAPPEND_INCLUDED
